2017-08-01  Michal Privoznik  <mprivozn@redhat.com>

	virNetDaemonCallInhibit: Call virNetDaemonGotInhibitReply properly
	So there are couple of issues here. Firstly, we never unref the
	@pendingReply and thus it leaks.

	==13279== 144 (72 direct, 72 indirect) bytes in 1 blocks are definitely lost in loss record 1,095 of 1,259
	==13279==    at 0x4C2E080: calloc (vg_replace_malloc.c:711)
	==13279==    by 0x781FA97: _dbus_pending_call_new_unlocked (in /usr/lib64/libdbus-1.so.3.14.11)
	==13279==    by 0x7812A4C: dbus_connection_send_with_reply (in /usr/lib64/libdbus-1.so.3.14.11)
	==13279==    by 0x56BEDF3: virNetDaemonCallInhibit (virnetdaemon.c:514)
	==13279==    by 0x56BEF18: virNetDaemonAddShutdownInhibition (virnetdaemon.c:536)
	==13279==    by 0x12473B: daemonInhibitCallback (libvirtd.c:742)
	==13279==    by 0x1249BD: daemonRunStateInit (libvirtd.c:823)
	==13279==    by 0x554FBCF: virThreadHelper (virthread.c:206)
	==13279==    by 0x8F913D3: start_thread (in /lib64/libpthread-2.23.so)
	==13279==    by 0x928DE3C: clone (in /lib64/libc-2.23.so)

	Secondly, while we send the message, we are suspended ('cos we're
	talking to a UNIX socket).  However, until we are resumed back
	again the reply might have came therefore subsequent
	dbus_pending_call_set_notify() has no effect and in fact the
	virNetDaemonGotInhibitReply() callback is never called. Thirdly,
	the dbus_connection_send_with_reply() has really stupid policy
	for return values. To cite the man page:

	  Returns
	      FALSE if no memory, TRUE otherwise.

	Yes, that's right. If anything goes wrong and it's not case of
	OOM then TRUE is returned, i.e. you're trying to pass FDs and
	it's not supported, or you're not connected, or anything else.
	Therefore, checking for return value of
	dbus_connection_send_with_reply() is not enoguh. We also have to
	check if @pendingReply is not NULL before proceeding any further.

2017-08-01  Michal Privoznik  <mprivozn@redhat.com>

	virCgroupValidateMachineGroup: Don't free @machinename
	We are given a string in @machinename, we never allocate it, just
	merely use it for reading. We should not free it otherwise it
	leads to double free:

	==32191== Thread 17:
	==32191== Invalid free() / delete / delete[] / realloc()
	==32191==    at 0x4C2D1A0: free (vg_replace_malloc.c:530)
	==32191==    by 0x54BBB84: virFree (viralloc.c:582)
	==32191==    by 0x2BC04499: qemuProcessStop (qemu_process.c:6313)
	==32191==    by 0x2BC500FF: processMonitorEOFEvent (qemu_driver.c:4724)
	==32191==    by 0x2BC502FC: qemuProcessEventHandler (qemu_driver.c:4769)
	==32191==    by 0x5550640: virThreadPoolWorker (virthreadpool.c:167)
	==32191==    by 0x554FBCF: virThreadHelper (virthread.c:206)
	==32191==    by 0x8F913D3: start_thread (in /lib64/libpthread-2.23.so)
	==32191==    by 0x928DE3C: clone (in /lib64/libc-2.23.so)
	==32191==  Address 0x31893d70 is 0 bytes inside a block of size 1,100 free'd
	==32191==    at 0x4C2D1A0: free (vg_replace_malloc.c:530)
	==32191==    by 0x54BBB84: virFree (viralloc.c:582)
	==32191==    by 0x54C1936: virCgroupValidateMachineGroup (vircgroup.c:343)
	==32191==    by 0x54C4B29: virCgroupNewDetectMachine (vircgroup.c:1550)
	==32191==    by 0x2BBDDA29: qemuConnectCgroup (qemu_cgroup.c:972)
	==32191==    by 0x2BC05DA7: qemuProcessReconnect (qemu_process.c:6822)
	==32191==    by 0x554FBCF: virThreadHelper (virthread.c:206)
	==32191==    by 0x8F913D3: start_thread (in /lib64/libpthread-2.23.so)
	==32191==    by 0x928DE3C: clone (in /lib64/libc-2.23.so)
	==32191==  Block was alloc'd at
	==32191==    at 0x4C2BE80: malloc (vg_replace_malloc.c:298)
	==32191==    by 0x4C2E35F: realloc (vg_replace_malloc.c:785)
	==32191==    by 0x54BB492: virReallocN (viralloc.c:245)
	==32191==    by 0x54BEDF2: virBufferGrow (virbuffer.c:150)
	==32191==    by 0x54BF3B9: virBufferVasprintf (virbuffer.c:408)
	==32191==    by 0x54BF324: virBufferAsprintf (virbuffer.c:381)
	==32191==    by 0x55BB271: virDomainGenerateMachineName (domain_conf.c:27078)
	==32191==    by 0x2BBD5B8F: qemuDomainGetMachineName (qemu_domain.c:9595)
	==32191==    by 0x2BBDD9B4: qemuConnectCgroup (qemu_cgroup.c:966)
	==32191==    by 0x2BC05DA7: qemuProcessReconnect (qemu_process.c:6822)
	==32191==    by 0x554FBCF: virThreadHelper (virthread.c:206)
	==32191==    by 0x8F913D3: start_thread (in /lib64/libpthread-2.23.so)

	Moreover, make the @machinename 'const char *' to mark it
	explicitly that we are not changing the passed string.

2017-08-01  Andrea Bolognani  <abologna@redhat.com>

	news: Fix typo

2017-07-31  Michal Privoznik  <mprivozn@redhat.com>

	news: Update for 3.6.0 release
	I was volunteered to prepare the release notes.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-28  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Old and empty test case for node name detection
	Prior to qemu 2.5 the node names would not be generated, thus would be
	missing from 'query-blockstats' and 'query-named-block-nodes'. Test that
	the code correctly detects nothing.

	Additionally make sure that a VM without disks does not cause problems.

	The test case change is necessary as our test file checker does not play
	well with empty files.

2017-07-28  Peter Krempa  <pkrempa@redhat.com>

	tests: utils: Allow NULL strings to be equal to empty file in virTestCompareToFile
	Treat an NULL string equivalent to an empty string in
	virTestCompareToFile so that callers don't need to add additional logic
	in case when a test produces no output.

	tests: Run virdrivermoduletest only when WITH_LIBVIRTD is defined
	The test makes sense only when building the daemon, thus run it only in
	such case.

	tests: Run virt-aa-helper-test only when the helper was compiled
	'virt-aa-helper' is compiled when both WITH_LIBVIRTD and
	WITH_SECDRIVER_APPARMOR are defined. The test was run only when
	WITH_SECDRIVER_APPARMOR was defined thus causing a build failure when
	building without the daemon.

2017-07-28  Martin Kletzander  <mkletzan@redhat.com>

	docs: Format comment timestamp in UTC
	I just forgot '-u' in a54c9622860a.

2017-07-28  Erik Skultety  <eskultet@redhat.com>

	nodedev: Fix double unlock of the driver on udevEnumerateDevices failure
	Commit @4cb719b2dc moved the driver locks around since these have become
	unnecessary at spots where the code handles now self-lockable object
	list, but missed the possible double unlock if udevEnumerateDevices
	fails, because at that point the driver lock had been already dropped.

2017-07-27  Pavel Hrdina  <phrdina@redhat.com>

	Revert "build: distribute tests/virfilecachedata"
	This reverts commit d3d422e00c995d50c4b78066367bfbc4f872f586.

	Already fixed by commit 5a30b817ec93543c7a6cc93b5a6091a6666e377e.

2017-07-27  Pavel Hrdina  <phrdina@redhat.com>

	build: distribute tests/virfilecachedata
	Missed by 478f0c5b8575.

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	security: apparmor: load the storage driver dynamically
	In commit 5e515b542d I've attempted to fix the inability to access
	storage from the apparmor helper program by linking with the storage
	driver. By linking with the .so the linker complains that it's not
	portable. Fix this by loading the module dynamically as we are supposed
	to do.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	make: Drop building without driver modules
	Driver modules proved to be reliable for a long time. Since support for
	not building modules complicates the code and makefiles drop it.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-27  Daniel P. Berrange  <berrange@redhat.com>

	tests: add virfilecachedata to EXTRA_DIST

2017-07-27  Pavel Hrdina  <phrdina@redhat.com>

	tests: add test case for new syntax of VNC unix path with '='

2017-07-27  Pavel Hrdina  <phrdina@redhat.com>

	qemu: properly handle '=' in the VNC socket path
	If a domain name contains a '=' and the unix socket path is
	auto-generated or socket path provided by user contains '=' QEMU
	is unable to properly parse the command line.  In order to make it
	work we need to use the new command line syntax for VNC if it's
	available, otherwise we can use the old syntax.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1352529

2017-07-27  Pavel Hrdina  <phrdina@redhat.com>

	qemu: capabilities: introduce QEMU_CAPS_VNC_MULTI_SERVERS

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Test extraction of iSCSI device node names
	Test storage was created on a rhel/centos 7 node using targetcli.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Test extraction of LUKS node names
	Test file created by:

	qemu-img create -f luks /var/lib/libvirt/images/luks 10M \
	        -o key-secret=asdf --object secret,id=asdf,format=raw,data=asdf

	Used in libvirt as:
	 <disk type='file' device='disk'>
	   <driver name='qemu' type='raw'/>
	   <source file='/var/lib/libvirt/images/luks'/>
	   <target dev='vda' bus='virtio'/>
	   <encryption format='luks'>
	     <secret type='passphrase' uuid='9b2c831a-fdb9-4c09-873c-1959580589e1'/>
	   </encryption>
	 </disk>

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Add test case for node name detection with blockjob
	qemu 2.9 returns an extra layer in the backing data if a block job is
	active. Add a test case to see whether our code properly detects and
	ignores such layer.

	The test data was prepared by creating a backing chain of qcow2 images
	(with qemu-img and with libvirt's snapshot feature).

	One of the layers was then merged back by doing a block-commit:

	virsh blockcommit VM hda --top /var/lib/libvirt/images/b

	and then a block-copy job was started and kept in synchronized phase:

	virsh blockcopy VM hda /tmp/tgt.img --transient job

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Fix 'gluster' node name detection test case
	Add the blockstats data and fix the expected output.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Fix 'relative' node name detection test case
	Add the blockstats data and fix the expected output.

	Test data was created as:

	qemu-img create -f qcow2 img0 10M
	qemu-img create -f qcow2 -o "backing_fmt=qcow2,backing_file=img0" img1
	qemu-img create -f qcow2 -o "backing_fmt=qcow2,backing_file=img1" img2
	...

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Add data and fix 'same-backing' node detection case
	With the new approach we are actually able to correctly detect node
	names for the two instances of the same backing file.

	Test images were created as:
	qemu-img create -f qcow2 /var/lib/libvirt/images/base.qcow2 10M
	qemu-img create -f qcow2 \
	   -o "backing_fmt=qcow2,backing_file=/var/lib/libvirt/images/base.qcow2 \
	   /var/lib/libvirt/images/a.qcow2
	qemu-img create -f qcow2 \
	   -o "backing_fmt=qcow2,backing_file=/var/lib/libvirt/images/base.qcow2 \
	   /var/lib/libvirt/images/b.qcow2

	and then used for two separate disks.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: store and test driver names for detected storage nodes
	Store the 'drv' field both for the storage node and for the format node
	and format them in the test case.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Simplify node name detection test
	We can now iterate the hash table and print all detected backing chains.
	This simplifies calling of the test cases.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: Extract mock library for making hash table deterministic
	virHashNew calls virRandomBits to initialize seed for the hashing
	function. If a test uses iteration through the hash table to produce
	results they may/will be non-deterministic. Extract the mock library
	which was used for mac address mapping to be universal.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: Refactor node name detection code
	Remove the complex and unreliable code which inferred the node name
	hierarchy only from data returned by 'query-named-block-nodes'. It turns
	out that query-blockstats contain the full hierarchy of nodes as
	perceived by qemu so the inference code is not necessary.

	In query blockstats, the 'parent' object corresponds to the storage
	behind a storage volume and 'backing' corresponds to the lower level of
	backing chain. Since all have node names this data can be really easily
	used to detect node names.

	In addition to the code refactoring the one remaining test case needed
	to be fixed along.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	util: storagefile: rename 'nodebacking' to 'nodestorage' in virStorageSource
	Make it less confusing by naming the field which refers to the storage
	object as 'nodestorage'.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: Rename qemuBlockFillNodeData and move it to the top
	The same operation will become useful in other places so rename the
	function to be more generic and move it to the top so that it can be
	reused earlier in the file.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumontitorjson: temporarily disable node name detection tests
	To simplify the refactoring patches disable the tests. This will allow
	adding test data later.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: simplify path handling in testBlockNodeNameDetect
	Extract the test prefix path into a variable and reuse
	virTestLoadFileJSON to load the sample json files rather than doing it
	manually.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: utils: Add virTestLoadFileJSON helper
	This new helper loads, parses and returns a JSON file from 'abs_srcdir'
	By using variable arguments for the function, it's not necessary to
	format the path separately in the test cases.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemuhelp: convert to virTestLoadFilePath
	As a sample usage of the new helper convert the calls in qemuhelptest to
	the new helper.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: utils: Add virTestLoadFilePath helper
	This new helper loads and returns a file from 'abs_srcdir'. By using
	variable arguments for the function, it's not necessary to format the
	path separately in the test cases.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	util: buffer: Add virBufferStrcatVArgs
	Split out the worker loop into a separate function and export it.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: utils: Don't calculate file size in virTestLoadFile
	The callers don't use it so don't waste a strlen(). Also fix the comment
	for the function.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Drop redundant data from testBlockNodeNameDetectFormat
	The node name and backing file name can be inferred from the hierarchy.
	This will also help when converting to detect node names using
	query-blockstats data.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitor: Prepare for more test data in testBlockNodeNameDetect
	Rename 'json' and related variables to 'nodeNameJson'. Also rename the
	test files along. This is a preparation for modifying how we detect node
	names which will also require data from 'query-blockstats'.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	tests: qemumonitorjson: Consolidate basic node name detection test cases
	Test cases named '1' and '2' differed only in the length of the backing
	chain, so remove test case '2' and rename test '1' to 'basic'.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  Peter Krempa  <pkrempa@redhat.com>

	qemu: monitor: Extract call of 'query-blockstats' and add new API for it
	Allow getting the raw data from query-blockstats, so that we can use it
	to detect the backing chain later on.

	Reviewed-by: Eric Blake <eblake@redhat.com>

2017-07-27  John Ferlan  <jferlan@redhat.com>

	storage: Disallow usage of the HBA for a fc_host backing
	Disallow providing the wwnn/wwpn of the HBA in the adapter XML:

	  <adapter type='fc_host' [parent='scsi_hostN'] wwnn='HBA_wwnn'
	    wwpn='HBA_wwpn'/>

	This should be considered a configuration error since a vHBA
	would not be created. In order to use the HBA as the backing the
	following XML should be used:

	  <adapter type='scsi_host' name='scsi_hostN'/>

	So add a check prior to the checkParent call to validate that
	the provided wwnn/wwpn resolves to a vHBA and not an HBA.

2017-07-26  Martin Kletzander  <mkletzan@redhat.com>

	qemu_cgroup: Remove unnecessary virQEMUDriverPtr arguments
	Since commit 2e6ecba1bcac, the pointer to the qemu driver is saved in
	domain object's private data and hence does not have to be passed as
	yet another parameter if domain object is already one of them.

	This is a first (example) patch of this kind of clean up, others will
	hopefully follow.

2017-07-26  Martin Kletzander  <mkletzan@redhat.com>

	docs: Add build timestamps to generated html/php pages
	In order not to make the build even less reproducible, honour
	SOURCE_DATE_EPOCH environment variable as specified:

	  https://reproducible-builds.org/specs/source-date-epoch/

2017-07-26  Martin Kletzander  <mkletzan@redhat.com>

	build: Distribute tests/{qemucpumock.c,testutilshostcpus.h}
	Missed by 13554a9e7f4e.

2017-07-26  Andrea Bolognani  <abologna@redhat.com>

	tests: Prepare for stricter NIC model validation
	While using "definitely-not-virtio" as a model name is very
	cute, it will also cause the relevant test to fail once we
	introduce stricter validation.

	Use "e1000", which is definitely not virtio but also a valid
	model name, instead.

2017-07-26  Nitesh Konkar  <niteshkonkar.libvirt@gmail.com>

	docs: Fix typo in memory backing section

2017-07-26  John Ferlan  <jferlan@redhat.com>

	test: Use consistent variable names for network test driver APIs
	A virNetworkObjPtr will be an 'obj'.

	A virNetworkPtr will be a 'net'.

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	qemu: privatize _virQEMUCapsCachePriv struct
	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	qemu: switch QEMU capabilities to use virFileCache
	The switch contains considerable amount of changes:

	  virQEMUCapsRememberCached() is removed because this is now handled
	  by virFileCacheSave().

	  virQEMUCapsInitCached() is removed because this is now handled by
	  virFileCacheLoad().

	  virQEMUCapsNewForBinary() is split into two functions,
	  virQEMUCapsNewData() which creates new data if there is nothing
	  cached and virQEMUCapsLoadFile() which loads the cached data.
	  This is now handled by virFileCacheNewData().

	  virQEMUCapsCacheValidate() is removed because this is now handled by
	  virFileCacheValidate().

	  virQEMUCapsCacheFree() is removed because it's no longer required.

	  Add virCapsPtr into virQEMUCapsCachePriv because for each call of
	  virFileCacheLookup*() we need to use current virCapsPtr.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	qemu: pass only host arch instead of the whole virCaps
	This is a preparation for following patches where we switch to
	virFileCache for QEMU capabilities cache

	The host arch will always remain the same but virCaps may change.  Now
	the host arch is stored while creating new qemu capabilities cache.
	It removes the need to pass virCaps into virQEMUCapsCache*() functions.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	tests: rewrite host CPU mocking
	Move all the host CPU data into a separate file and rewrite qemucpumock
	to not use passed @caps.  This is preparation for following patch which
	will replace virCaps argument with virArch.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	qemu: introduce struct _virQEMUCapsCachePriv
	This will store private data that will be used by following patches
	when switching to virFileCache.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	tests: add virfilecachetest
	Implements 3 test cases that covers how the cache is used.

	We have to mock unlink() function because the caching code unlinks
	files that are no longer valid and we don't want to do it in our tests.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	util: introduce virFileCache
	The new virFileCache will nicely handle the caching logic for any data
	that we would like to cache.  For each type of data we will just need
	to implement few handlers that will take care of creating, validating,
	loading and saving the cached data.

	The cached data must be an instance of virObject.

	Currently we cache QEMU capabilities which will start using
	virFileCache.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-26  Pavel Hrdina  <phrdina@redhat.com>

	qemu: we prefer C89 comment styles over C99
	Introduced by commit 'a7bc2c8cfd6f'.

2017-07-26  Scott Garfinkle  <seg@us.ibm.com>

	Generate unique socket file
	It's possible to have more than one unnamed virtio-serial unix channel.
	We need to generate a unique name for each channel. Currently, we use
	".../unknown.sock" for all of them. Better practice would be to specify
	an explicit target path name; however, in the absence of that, we need
	uniqueness in the names we generate internally.

	Before the changes we'd get /var/lib/libvirt/qemu/channel/target/unknown.sock
	for each instance of
	    <channel type='unix'>
	        <source mode='bind'/>
	        <target type='virtio'/>
	    </channel>

	Now, we get vioser-00-00-01.sock, vioser-00-00-02.sock, etc.

2017-07-25  Martin Kletzander  <mkletzan@redhat.com>

	Move machineName generation from virsystemd into domain_conf
	It is more related to a domain as we might use it even when there is
	no systemd and it does not use any dbus/systemd functions.  In order
	not to use code from conf/ in util/ pass machineName in cgroups code
	as a parameter.  That also fixes a leak of machineName in the lxc
	driver and cleans up and de-duplicates some code.

	lxc: Make lxcProcessStop callable even without PID being available
	This way the function can work as a central point of clean-up code and
	we don't have to duplicate code.  And it works similarly to the qemu
	driver.

	qemu: Save qemu driver in qemuDomainObjPrivateData
	This way we can finally make it static and not use any externs anywhere.

	conf: Pass config.priv to xmlopt->privateData.alloc
	This will help us to get to some data more easily.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	secret: Handle object list removal and deletion properly
	Rather than rely on virSecretObjEndAPI to make the final virObjectUnref
	after the call to virSecretObjListRemove, be more explicit by calling
	virObjectUnref and setting @obj to NULL for secretUndefine and in
	the error path of secretDefineXML. Calling EndAPI will end up calling
	Unlock on an already unlocked object which has indeteriminate results
	(usually an ignored error).

	The virSecretObjEndAPI will both Unref and Unlock the object; however,
	the virSecretObjListRemove would have already Unlock'd the object so
	calling Unlock again is incorrect. Once the virSecretObjListRemove
	is called all that's left is to Unref our interest since that's the
	corrollary to the virSecretObjListAdd which returned our ref interest
	plus references for each hash table in which the object resides. In math
	terms, after an Add there's 2 refs on the object (1 for the object and
	1 for the list). After calling Remove there's just 1 ref on the object.
	For the Add callers, calling EndAPI removes the ref for the object and
	unlocks it, but since it's in a list the other 1 remains.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	secret: Fix memory leak in virSecretLoad
	If the virSecretLoadValue fails, the code jumped to cleanup without
	setting @ret = obj, thus calling virSecretObjListRemove which only
	accounts for the object reference related to adding the object to
	the list during virSecretObjListAdd, but does not account for the
	reference to the object itself as the return of @ret would be NULL
	so the caller wouldn't call virSecretObjEndAPI on the object recently
	added thus reducing the refcnt to zero.

	This patch will perform the ObjListRemove in the failure path of
	virSecretLoadValue and Unref @obj in order to perform clean up
	and return @obj as NULL. The @def will be freed as part of the
	virObjectUnref.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	secret: Properly handle @def after virSecretObjAdd in driver
	Since the virSecretObjListAdd technically consumes @def on success,
	the secretDefineXML should set @def = NULL immediately and process
	the remaining calls using a new @objDef variable. We can use use
	VIR_STEAL_PTR since we know the Add function just stores @def in
	obj->def.

	Because we steal @def into @objDef, if we jump to restore_backup:
	and @backup is set, then we need to ensure the @def would be
	free'd properly, so we'll steal it back from @objDef. For the other
	condition this fixes a double free of @def if the code had jumped to
	@backup == NULL thus calling virSecretObjListRemove without setting
	@def = NULL. In this case, the subsequent call to DefFree would
	succeed and free @def; however, the call to EndAPI would also
	call DefFree because the Unref done would be the last one for
	the @obj meaning the obj->def would be used to call DefFree,
	but it's already been free'd because @def wasn't managed right
	within this error path.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	secret: Remove need for local configFile and base64File in ObjectAdd
	Rather than assign to a local variable, let's just assign directly to the
	object using the error path for cleanup.

2017-07-25  Michal Privoznik  <mprivozn@redhat.com>

	Revert "virthread: Introduce virRWLockInitPreferWriter"
	This reverts commit 328bd24443d2a345a5832ee48ebba0208f8036ea.

	As it turns out, this is not portable and very Linux & glibc
	specific. Worse, this may lead to not starving writers on Linux
	but everywhere else. Revert this and if the starvation occurs
	resolve it.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-25  Andrea Bolognani  <abologna@redhat.com>

	conf: Rename virDomainControllerIsPCIHostBridge() to IsPSeriesPHB()
	The original name didn't hint at the fact that PHBs are
	a pSeries-specific concept.

	Suggested-by: Peter Krempa <pkrempa@redhat.com>

2017-07-25  Andrea Bolognani  <abologna@redhat.com>

	conf: Fix backwards migration of pSeries guests
	Recent commits made it so that pci-root controllers for
	pSeries guests are automatically assigned the
	spapr-pci-host-bridge model name; however, that prevents
	guests to migrate to older versions of libvirt which don't
	know about that model name at all, which at the moment is
	all of them :)

	To avoid the issue, just strip the model name from PHBs
	when formatting the migratable XML; guests that use more
	than one PHB are not going to be migratable anyway.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	storage: Check if provided parent is vHBA capable
	https://bugzilla.redhat.com/show_bug.cgi?id=1458708

	If the parent provided for the storage pool adapter is not vHBA
	capable, then issue a configuration error even though the provided
	wwnn/wwpn were found.

	It is a configuration error to provide a mismatched parent to
	the wwnn/wwpn. The @parent is optional and is used as a means to
	perform duplicate pool source checks.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	storage: Remove @conn from virNodeDeviceCreateVport
	It's no longer needed since the checkParent code moved back to
	storage_backend_scsi.c

2017-07-25  John Ferlan  <jferlan@redhat.com>

	storage: Fix existing parent check for vHBA creation
	https://bugzilla.redhat.com/show_bug.cgi?id=1472277

	Commit id '106930aaa' altered the order of checking for an existing
	vHBA (e.g something created via nodedev-create functionality outside
	of the storage pool logic) which inadvertantly broke the code to
	decide whether to alter/force the fchost->managed field to be 'yes'
	because the storage pool will be managing the created vHBA in order
	to ensure when the storage pool is destroyed that the vHBA is also
	destroyed.

	This patch moves the check (and checkParent helper) for an existing
	vHBA back into the createVport in storage_backend_scsi. It also
	adjusts the checkParent logic to more closely follow the intentions
	prior to commit id '79ab0935'. The changes made by commit id '08c0ea16f'
	are only necessary to run the virStoragePoolFCRefreshThread when
	a vHBA was really created because there's a timing lag such that
	the refreshPool call made after a startPool from storagePoolCreate*
	wouldn't necessarily find LUNs, but the thread would. For an already
	existing vHBA, using the thread is unnecessary since the vHBA already
	exists and the lag to configure the LUNs wouldn't exist.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	nodedev: Remove driver locks around object list mgmt code
	Since virnodedeviceobj now has a self-lockable hash table, there's no
	need to lock the table from the driver for processing. Thus remove the
	locks from the driver for NodeDeviceObjList mgmt.

	This includes the test driver as well.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	nodedev: Convert virNodeDeviceObjListPtr to use hash tables
	Rather than use a forward linked list of elements, it'll be much more
	efficient to use a hash table to reference the elements by unique name
	and to perform hash searches.

	This patch does all the heavy lifting of converting the list object to
	use a self locking list that contains the hash table. Each of the FindBy
	functions that do not involve finding the object by it's key (name) is
	converted to use virHashSearch in order to find the specific object.
	When searching for the key (name), it's possible to use virHashLookup.
	For any of the list perusal functions that are required to evaluate
	each object, the virHashForEach function is used.

2017-07-25  John Ferlan  <jferlan@redhat.com>

	nodedev: Remove @create from virNodeDeviceObjListGetParentHost
	The only callers to this function are from CreateXML paths now, so
	let's just remove the unnecessary parameter.

	nodedev: Alter node device deletion logic
	Alter the node device deletion logic to make use of the parent field
	from the obj->def rather than call virNodeDeviceObjListGetParentHost.
	As it turns out the saved @def won't have parent_wwnn/wwpn or
	parent_fabric_wwn, so the only logical path would be to call
	virNodeDeviceObjListGetParentHostByParent which we can accomplish
	directly via virNodeDeviceObjListFindByName.

2017-07-24  Michal Privoznik  <mprivozn@redhat.com>

	virdomainobjlist: Use virObjectRWLockable
	There is no reason why two threads trying to look up two domains
	should mutually exclude each other. Utilize new
	virObjectRWLockable that was just introduced.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-24  Michal Privoznik  <mprivozn@redhat.com>

	virobject: Introduce virObjectRWLockable
	Up until now we only had virObjectLockable which uses mutexes for
	mutually excluding each other in critical section. Well, this is
	not enough. Future work will require RW locks so we might as well
	have virObjectRWLockable which is introduced here.

	Moreover, polymorphism is introduced to our code for the first
	time. Yay! More specifically, virObjectLock will grab a write
	lock, virObjectLockRead will grab a read lock then (what a
	surprise right?). This has great advantage that an object can be
	made derived from virObjectRWLockable in a single line and still
	continue functioning properly (mutexes can be viewed as grabbing
	write locks only). Then just those critical sections that can
	grab a read lock need fixing. Therefore the resulting change is
	going to be way smaller.

	In order to avoid writer starvation, the object initializes RW
	lock that prefers writers.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-24  Michal Privoznik  <mprivozn@redhat.com>

	virthread: Introduce virRWLockInitPreferWriter
	We already have virRWLockInit. But this uses pthread defaults
	which prefer reader to initialize the RW lock. This may lead to
	writer starvation. Therefore we need to have the counterpart that
	prefers writers. Now, according to the
	pthread_rwlockattr_setkind_np() man page setting
	PTHREAD_RWLOCK_PREFER_WRITER_NP attribute is no-op. Therefore we
	need to use PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP
	attribute. So much for good enum value names.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-24  Martin Kletzander  <mkletzan@redhat.com>

	testutils: Remove unneeded variable
	virDomainXMLOptionNew() gladly accepts NULL and it is used in some
	drivers.  There is no need for additional variable with no members set

2017-07-24  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	qemu_capabilities: Fix the formatting with a space
	It was observed while adding new property that there should be a space
	before closing a curly brace in intel-iommu object property definition.
	Fixing it as a separate patch.

2017-07-24  Michal Privoznik  <mprivozn@redhat.com>

	docs: Span cells if there's not doc text for enum val
	When generating HTML documentation we put enum values into a
	table so that we can display the value's name, numerical value
	and description (if it has one). Now the last part is problem. If
	the value doesn't have description the table row has just two
	cells and if it has one the row counts three cells. This makes
	HTML engines render the description into very little space - for
	instance see:

	  html/libvirt-libvirt-domain.html#virDomainMemoryStatTags

	We can avoid this problem if we let the cell that corresponds to
	numerical value span over two cells if there's no description.

	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>

2017-07-24  Michal Privoznik  <mprivozn@redhat.com>

	apibuild.py: Handle enum comments properly
	After f4cb85c6aff7c1d90 we only have two options for placing enum
	values descriptions. It's either:

	    typedef enum {
	        /* Some long description. Therefore it's placed before
	         * the value. */
	        VIR_ENUM_A_VAL = 1,
	    } virEnumA;

	or:

	    typedef enum {
	        VIR_ENUM_B_VAL = 1, /* Some short description */
	    } virEnumB;

	However, our apibuild.py script is not able to deal with the
	former one. It messes up comments. To fix this couple of things
	needs to be done:

	a) DO NOT reset self.comment in parseEnumBlock(). This is a
	result from our tokenizer. Upon calling token() if it finds a
	comment block it stores it in self.comment and returns the next
	token (which is not comment). Therefore, if we reset self.comment
	we might lose the first comment in the enum block.

	b) we need a variable to track if the current enum block uses
	value descriptions before or after values. That is if it's type
	virEnumA or virEnumB. Depending on that, it we're dealing with
	virEnumA type and the current token is a comma ',' we can add the
	value into the list as we already have everything needed:
	comment, name and value.

	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>

2017-07-24  Peter Krempa  <pkrempa@redhat.com>

	virStorageNetHostDef: Turn @port into integer
	Currently, @port is type of string. Well, that's overkill and
	waste of memory. Port is always an integer. Use it as such.

2017-07-24  Peter Krempa  <pkrempa@redhat.com>

	conf: domain: Split up virDomainStorageHostParse and rename it
	Split out parsing of one host into a separate function and add a new
	function to loop through all the host XML nodes.

	This change removes multiple levels of nesting due to the old XML
	parsing approach used.

2017-07-24  Peter Krempa  <pkrempa@redhat.com>

	util: storage: fill in default ports when parsing backing chain
	Similarly to when parsing XML we need to fill in default ports for the
	backing chain. This was missed in commit 5bda835466a8050625dd8bb10566e

	qemu: command: Remove condition to use default sheepdog port
	Since we now set the default ports when parsing disks, it's not
	necessary to have default port numbers encoded in the command line
	generator.

	util: uri: Convert port number to unsigned integer
	Negative ports don't make sense so use a unsigned integer.

	qemu: command: Rename and move qemuNetworkDriveGetPort
	Move it to virstring.c and improve it to parse and validate ports. New
	name is virStringParsePort.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	storage: Fix editing mistake in storagePoolSetAutostart
	Commit id '905f1024b' had a rogue editing mistake that inadvertently
	dropped a goto cleanup in storagePoolSetAutostart, but Coverity noted it.

2017-07-22  Michal Privoznik  <mprivozn@redhat.com>

	qemu_capabilities: Honour caps values formatting
	So the way we format this huge virQEMUCaps enum is we group the
	values in groups of five. And then at the beginning of each group
	we have a small comment that says what's the number of the first
	item in the group. Well, the last commit of 11b2ebf3e152 does not
	follow this formatting.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	storage: Alter volume num, name, and export API's to just take obj
	Alter the virStoragePoolObjNumOfVolumes, virStoragePoolObjVolumeGetNames,
	and virStoragePoolObjVolumeListExport APIs to take a virStoragePoolObjPtr
	instead of the &obj->volumes and obj->def.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	storage: Use consistent variable names for driver
	A virStoragePoolObjPtr will be an 'obj'.

	A virStoragePoolPtr will be a 'pool'.

	A virStorageVolPtr will be a 'vol'.

	A virStorageVolDefPtr will be a 'voldef'.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	storage: Use consistent variable names in virstorageobj
	A virStoragePoolObjPtr will be an 'obj'.

	Also modify the @matchpool to @matchobj.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	storage: Fix return value checks for virAsprintf
	Use the < 0 rather than == -1 (consistently) for virAsprintf errors.

	test: Add testStorageVolDefFindByName for storage volume tests
	Remove repetitive code, replace with common function.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	test: Add helpers to fetch active/inactive storage pool by name
	Rather than have repetitive code - create/use a couple of helpers:

	    testStoragePoolObjFindActiveByName
	    testStoragePoolObjFindInactiveByName

	This will also allow for the reduction of some cleanup path logic.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	test: Cleanup exit/failure paths of some storage pool APIs
	Rework some of the test driver API's to remove the need to return
	failure when testStoragePoolObjFindByName returns NULL rather than
	going to cleanup. This removes the need for check for "if (obj)" and in
	some instances the need to for a cleanup label and a local ret variable.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	test: Use consistent variable names for storage test driver APIs
	A virStoragePoolObjPtr will be an 'obj'.

	A virStoragePoolPtr will be a 'pool'.

2017-07-22  John Ferlan  <jferlan@redhat.com>

	test: Fix up formatting in storage test API's
	Fix some spacing/formatting in the storage pool/vol test driver code.

2017-07-22  dann frazier  <dann.frazier@canonical.com>

	virt-aa-helper-test: Add test for aarch32 UEFI image path

	qemu: Add AAVMF32 to the list of known UEFIs
	Add a path for UEFI VMs for AArch32 VMs, based on the path Debian is using.
	libvirt is the de facto canonical location for defining where distros
	should place these firmware images, so let's define this path here to try
	and minimize distro fragmentation.

2017-07-22  Andrea Bolognani  <abologna@redhat.com>

	qemu: Remove duplicated code in qemuBuildSerialChrDeviceStr()
	The call to qemuBuildDeviceAddressStr() happens no matter
	what, so we can move it to the outer possible scope inside
	the function.

	We can also move the call to virBufferAsprintf() after all
	the checks have been performed, where it makes more sense.

2017-07-21  Andrea Bolognani  <abologna@redhat.com>

	conf: Move some virDomainDeviceInfo functions
	The virDomainDeviceInfo struct is defined in device_conf,
	so generic functions that operate on it should also be
	defined there rather than in domain_conf.

	conf: Clean up virDomainHostdevDefNew()
	Follow the same style as other similar functions.

	conf: Rename virDomainHostdevDefAlloc() to virDomainHostdevDefNew()
	All other virDomain*Def follow this naming convention for
	their allocation function.

2017-07-21  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	qemu: Enable NUMA node tag in pci-root for PPC64
	This patch addresses the same aspects on PPC the bug 1103314 addressed
	on x86.

	PCI expander bus creates multiple primary PCI busses, where each of these
	busses can be assigned a specific NUMA affinity, which, on x86 is
	advertised through ACPI on a per-bus basis.

	For SPAPR, a PHB's NUMA affinities are assigned on a per-PHB basis, and
	there is no mechanism for advertising NUMA affinities to a guest on a
	per-bus basis. So, even if qemu-ppc manages to get some sort of multi-bus
	topology working using PXB, there is no way to expose the affinities
	of these busses to the guest. It can only be exposed on a per-PHB/per-domain
	basis.

	So patch enables NUMA node tag in pci-root controller on PPC.

	The way to set the NUMA node is through the numa_node option of
	spapr-pci-host-bridge device. However for the implicit PHB, the only way
	to set the numa_node is from the -global option. The -global option applies
	to all the PHBs unless explicitly specified with the option on the
	respective PHB of CLI. The default PHB has the emulated devices only, so
	the patch prevents setting the NUMA node for the default PHB.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-21  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	qemu: capabilitity: Introduce QEMU_CAPS_SPAPR_PCI_HOST_BRIDGE_NUMA_NODE
	The patch adds a capability for spapr-pci-host-bridge.numa_node.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-21  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	Add capabilities for qemu-2.9.0 ppc64
	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-21  Andrea Bolognani  <abologna@redhat.com>

	qemu: Clean up firmware list initialization
	Instead of going through two completely different code paths,
	one of which repeats the same hardcoded bit of information
	three times in rapid succession, depending on whether or not
	a firmware list has been provided at configure time, just
	provide a reasonable default value and remove the extra code.

2017-07-21  Michal Privoznik  <mprivozn@redhat.com>

	libvirt-domain.h: Fix enum description placement
	There are only two acceptable places for describing enum values.
	It's either:

	    typedef enum {
	        /* Some long description. Therefore it's placed before
	         * the value. */
	        VIR_ENUM_A_VAL = 1,
	    } virEnumA;

	or:

	    typedef enum {
	        VIR_ENUM_B_VAL = 1, /* Some short description */
	    } virEnumB;

	However, during review of a patch sent upstream I realized that
	is not always the case. I went through all the public header
	files and identified all the offenders. Luckily there were just
	two of them.

	Yes, this makes our HTML generated documentation broken, but
	that's bug of the generator. Our header files shouldn't be forced
	to use something we don't want to.

2017-07-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Don't put memoryless NUMA nodes into autoNodeset
	'numad' may return a nodeset which contains NUMA nodes without memory
	for certain configurations. Since cgroups code will not be happy using
	nodes without memory we need to store only numa nodes with memory in
	autoNodeset.

	On the other hand autoCpuset should contain cpus also for nodes which
	do not have any memory.

2017-07-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Extract gathering of 'numad' placement into a function
	Remove the code from qemuProcessPrepareDomain so that it won't get even
	more bloated.

	qemu: domain: Store and restore autoCpuset to status XML
	Decouple them by storing them in the XML separately rather than
	regenerating them. This will simplify upcoming fixes.

	qemu: domain: Extract parsing and formatting of priv->autoNodeset
	Move the code to separate functions to avoid complicating the existing
	ones with changes.

	util: bitmap: Modify virBitmapSubtract to virBitmapIntersect
	Since virBitmapSubtract is unused modify it to perform bitmap
	intersection.

2017-07-20  John Ferlan  <jferlan@redhat.com>

	tests: Free @fakerootdir in error path
	Commit id 'dd9b29dad' added this new variable, but didn't free it in
	one instance where status was returned to the caller.

	Found by Coverity

2017-07-20  John Ferlan  <jferlan@redhat.com>

	daemon: Don't conditionally free @origErr in daemonStreamEvent
	Commit id '0fe4aa149' added @origErr, but since it's assigned outside
	the if condition, the free should be outside as well.

	Found by Coverity

2017-07-20  Antoine Millet  <antoine.millet@tdf.fr>

	Handle hotplug change on VLAN configuration using OVS
	A new function virNetDevOpenvswitchUpdateVlan has been created to instruct
	OVS of the changes. qemuDomainChangeNet has been modified to handle the
	update of the VLAN configuration for a running guest and rely on
	virNetDevOpenvswitchUpdateVlan to do the actual update if needed.

	virnetdevopenvswitch: Move OVS VLAN configuration to a separate function
	This piece of code is going to be reused. So move it out to a
	separate function.

2017-07-20  Cole Robinson  <crobinso@redhat.com>

	security: Don't overwrite error of GetProcessLabel
	Security impls of this function already raise errors, don't
	overwrite them.

2017-07-20  Pavel Hrdina  <phrdina@redhat.com>

	qemu: separate virQEMUCapsInitCached out of virQEMUCapsNewForBinaryInternal
	Preparation for switching to virFileCache where there are two callbacks,
	one to get a new data and second one to load a cached data.

	This also removes virQEMUCapsReset which is no longer required.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-20  Pavel Hrdina  <phrdina@redhat.com>

	qemu: don't pass qemuctime into virQEMUCapsIsValid
	It's not required and following patches will change the code.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-20  Pavel Hrdina  <phrdina@redhat.com>

	qemu: move libvirt ctime and version check into virQEMUCapsIsValid
	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

	qemu: move virQEMUCapsIsValid before its usage and make it static
	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-20  Pavel Hrdina  <phrdina@redhat.com>

	qemu: move libvirt ctime and version into _virQEMUCaps struct
	Cleanups the code a little bit and reduces amount of arguments passed
	throughout the functions.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-20  Pavel Hrdina  <phrdina@redhat.com>

	util/virhash: add name parameter to virHashSearch
	While searching for an element using a function it may be
	desirable to know the element key for future operation.

	Reviewed-by: Jiri Denemark <jdenemar@redhat.com>

2017-07-20  Chen Hanxiao  <chenhanxiao@gmail.com>

	include: nodedev: Fix a misleading comment about the used callback
	Actually we use virConnectNodeDeviceEventGenericCallback.

2017-07-20  Hao Peng  <peng.hao2@zte.com.cn>

	qemu: shared disks with cache=directsync should be safe for migration
	At present shared disks can be migrated with either readonly or cache=none. But
	cache=directsync should be safe for migration, because both cache=directsync and cache=none
	don't use the host page cache, and cache=direct write through qemu block layer cache.

	Reviewed-by: Wang Yechao <wang.yechao255@zte.com.cn>

2017-07-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: blockcopy: Refactor logic checking the target storage file
	Use virStorageSource accessors to check the file and call
	virStorageFileAccess before even attempting to stat the target. This
	will be helpful once we try to add network destinations for block copy,
	since there will be no need to stat them.

	qemu: blockcopy: Split out checking of the target image file
	Move the code into a separate function so that the flow of creating the
	copy is more obvious and split into logical pieces.

	qemu: blockcopy: reuse storage driver APIs to pre-create copy target
	Rather than using the local-file only implementation 'qemuOpenFile'
	switch to the imagelabel aware storage driver implementation.

2017-07-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: blockcopy: Explicitly assert 'reuse' for block devices
	When copying to a block device, the block device will already exist. To
	allow users using a block device without any preparation, they need to
	use the block copy without VIR_DOMAIN_BLOCK_COPY_REUSE_EXT.

	This means that if the target is an existing block device we don't need
	to prepare it, but we can't reject it as being existing.

	To avoid breaking this feature, explicitly assume that existing block
	devices will be reused even without that flag explicitly specified,
	while skipping attempts to create it.

	qemuMonitorDriveMirror still needs to honor the flag as specified by the
	user, since qemu overwrites the metadata otherwise.

2017-07-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: driver: Split out access to VIR_DOMAIN_BLOCK_COPY_REUSE_EXT
	Extract the presence of the flag into a boolean to simplify conditions
	and allow further manipulation of the state of the flag.

2017-07-20  Chen Hanxiao  <chenhanxiao@gmail.com>

	LXC: set the right var to NULL
	   For attaching hosdev, we should set dev->data.hostdev
	   rather than dev->data.disk

2017-07-20  Neal Gompa  <ngompa13@gmail.com>

	spec: Add support for building the zfs storage driver
	Where it can be supported in Fedora, the driver is built and made
	available as a subpackage.

2017-07-19  Peter Krempa  <pkrempa@redhat.com>

	tests: virjson: Test nesting of JSON string into a JSON (string) property
	Test that we are able to create a JSON object and nest it into a string
	property of a JSON object and then correctly extract and parse it back.

	tests: virjson: Test parsing and formatting of strings with escaped chars
	Make sure that JSON strings can contain characters which need to be
	escaped (double quotes, backslashes, tabs, etc.).

2017-07-19  ZhiPeng Lu  <lu.zhipeng@zte.com.cn>

	phyp: Fix memory leak in phypUUIDTable_Push
	@remote_file, allocated by virAsprintf, was not freed and leaked.

	mpath: Fix memory leak in virStorageBackendCreateVols
	@map_device, allocated by virAsprintf in virStorageBackendCreateVols,
	was not freed and leaked.

2017-07-19  Peter Krempa  <pkrempa@redhat.com>

	tests: virjson: Test formatting along with parsing of JSON objects
	Format the parsed string back and compare it to the original (or
	modified) string for back and forth comparison.

2017-07-19  Peter Krempa  <pkrempa@redhat.com>

	tests: virjson: Remove spaces from 'very-hard' parsing example
	The example is rather long and upcomming patch will check whether the
	string can be formatted back. As the formatted string lacks spaces and
	adding the 'expect' string with spaces would be rather long, just drop
	spaces from this test case.

	There are other test cases which do contain spaces.

2017-07-19  Peter Krempa  <pkrempa@redhat.com>

	tests: virjson: Modify logic in testJSONFromString
	To allow better testing in case where the string was parsed, modify the
	logic so that the regular code path is not included in a conditional
	block.

2017-07-19  Ján Tomko  <jtomko@redhat.com>

	test/Makefile.am: drop WARN_CFLAGS from LDFLAGS
	Introduced by commit 0832c58, with the intention to link with
	the stack protector library.

	Another instance introduced by commit 4cbc15d which separated
	commandhelper_LDADD from LDADDS.

	Not needed because per commit 71b54636, automake should pass
	all the CFLAGS to the linker.

2017-07-19  Wang King  <king.wang@huawei.com>

	qemu: avoid deadlock on domain object enter monitor fail
	Should be followed with qemuDomainObjExitMonitor only if
	qemuDomainObjEnterMonitorAsync returns 0.

2017-07-19  Peter Krempa  <pkrempa@redhat.com>

	security: apparmor: Properly link with storage driver in helper program
	The refactor to split up storage driver into modules broke the apparmor
	helper program, since that did not initialize the storage driver
	properly and thus detection of the backing chain could not work.

	Register the storage driver backends explicitly. Unfortunately it's now
	necessary to link with the full storage driver to satisfy dependencies
	of the loadable modules.

	Reviewed-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>
	Reported-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>
	Tested-by: Christian Ehrhardt <christian.ehrhardt@canonical.com>

2017-07-19  Michal Privoznik  <mprivozn@redhat.com>

	virFileInData: Report an error if unable to reposition file
	The purpose of this function is to tell if the current position
	in given FD is in data section or a hole and how much bytes there
	is remaining until the end of the section. This is achieved by
	couple of lseeks(). The most important part is that we reposition
	the FD back, so that the position is unchanged from the caller
	POV. And until now the final lseek() back to the original
	position was done with no check for errors. And I was convinced
	that that's okay since nothing can go wrong. However, review
	feedback from a related series persuaded me, that it's better to
	be safe than sorry. Therefore, lets check if the final lseek()
	succeeded and if it doesn't report an error.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-19  Jim Fehlig  <jfehlig@suse.com>

	docs: schema: make disk driver name attribute optional
	/domain/devices/disk/driver/@name is not a required or mandatory
	attribute according to formatdomain, and indeed it was agreed on
	IRC that the attribute is "optional for input, recommended (but
	not required) for output". Currently the schema requires the
	attribute, causing virt-xml-validate to fail on disk config where
	the driver name is not explicitly specified. E.g.

	# cat test.xml | grep -A 5 cdrom
	    <disk type='file' device='cdrom'>
	      <driver type='raw'/>
	      <target dev='hdb' bus='ide'/>
	      <readonly/>
	      <address type='drive' controller='0' bus='0' target='0' unit='1'/>
	    </disk>

	# virt-xml-validate test.xml
	Relax-NG validity error : Extra element devices in interleave
	test.xml:21: element devices: Relax-NG validity error : Element domain failed to validate content
	test.xml fails to validate

	Relaxing the name attribute to be optional fixes the validation

	# virt-xml-validate test.xml
	test.xml validates

2017-07-18  Michal Privoznik  <mprivozn@redhat.com>

	wireshark: Adapt to tvb_new_subset() rename
	In Wireshark commit of 7cd6906056922e4b8 (contained in v2.4.0)
	the tvb_new_subset() function was renamed to
	tvb_new_subset_length_caplen(). However, we can take the extra
	step and rename to tvb_new_subset_remaining() directly (see
	Wireshark commit 0ecfc7280cf3d7). The reasoning is that there is
	no other protocol in the packet than libvirt. Therefore, from the
	point that libvirt dissector takes over till the end of the
	packet it's all libvirt packet.

	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>

2017-07-18  Boris Fiuczynski  <fiuczy@linux.vnet.ibm.com>

	tests: enable qemu 2.9 capabilities test for s390
	Adjust qemu 2.9 s390 capabilites xml and enable qemu capabilities test.

2017-07-18  John Ferlan  <jferlan@redhat.com>

	nodedev: Fix call to virNodeDeviceObjListFree in nodeStateReload
	Commit id '9c5d98fd8' missed changing this call to use driver->devs
	rather than @driver->devs.

2017-07-18  Andrea Bolognani  <abologna@redhat.com>

	news: Update for hostdev isolation
	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-18  Andrea Bolognani  <abologna@redhat.com>

	qemu: Isolate hostdevs on pSeries guests
	All the pieces are now in place, so we can finally start
	using isolation groups to achieve our initial goal, which is
	separating hostdevs from emulated PCI devices while keeping
	hostdevs that belong to the same host IOMMU group together.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1280542

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-18  Andrea Bolognani  <abologna@redhat.com>

	conf: Implement isolation rules
	These rules will make it possible for libvirt to
	automatically assign PCI addresses in a way that
	respects any isolation constraints devices might
	have.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-18  Andrea Bolognani  <abologna@redhat.com>

	conf: Introduce isolation groups
	Isolation groups will eventually allow us to make sure certain
	devices, eg. PCI hostdevs, are assigned to guest PCI buses in
	a way that guarantees improved isolation, error detection and
	recovery for machine types and hypervisors that support it,
	eg. pSeries guest on QEMU.

	This patch merely defines storage for the new information
	we're going to need later on and makes sure it is passed from
	the hypervisor driver (QEMU / bhyve) down to the generic PCI
	address allocation code.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Convert virNodeDeviceObj to use virObjectLockable
	Now that we have a bit more control, let's convert our object into
	a lockable object and let that magic handle the create and lock/unlock.

	This also involves creating a virNodeDeviceEndAPI in order to handle
	the object cleanup for API's that use the Add or Find API's in order
	to get a locked/reffed object. The EndAPI will unlock and unref the
	object returning NULL to indicate to the caller to not use the obj.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Privatize _virNodeDeviceObj and _virNodeDeviceObjList
	Move the structures to withing virnodedeviceobj.c

	Move the typedefs from node_device_conf to virnodedeviceobj.h

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Introduce virNodeDeviceObjListFindSCSIHostByWWNs
	In an overall effort to privatize access to virNodeDeviceObj and
	virNodeDeviceObjList into the virnodedeviceobj module, move the
	object list parsing from node_device_driver and replace with a
	call to a virnodedeviceobj helper. This follows other similar
	APIs/helpers which peruse the object list looking for some specific
	data in order to get/return an @device (virNodeDevice) object to
	the caller.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Introduce virNodeDeviceGetSCSIHostCaps
	We're about to move the call to nodeDeviceSysfsGetSCSIHostCaps from
	node_device_driver into virnodedeviceobj, so move the guts of the code
	from the driver specific node_device_linux_sysfs into its own API
	since virnodedeviceobj cannot callback into the driver.

	Nothing in the code deals with sysfs anyway, as that's hidden by the
	various virSCSIHost* and virVHBA* utility function calls.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Dereference the obj/def in virNodeDeviceObjListFind* APIs
	Create local @obj and @def for the API's rather than referencing the
	devs->objs[i][->def->].  It'll make future patches easier to read.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Alter node device obj list function names
	Ensure that any function that walks the node device object list is prefixed
	by virNodeDeviceObjList.

	Also, modify the @filter param name for virNodeDeviceObjListExport to
	be @aclfilter.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Introduce virNodeDeviceObjListNew
	In preparation to make things private, make the ->devs be pointers to a
	virNodeDeviceObjList and then manage everything inside virnodedeviceobj

	nodedev: Introduce virNodeDeviceObjNew
	Create an allocator for the virNodeDeviceObjPtr - include setting up
	the mutex, saving the virNodeDeviceDefPtr, and locking the return object.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Use consistent names for driver variables
	A virNodeDeviceObjPtr is an @obj

	A virNodeDeviceObjListPtr is a @devs

	A virNodeDevicePtr is a @device

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Use common naming for virnodedeviceobj
	A virNodeDeviceObjPtr is an @obj

	A virNodeDeviceObjListPtr is an @devs

2017-07-17  John Ferlan  <jferlan@redhat.com>

	test: Adjust cleanup/error paths for nodedev test APIs
	 - In testDestroyVport rather than use a cleanup label, just return -1
	   immediately since nothing else is needed.

	 - In testStoragePoolDestroy, if !privpool, then just return -1 since
	   nothing else will happen anyway.

	 - Rather than "goto cleanup;" on failure to virNodeDeviceObjFindByName
	   an @obj, just return directly.  This then allows the cleanup: label code
	   to not have to check "if (obj)" before calling virNodeDeviceObjUnlock.
	   This also simplifies some exit logic...

	 - In testNodeDeviceObjFindByName use an error: label to handle the failure
	   and don't do the ncaps++ within the VIR_STRDUP() source target index.
	   Only increment ncaps after success. Easier on eyes at error label too.

	 - In testNodeDeviceDestroy use "cleanup" rather than "out" for the goto

2017-07-17  John Ferlan  <jferlan@redhat.com>

	nodedev: Alter virNodeDeviceObjRemove
	Rather than passing the object to be removed by reference, pass by value
	and then let the caller decide whether or not the object should be free'd
	and how to handle the logic afterwards. This includes free'ing the object
	and/or setting the local variable to NULL to prevent subsequent unexpected
	usage (via something like virNodeDeviceObjRemove in testNodeDeviceDestroy).

	For now this function will just handle the remove of the object from the
	list for which it was placed during virNodeDeviceObjAssignDef.

	This essentially reverts logic from commit id '61148074' that free'd the
	device entry on list, set *dev = NULL and returned. Thus fixing a bug in
	node_device_hal.c/dev_refresh() which would never call dev_create(udi)
	since @dev would have been set to NULL.

2017-07-17  Martin Kletzander  <mkletzan@redhat.com>

	qemu: Use the proper string in qemuBlock...JSONSocketAddress()
	Recent refactors made it so that the function may use uninitialized
	pointer, but it actually wanted to use a different variable and value
	at all.

2017-07-17  John Ferlan  <jferlan@redhat.com>

	Revert "nwfilter: Move save of config until after successful assign"
	This reverts commit b3e71a8830b2683ee88fa10cb048eabb99a446c0.

	As it turns out this ends up very badly as the @def could be Free'd
	even though it's owned by @obj as a result of the AssignDef.

2017-07-17  ZhiPeng Lu  <lu.zhipeng@zte.com.cn>

	virpcimock: Fix memory leak in pci_driver_new
	driverpath, allocated by virAsprintfQuiet, was not freed and leaked.

2017-07-16  John Ferlan  <jferlan@redhat.com>

	nwfilter: Introduce virNWFilterObjListFindInstantiateFilter
	Create a common API to handle the instantiation path filter lookup.

	nwfilter: Rename _virNWFilterInstantiateFilter
	New API will be virNWFilterInstantiateFilterInternal as it's called from
	the virNWFilterInstantiateFilter and virNWFilterUpdateInstantiateFilter.

	nwfilter: Rename __virNWFilterInstantiateFilter
	Rename to virNWFilterInstantiateFilterUpdate and alter the callers to not
	have one parameter per line.

2017-07-16  John Ferlan  <jferlan@redhat.com>

	nwfilter: Rename virNWFilterInstantiate
	Rename to virNWFilterDoInstantiate to better describe the action.

	Also fix the @vmuuid parameter to not have the ATTRIBUTE_UNUSED since it
	is used in the call to virNWFilterDHCPSnoopReq.

2017-07-16  John Ferlan  <jferlan@redhat.com>

	nwfilter: Consistently name virNWFilterPtr in driver
	Use @nwfilter always for the name

	nwfilter: Clean up a couple nwfilter_driver error paths
	No need to goto cleanup and check "if (obj)" if we know (obj) isn't there,
	so just return immediately.

	nwfilter: Remove need for virNWFilterSaveXML
	Merge code into virNWFilterSaveConfig

	nwfilter: Fix return value comparison for virNWFilterTriggerVMFilterRebuild
	Should compare < 0 to be correct.

2017-07-16  Cole Robinson  <crobinso@redhat.com>

	docs: formatdomain: Tweak disk discard= docs
	Change from

	  'controls whether to discard ... requests are ignored'

	to

	  'controls whether discard requests ... are ignored'

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	news: Update for multiple PHBs
	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Use PHBs when extending the guest PCI topology
	When looking for slots suitable for a PCI device, libvirt
	might need to add an extra PCI controller: for pSeries guests,
	we want that extra controller to be a PHB (pci-root) rather
	than a PCI bridge.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Use PHBs to fill holes in PCI bus numbering
	PCI bus has to be numbered sequentially, and no index can be
	missing, so libvirt will fill in the blanks automatically for
	the user.

	Up until now, it has done so using either pci-bridge, for machine
	types based on legacy PCI, or pcie-root-port, for machine types
	based on PCI Express. Neither choice is good for pSeries guests,
	where PHBs (pci-root) should be used instead.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	tests: Add baseline tests for automatic PHB usage
	These tests demonstrate that, while it's now possible for the
	user to create PHB explicitly and manually assign devices to
	them, libvirt still defaults to extending the guest PCI
	topology using PCI bridges and making suboptimal device
	placement choices.

	The next few commits will improve on these behaviors and the
	tests outputs will automatically be updated to reflect this.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	tests: Add tests for pSeries guests with multiple PHBs
	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	qemu: Take all PHBs into account while calculating memlock limits
	Now that the multi-phb support series is in, work on the TODO at
	qemuDomainGetMemLockLimitBytes() to arrive at the correct memlock limit
	value.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Format additional PHBs on the command line
	Additional PHBs (pci-root controllers) will be created for
	the guest using the spapr-pci-host-bridge QEMU device, if
	available; the implicit default PHB, while present in the
	guest configuration, will be skipped.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1431193

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Deal with PHB naming conventions
	Usually, a controller with alias 'x' will create a bus with the
	same name; however, the bus created by a PHBs with alias 'x' will
	be named 'x.0' instead, so we need to account for that.

	As an exception to the exception, the implicit PHB that's added
	automatically to every pSeries guest creates the 'pci.0' bus.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Introduce QEMU_CAPS_DEVICE_SPAPR_PCI_HOST_BRIDGE
	This new capability can be used to detect whether a QEMU
	binary supports the spapr-pci-host-bridge controller.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Automatically pick target index and model for pci-root controllers
	pSeries guests will soon need the new information; luckily,
	we can figure it out automatically most of the time, so
	users won't have to worry about it.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Parse and format <target index='...'/>
	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Add 'spapr-pci-host-bridge' controller model
	Adding it to the virDomainControllerPCIModelName enumeration
	is enough for existing code to handle it, so parsing and
	formatting will work without further tweaking.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Relax pci-root index requirement for pSeries guests
	pSeries guests will soon be allowed to have multiple
	PHBs (pci-root controllers), meaning the current check
	on the controller index no longer applies to them.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Move index number checking to drivers
	pSeries guests will soon be allowed to have multiple
	PHBs (pci-root controllers), which of course means that
	all but one of them will have a non-zero index; hence,
	we'll need to relax the current check.

	However, right now the check is performed in the conf
	module, which is generic rather than tied to the QEMU
	driver, and where we don't have information such as the
	guest machine type available.

	To make this change of behavior possible down the line,
	we need to move the check from the XML parser to the
	drivers. Luckily, only QEMU and bhyve are using PCI
	controllers, so this doesn't result in much duplication.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Tweak index number checking
	Moving the check and rewriting it this way doesn't alter
	the current behavior, but will allow us to special-case
	pci-root down the line.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Allow qemuBuildControllerDevStr() to return NULL
	We will soon need to be able to return a NULL pointer
	without the caller considering that an error: to make
	it possible, change the return type to int and use
	an out parameter for the string instead.

	Add some documentation for the function as well.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Simplify slot allocation
	The current algorithm for slot allocation tries to be clever
	and avoid looking at buses / slots more than once unless it's
	necessary. Unfortunately that makes the code more complex,
	and it will cause problem later on in some situations unless
	even more complex code is added.

	Since the performance gains are going to be pretty modest
	anyway, we can just get rid of the extra complexity and use a
	completely  straighforward implementation instead.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	tests: Mock IOMMU groups
	Later on we're going to need access to information about IOMMU
	groups for host devices. Implement the support in virpcimock,
	and start using that mock library in a few QEMU test cases.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	tests: Update qemumemlock data
	Use 0001:01:00.0 instead of 0000:04:02.0 as the source address
	for the host device. This doesn't change anything at the moment,
	but it will make a difference later on.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	qemu: Clean up qemuDomainAttachHostPCIDevice()
	We use hostdev->info frequently enough that having
	a shorter name for it makes the code more readable.
	We will also be adding even more uses later on.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Tweak virDomainPCIAddressGetNextAddr() signature
	Move @function after @flags to match other functions in the
	same module like virDomainPCIAddressReserveNextAddr().

	Also move virDomainPCIAddressReserveNextAddr() closer to
	virDomainPCIAddressReserveAddr() in the header file.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Make virDomainPCIAddressFlagsCompatible() private
	There are no external users.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Make virDomainPCIAddressSetGrow() private
	There are no external users.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Move virDomainPCIAddressBusIsFullyReserved()
	This function was private to the QEMU driver and was,
	accordingly, called qemuDomainPCIBusFullyReserved().

	However the function is really not QEMU-specific at
	all, so it makes sense to move it closer to the
	virDomainPCIAddressBus struct it operates on.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  Andrea Bolognani  <abologna@redhat.com>

	conf: Remove obsolete comment
	The virDomainDeviceInfoIsSet() function no longer exists.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-07-15  John Ferlan  <jferlan@redhat.com>

	network: Perform some formatting cleanup in bridge_driver
	Modify code to have two spaces between functions, follow function more
	recent function formatting w/r/t args per line and function return type
	and name on separate lines.

	test: Fix up formatting in network test API's
	Fix some spacing/formatting in the network test driver code.

2017-07-14  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: rename and refactor qemuBuildGlusterDriveJSON
	New name is qemuBlockStorageSourceGetGlusterProps and also hardcode the
	protocol name rather than calling the ToString function, since this
	function can't be made universal.

2017-07-14  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: refactor and rename qemuBuildGlusterDriveJSONHosts
	New name is qemuBlockStorageSourceBuildHostsJSONSocketAddress since it
	formats the JSON object in accordance with qemu's SocketAddress type.

	Since the new naming in qemu uses 'inet' instead of 'tcp' add a
	compatibility layer for gluster which uses the old name.

2017-07-14  Peter Krempa  <pkrempa@redhat.com>

	qemu: block: Refactor and rename qemuGetDriveSourceProps
	Rename it to qemuBlockStorageSourceGetBackendProps and refactor it to
	return the JSON object instead of filling a pointer since now it's
	always expected to return data.

	qemu: Move qemuGetDriveSourceProps to qemu_block
	Pure code movement except for the tweaks necessary for cross-usage.

	qemu: command: Call qemuGetDriveSourceProps only if necessary
	Add logic which will call qemuGetDriveSourceProps only in cases where we
	need the JSON representation. This will allow qemuGetDriveSourceProps to
	generate the JSON representation for all possible disk sources.

	qemu: command: Remove default port numbers for NBD and GLUSTER
	The command line generators for the protocols above hardcoded a default
	port number. Since we now always assign it when parsing the source
	definition, this ad-hoc code is not required any more.

2017-07-14  Peter Krempa  <pkrempa@redhat.com>

	conf: Pre-fill default ports when parsing network disk sources
	Fill them in right away rather than having to figure out at runtime
	whether they are necessary or not.

	virStorageSourceNetworkDefaultPort does not need to be exported any
	more.

2017-07-14  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Fill in default ports for gluster and iscsi
	Our documentation provides them, so the helper should return them.

	util: Extract helper to retrieve default port for network protocol
	Make the stuff hardcoded in qemu a global helper so that other parts of
	the code can determine the default port too.

	qemu: command: Set port number only for TCP transport
	Setting port number for protocols using UNIX transport does not make
	sense. Move the setter code to the appropriate block.

2017-07-14  John Ferlan  <jferlan@redhat.com>

	secret: Rename variable in virSecretObjListAdd
	Rename @def to @objdef - it'll make future patches easier.

	secret: Alter FindByUUID to expect the formatted uuidstr
	Since we're storing a virUUIDFormat'd string in our Hash Table, let's
	modify the Lookup API to receive a formatted string as well.

	secret: Whitespace modification for secret_driver
	Ensure two empty lines between functions.

2017-07-13  Daniel P. Berrange  <berrange@redhat.com>

	Revert "Prevent more compiler optimization of mockable functions"
	This reverts commit e4b980c853d2114b25fa805a84ea288384416221.

	When a binary links against a .a archive (as opposed to a shared library),
	any symbols which are marked as 'weak' get silently dropped. As a result
	when the binary later runs, those 'weak' functions have an address of
	0x0 and thus crash when run.

	This happened with virtlogd and virtlockd because they don't link to
	libvirt.so, but instead just libvirt_util.a and libvirt_rpc.a. The
	virRandomBits symbols was weak and so left out of the virtlogd &
	virtlockd binaries, despite being required by virHashTable functions.

	Various other binaries like libvirt_lxc, libvirt_iohelper, etc also
	link directly to .a files instead of libvirt.so, so are potentially
	at risk of dropping symbols leading to a later runtime crash.

	This is normal linker behaviour because a weak symbol is not treated
	as undefined, so nothing forces it to be pulled in from the .a You
	have to force the linker to pull in weak symbols using -u$SYMNAME
	which is not a practical approach.

	This risk is silent bad linkage that affects runtime behaviour is
	not acceptable for a fix that was merely trying to fix the test
	suite. So stop using __weak__ again.

2017-07-13  Daniel P. Berrange  <berrange@redhat.com>

	Revert "internal: don't use weak symbols for Win32 platform"
	This reverts commit b9473d8b11d79c8990dcbba13bbf7d4051288a1e.

2017-07-13  Martin Kletzander  <mkletzan@redhat.com>

	util: Don't leak linksrc in vircgroup

2017-07-13  Daniel P. Berrange  <berrange@redhat.com>

	tests: add virjsondata to EXTRA_DIST

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Update host-model CPUs on reconnect
	When libvirt starts a new QEMU domain, it replaces host-model CPUs with
	the appropriate custom CPU definition. However, when reconnecting to a
	domain started by older libvirt (< 2.3), the domain would still have a
	host-model CPU in its active definition.

	https://bugzilla.redhat.com/show_bug.cgi?id=1463957

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Move qemuProcessReconnect to the end of qemu_process.c
	qemuProcessReconnect will need to call additional functions which were
	originally defined further in qemu_process.c.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Export virQEMUCapsGuestIsNative
	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add qemuProcessUpdateLiveGuestCPU
	Separated from qemuProcessUpdateAndVerifyCPU to handle updating of an
	active guest CPU definition according to live data from QEMU.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Rename qemuProcessUpdateLiveGuestCPU
	In addition to updating a guest CPU definition the function verifies
	that all required features are provided to the guest. Let's make it
	obvious by calling it qemuProcessUpdateAndVerifyCPU.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add qemuProcessVerifyCPU
	Separated from qemuProcessUpdateLiveGuestCPU. The function makes sure
	a guest CPU provides all features required by a domain definition.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add qemuProcessFetchGuestCPU
	Separated from qemuProcessUpdateLiveGuestCPU. Its purpose is to fetch
	guest CPU data from a running QEMU process. The data can later be used
	to verify and update the active guest CPU definition.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	cpu_x86: Properly disable unknown CPU features
	CPU features unknown to a hypervisor will not be present in dataDisabled
	even though the features won't naturally be enabled because.
	Thus any features we asked for which are not in dataEnabled should be
	considered disabled.

2017-07-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Don't update CPU when checking ABI stability
	When checking ABI stability between two domain definitions, we first
	make migratable copies of them. However, we also asked for the guest CPU
	to be updated, even though the updated CPU is supposed to be already
	included in the original definitions. Moreover, if we do this on the
	destination host during migration, we're potentially updating the
	definition with according to an incompatible host CPU.

	While updating the CPU when checking ABI stability doesn't make any
	sense, it actually just worked because updating the CPU doesn't do
	anything for custom CPUs (only host-model CPUs are affected) and we
	updated both definitions in the same way.

	Less then a year ago commit v2.3.0-rc1~42 stopped updating the CPU in
	the definition we got internally and only the user supplied definition
	was updated. However, the same commit started updating host-model CPUs
	to custom CPUs which are not affected by the request to update the CPU.
	So it still seemed to work right, unless a user upgraded libvirt 2.2.0
	to a newer version while there were some domains with host-model CPUs
	running on the host. Such domains couldn't be migrated with a user
	supplied XML since libvirt would complain:

	    Target CPU mode custom does not match source host-model

	The fix is pretty straightforward, we just need to stop updating the CPU
	when checking ABI stability.

	https://bugzilla.redhat.com/show_bug.cgi?id=1463957

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-13  Juan Hernandez  <jhernand@redhat.com>

	Avoid hidden cgroup mount points
	Currently the scan of the /proc/mounts file used to find cgroup mount
	points doesn't take into account that mount points may hidden by other
	mount points. For, example in certain Kubernetes environments the
	/proc/mounts contains the following lines:

	  cgroup /sys/fs/cgroup/net_prio,net_cls cgroup ...
	  tmpfs /sys/fs/cgroup tmpfs ...
	  cgroup /sys/fs/cgroup/net_cls,net_prio cgroup ...

	In this particular environment the first mount point is hidden by the
	second one. The correct mount point is the third one, but libvirt will
	never process it because it only checks the first mount point for each
	controller (net_cls in this case). So libvirt will try to use the first
	mount point, which doesn't actually exist, and the complete detection
	process will fail.

	To avoid that issue this patch changes the virCgroupDetectMountsFromFile
	function so that when there are duplicates it takes the information from
	the last line in /proc/mounts. This requires removing the previous
	explicit condition to skip duplicates, and adding code to free the
	memory used by the processing of duplicated lines.

	Related-To: https://bugzilla.redhat.com/1468214
	Related-To: https://github.com/kubevirt/libvirt/issues/4

2017-07-12  Cole Robinson  <crobinso@redhat.com>

	news: qemu platform serial devices now use -chardev
	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-12  Cole Robinson  <crobinso@redhat.com>

	qemu: process: Remove unused qemuCaps
	After 426dc5eb2 qemuCaps and virDomainDefPtr are unused here,
	remove it from the call stack

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-12  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainGetPreservedMountPath: rename @mount
	Obviously, old gcc-s ale sad when a variable shares the name with
	a function. And we do have such variable (added in 4d8a914be0):
	@mount. Rename it to @mountpoint so that compiler's happy again.

2017-07-12  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Provide non-linux stub for qemuDomainAttachDeviceMknodRecursive
	The way we create devices under /dev is highly linux specific.
	For instance we do mknod(), mount(), umount(), etc. Some
	platforms are even missing some of these functions. Then again,
	as declared in qemuDomainNamespaceAvailable(): namespaces are
	linux only. Therefore, to avoid obfuscating the code by trying to
	make it compile on weird platforms, just provide a non-linux stub
	for qemuDomainAttachDeviceMknodRecursive(). At the same time,
	qemuDomainAttachDeviceMknodHelper() which actually calls the
	non-existent functions is moved under ifdef __linux__ block since
	its only caller is in that block too.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-12  John Ferlan  <jferlan@redhat.com>

	qemu: Fix qemuDomainGetBlockInfo allocation value setting
	https://bugzilla.redhat.com/show_bug.cgi?id=1467826

	Commit id 'b9b1aa639' was supposed to add logic to set the allocation
	for sparse files when wr_highest_offset was zero; however, an unconditional
	setting was done just prior. For block devices, this means allocation is
	always returning 0 since 'actual-size' will be zero.

	Remove the unconditional setting and add the note about it being possible
	to still be zero for block devices. As soon as the guest starts writing to
	the volume, the allocation value will then be obtainable from qemu via
	the wr_highest_offset.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	qemu: Support only raw volumes in qemuDomainBlockPeek
	The API documents that it peeks into the VM disk. We can't do that
	currently for non raw images so report an error.

	qemu: Use storage driver APIs in qemuDomainBlockPeek
	Refactor the access to storage driver usage along with
	qemuDomainStorageFileInit which ensures that we access the file with
	correct DAC uid/gid.

	storage: Make virStorageFileReadHeader more universal
	Allow specifying offset to read an arbitrary position in the file. This
	warrants a rename to virStorageFileRead.

	storage: Split out virStorageSource accessors to separate file
	The helper methods for actually accessing the storage objects don't
	really belong to the main storage driver implementation file. Split them
	out.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	tests: storage: Fully register storage driver
	Use the full storage driver registration method that also fails if one
	of the storage backends is not present. This makes the test fail if a
	submodule fails registration, which is useful for testing.

	Additionally return EXIT_FAILURE as usual in tests rather than -1.

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	internal: don't use weak symbols for Win32 platform
	The Win32 platform will fail to link if you use weak symbols
	because it is incompatible with exporting symbols in a DLL:

	Cannot export virRandomGenerateWWN: symbol wrong type (2 vs 3)

	We only need weak symbols for our test suite to do LD_PRELOAD
	and this doesn't work on Win32, so we can just drop the hack
	for Win32

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	rpc: improve error message for bounds check
	If we exceed a fixed limit in RPC code we get a horrible message
	like this, if the parameter type is a 'string', because we forgot
	to initialize the error message type field:

	  $ virsh snapshot-list ostack1
	  error: too many remote undefineds: 1329 > 1024

	It would also be useful to know which RPC call and field was
	exceeded. So this patch makes us report:

	  $ virsh snapshot-list ostack1
	  error: too many remote undefineds: 1329 > 1024,
	  in parameter 'names' for 'virDomainSnapshotListNames'

2017-07-11  Ján Tomko  <jtomko@redhat.com>

	qemu: handle missing bind host/service on chardev hotplug
	On domain startup, bind host or bind service can be omitted
	and we will format a working command line.

	Extend this to hotplug as well and specify the service to QEMU
	even if the host is missing.

	https://bugzilla.redhat.com/show_bug.cgi?id=1452441

2017-07-11  Ján Tomko  <jtomko@redhat.com>

	qemuDomainSetInterfaceParameters: use the temporary params variable
	We have a temporary pointer to the currently processed parameter.
	Use it to save three bytes per use.

	qemuDomainSetSchedulerParametersFlags: use the value_ul variable
	We assign the unsigned long value of the currently processed
	parameter to a temporary value_ul variable. Use it consistently
	in all cases.

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	Prevent more compiler optimization of mockable functions
	Currently all mockable functions are annotated with the 'noinline'
	attribute. This is insufficient to guarantee that a function can
	be reliably mocked with an LD_PRELOAD. The C language spec allows
	the compiler to assume there is only a single implementation of
	each function. It can thus do things like propagating constant
	return values into the caller at compile time, or creating
	multiple specialized copies of the function body each optimized
	for a different caller. To prevent these optimizations we must
	also set the 'noclone' and 'weak' attributes.

	This fixes the test suite when libvirt.so is built with CLang
	with optimization enabled.

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	Remove incorrectly used TODO macro
	The TODO macro expands to an fprintf() call and is used in several
	places in the Xen driver. Anything that wishes to print such debug
	messages should use the logging macros. In this case though, all the
	places in the Xen driver should have been raising a formal libvirt
	error instead. Add proper error handling and delete the TODO macro
	to prevent future misuse.

	Remove network constants out of internal.h
	The HOST_NAME_MAX, INET_ADDRSTRLEN and VIR_LOOPBACK_IPV4_ADDR
	constants are only used by a handful of files, so are better
	kept in virsocketaddr.h or the source file that uses them.

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	Require use of GCC 4.4 or CLang compilers
	We only ever test libvirt with GCC or CLang which provides a
	GCC compatible compilation environment. Between them, these
	compilers cover every important operating system platform,
	even Windows.

	Mandate their use to make it explicit that we don't care about
	compilers like Microsoft VCC or other UNIX vendor C compilers.

	GCC 4.4 was picked as the baseline, since RHEL-6 ships 4.4.7
	and that lets us remove a large set of checks. There is a slight
	issue that CLang reports itself as GCC 4.2, so we must also check
	if __clang__ is defined. We could check a particular CLang version
	too, but that would require someone to figure out a suitable min
	version which is fun because OS-X reports totally different CLang
	version numbers from CLang builds on Linux/BSD

2017-07-11  Daniel P. Berrange  <berrange@redhat.com>

	Remove duplicate define of __GNUC_PREREQ
	Back in this commit:

	  commit b436a8ae5ccb04f8cf893d882d52ab5efc713307
	  Author: Fabian Freyer <fabian.freyer@physik.tu-berlin.de>
	  Date:   Thu Jun 9 00:50:35 2016 +0000

	    gnulib: add getopt module

	config-post.h was modified to define __GNUC_PREREQ, but the
	original definition was never removed from internal.h, and
	that is now dead code since config.h is always the first file
	included.

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemu ns: Create chardev backends more frequently
	Currently, the only type of chardev that we create the backend
	for in the namespace is type='dev'. This is not enough, other
	backends might have files under /dev too. For instance channels
	might have a unix socket under /dev (well, bind mounted under
	/dev from a different place).

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainAttachDeviceMknodRecursive: Support file mount points
	https://bugzilla.redhat.com/show_bug.cgi?id=1462060

	Just like in the previous commit, when attaching a file based
	device which has its source living under /dev (that is not a
	device rather than a regular file), calling mknod() is no help.
	We need to:

	1) bind mount device to some temporary location
	2) enter the namespace
	3) move the mount point to desired place
	4) umount it in the parent namespace from the temporary location

	At the same time, the check in qemuDomainNamespaceSetupDisk makes
	no longer sense. Therefore remove it.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainCreateDeviceRecursive: Support file mount points
	https://bugzilla.redhat.com/show_bug.cgi?id=1462060

	When building a qemu namespace we might be dealing with bare
	regular files. Files that live under /dev. For instance
	/dev/my_awesome_disk:

	  <disk type='file' device='disk'>
	    <driver name='qemu' type='qcow2'/>
	    <source file='/dev/my_awesome_disk'/>
	    <target dev='vdc' bus='virtio'/>
	  </disk>

	  # qemu-img create -f qcow2 /dev/my_awesome_disk 10M

	So far we were mknod()-ing them which is
	obviously wrong. We need to touch the file and bind mount it to
	the original:

	1) touch /var/run/libvirt/qemu/fedora.dev/my_awesome_disk
	2) mount --bind /dev/my_awesome_disk /var/run/libvirt/qemu/fedora.dev/my_awesome_disk

	Later, when the new /dev is built and replaces original /dev the
	file is going to live at expected location.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainAttachDeviceMknodHelper: Fail on unsupported file type
	Currently, we silently assume that file we are creating in the
	namespace is either a link or a device (character or block one).
	This is not always the case. Therefore instead of doing something
	wrong, claim about unsupported file type.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainCreateDeviceRecursive: Fail on unsupported file type
	Currently, we silently assume that file we are creating in the
	namespace is either a link or a device (character or block one).
	This is not always the case. Therefore instead of doing something
	wrong, claim about unsupported file type.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Move preserved mount points path generation into a separate function
	This function is going to be used on other places, so
	instead of copying code we can just call the function.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainBuildNamespace: Handle special file mount points
	https://bugzilla.redhat.com/show_bug.cgi?id=1459592

	In 290a00e41d I've tried to fix the process of building a
	qemu namespace when dealing with file mount points. What I
	haven't realized then is that we might be dealing not with just
	regular files but also special files (like sockets). Indeed, try
	the following:

	1) socat unix-listen:/tmp/soket stdio
	2) touch /dev/socket
	3) mount --bind /tmp/socket /dev/socket
	4) virsh start anyDomain

	Problem with my previous approach is that I wasn't creating the
	temporary location (where mount points under /dev are moved) for
	anything but directories and regular files.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	conf: Rename and expose virDomainChrSourceDefPath
	It comes very handy to have source path for chardevs. We already
	have such function: virDomainAuditChardevPath() but it's static
	and has name not suitable for exposing. Moreover, while exposing
	it change its name slightly to virDomainChrSourceDefGetPath.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	tests: virjson: Reuse VIR_TEST_VERBOSE in testJSONCopy
	Use VIR_TEST_VERBOSE instead of calling virTestGetVerbose and
	conditionally fprintf. Additionally remove redundant setting of 'ret' to
	-1.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	tests: Validate that JSON deflattening fixed nested json pseudo-protocol strings
	Sheepdog and possibly others use nested objects for network server and
	thus could be specified in a way that libvirt would not parse.

	Validates that https://bugzilla.redhat.com/show_bug.cgi?id=1464821
	is fixed properly.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Always deflatten JSON pseudo-protocol objects
	Now that the JSON deflattener is working sanely we can always attempt
	the deflattening so that we can then parse the tree as expected.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	util: json: Recursively deflatten objects virJSONValueObjectDeflatten
	If a value of the first level object contains more objects needing
	deflattening which would be wrapped in an actual object the function
	would not recurse into them.

	By this simple addition we can fully deflatten the objects.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	util: json: Properly implement JSON deflattening
	As it turns out sometimes users pass in an arbitrarily nested structure
	e.g. for the qemu backing chains JSON pseudo protocol. This new
	implementation deflattens now a single object fully even with nested
	keys.

	Additionally it's not necessary now to stick with the "file." prefix for
	the properties.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	tests: json: Add test for the deflattening function
	Add a few test cases to verify that the old behaviour does not break and
	that new one behaves sanely.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	util: json: Don't remove the 'file' subobject when deflattening
	Currently the function would deflatten the object by dropping the 'file'
	prefix from the attributes. This does not really scale well or adhere to
	the documentation.

	Until we refactor the worker to properly deflatten everything we at
	least simulate it by adding the "file" wrapper object back.

2017-07-11  Peter Krempa  <pkrempa@redhat.com>

	util: Move JSON object deflattening code to json utility file
	The code will become more universal so it makes more sense for it to
	live with the rest of the JSON functions.

	util: json: Add virJSONValueIsObject
	Allows testing whether a virJSONValue is an object.

	tests: Rename jsontest to virjsontest

2017-07-11  Cédric Bosdonnat  <cbosdonnat@suse.com>

	lxc: add possibility to define init uid/gid
	Users may want to run the init command of a container as a special
	user / group. This is achieved by adding <inituser> and <initgroup>
	elements. Note that the user can either provide a name or an ID to
	specify the user / group to be used.

	This commit also fixes a side effect of being able to run the command
	as a non-root user: the user needs rights on the tty to allow shell
	job control.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-11  Cédric Bosdonnat  <cbosdonnat@suse.com>

	lxc: allow user to specify command working directory
	Some containers may want the application to run in a special directory.
	Add <initdir> element in the domain configuration to handle this case
	and use it in the lxc driver.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-11  Cédric Bosdonnat  <cbosdonnat@suse.com>

	util: share code between virExec and virCommandExec
	virCommand is a version of virExec that doesn't fork, however it is
	just calling execve and doesn't honors setting uid/gid and pwd.

	This commit extrac those pieces from virExec() to a virExecCommon()
	function that is called from both virExec() and virCommandExec().

2017-07-11  Cédric Bosdonnat  <cbosdonnat@suse.com>

	lxc: allow defining environment variables
	When running an application container, setting environment variables
	could be important.

	The newly introduced <initenv> tag in domain configuration will allow
	setting environment variables to the init program.

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	virStream*All: Report error if a callback fails
	All of these four functions (virStreamRecvAll, virStreamSendAll,
	virStreamSparseRecvAll, virStreamSparseSendAll) take one or more
	callback functions that handle various aspects of streams.
	However, if any of them fails no error is reported therefore
	caller does not know what went wrong.

	At the same time, we silently presumed callbacks to set errno on
	failure. With this change we should document it explicitly as the
	error is not properly reported.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	virStream*All: Preserve reported error
	If one these four functions fail (virStreamRecvAll,
	virStreamSendAll, virStreamSparseRecvAll, virStreamSparseSendAll)
	the stream is aborted by calling virStreamAbort(). This is  a
	public API; therefore, the first thing it does is error reset. At
	that point any error that caused us to abort stream in the first
	place is gone.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	virStream*All: Call virStreamAbort() more frequently
	Our documentation to the virStreamRecvAll, virStreamSendAll,
	virStreamSparseRecvAll, and virStreamSparseSendAll functions
	indicates that if these functions fail, then virStreamAbort is
	called. But that is not necessarily true. For instance all of
	these functions allocate a buffer to work with. If the allocation
	fails, no virStreamAbort() is called despite -1 being returned.
	It's the same story with argument sanity checks and a lot of
	other checks.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	fdstream: Report error from the I/O thread
	Problem with our error reporting is that the error object is a
	thread local variable. That means if there's an error reported
	within the I/O thread it gets logged and everything, but later
	when the event loop aborts the stream it doesn't see the original
	error. So we are left with some generic error. We can do better
	if we copy the error message between the threads.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Michal Privoznik  <mprivozn@redhat.com>

	virfdstream: Check for thread error more frequently
	When the I/O thread quits (e.g. due to an I/O error, lseek()
	error, whatever), any subsequent virFDStream API should return
	error too. Moreover, when invoking stream event callback, we must
	set the VIR_STREAM_EVENT_ERROR flag so that the callback knows
	something bad happened.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: Rename SupportsChardev to IsPlatformDevice
	This is only used in qemu_command.c, so move it, and clarify that
	it's really about identifying if the serial config is a platform
	device or not.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: command: support -chardev for platform devices
	Some qemu arch/machine types have built in platform devices that
	are always implicitly available. For platform serial devices, the
	current code assumes that only old style -serial config can be
	used for these devices.

	Apparently though since -chardev was introduced, we can use -chardev
	in these cases, like this:

	  -chardev pty,id=foo
	  -serial chardev:foo

	Since -chardev enables all sorts of modern features, use this method
	for platform devices.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: caps: blacklist QEMU_CAPS_CHARDEV
	Every qemu version we support has QEMU_CAPS_CHARDEV, so stop
	explicitly tracking it and blacklist it like we've done for many
	other feature flags.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	tests: qemuxml2argv: Add some QEMU_CAPS_CHARDEV annotations
	Several tests are intending to test some serial/console related
	bits but aren't setting QEMU_CAPS_CHARDEV. This will soon be enabled
	unconditionally so let's add it ahead of time.

	* q35-virt-manager-basic: Intended to test a virt-manager q35 config,
	    which will include a serial/console device
	* console-compat*: console/serial XML compat handling
	* bios: Needs a serial device for sgabios CLI

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	tests: qemuxml2argv: Drop old style serial testing
	These tests are exercising old style -serial command lines. That
	code will soon be removed, so drop these tests.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	tests: qemuxml2argv: drop redundant serial testing
	Several cases have incidental <serial> or <console> XML which aren't
	the features being tested for. Upcoming changes will cause some
	churn here, so instead drop these bits now.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: command: always use -chardev for monitor config
	AFAIK there aren't any cases where we will/should hit the old code
	path for our supported qemu versions, so drop the old code.

	Massive test suite churn follows

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: command: Drop some QEMU_CAPS_CHARDEV checks
	AFAIK there aren't any cases where we should fail these checks with
	supported qemu versions, so just drop them.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: command: Remove old style -parallel building
	AFAIK there aren't any qemu arch/machine types with platform parallel
	devices that would require old style -parallel config, so we shouldn't
	ever need this nowadays.

	Remove a now redundant test

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	tests: qemuxml2argv: Add an aarch64 pci-serial test
	This demonstrates that the previous qemu caps changes will use
	-chardev for pci-serial on aarch64 machvirt

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-11  Cole Robinson  <crobinso@redhat.com>

	qemu: caps: Tweak arm conditional in SupportsChardev
	Rather than try to whitelist all device configs that can't use
	-chardev, blacklist the only one that really can't, which is the
	default serial/console target type=isa case.

	ISA specifically isn't a valid config for arm/aarch64, but we've
	always implicitly treated it to mean 'default platform device'.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-10  Scott Garfinkle  <seg@us.ibm.com>

	Use unsigned timeout in cmdMigrateSetMaxDowntime
	While looking to implement a migrate-getmaxdowntime command (coming),
	I noticed that the setmaxdowntime is incorrectly looking at its
	parameter as a signed longlong. Not sure how that got past gcc, but
	here's a simple patch to make the command line parsing and the parameter to
	the worker functions all have the correct (unsigned) type.

2017-07-10  Francesc Guasch  <frankie@etsetb.upc.edu>

	docs: add entry for Ravada to apps page

2017-07-10  Martin Kletzander  <mkletzan@redhat.com>

	docs: Properly quote self uri in search.php
	This removes the classical XSS vulnerability of using unquoted
	PHP_SELF.

	Reported-by: John Lightsey <john@nixnuts.net>

2017-07-10  Peter Krempa  <pkrempa@redhat.com>

	qemu: domain: Use vcpu 'node-id' property and pass it back to qemu
	vcpu properties gathered from query-hotpluggable cpus need to be passed
	back to qemu. As qemu did not use the node-id property until now and
	libvirt forgot to pass it back properly (it was parsed but not passed
	around) we did not honor this.

	This patch adds node-id to the structures where it was missing and
	passes it around as necessary.

	The test data was generated with a VM with following config:
	    <numa>
	      <cell id='0' cpus='0,2,4,6' memory='512000' unit='KiB'/>
	      <cell id='1' cpus='1,3,5,7' memory='512000' unit='KiB'/>
	    </numa>

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1452053

2017-07-10  Pino Toscano  <ptoscano@redhat.com>

	configure: fix typo in nss error message
	This error message refers to the lack of network, not to yajl.

2017-07-10  Julio Faracco  <jcfaracco@gmail.com>

	tools: virsh: domdisplay command is not freeing the domain pointer
	The command 'domdisplay' is not freeing the domain pointer properly in
	cleanup section. See the error below:

	virsh # domdisplay WINDOWS7
	vnc://127.0.0.1:0

	virsh # quit

	error: One or more references were leaked after disconnect from the hypervisor

	Valgrind report:

	==29168== 66 (56 direct, 10 indirect) bytes in 1 blocks are definitely lost in loss record 154 of 239
	==29168==    at 0x4C2FB55: calloc (in /usr/lib/valgrind/vgpreload_memcheck-amd64-linux.so)
	==29168==    by 0x5505324: virAllocVar (viralloc.c:560)
	==29168==    by 0x555A61B: virObjectNew (virobject.c:199)
	==29168==    by 0x561F367: virGetDomain (datatypes.c:284)
	==29168==    by 0x5680979: get_nonnull_domain (remote_driver.c:8143)
	==29168==    by 0x5680979: remoteDomainLookupByName (remote_client_bodies.h:3047)
	==29168==    by 0x5623D9A: virDomainLookupByName (libvirt-domain.c:425)
	==29168==    by 0x160480: virshLookupDomainInternal (virsh-util.c:59)
	==29168==    by 0x160547: virshCommandOptDomainBy (virsh-util.c:98)
	==29168==    by 0x13D3A9: cmdDomDisplay (virsh-domain.c:10963)
	==29168==    by 0x165680: vshCommandRun (vsh.c:1327)
	==29168==    by 0x12E320: main (virsh.c:953)

2017-07-10  Julio Faracco  <jcfaracco@gmail.com>

	tests: virstringtest: adding tests to virStrToDouble()
	There are no occurrences of tests related to Strings and Double numbers
	inside virstringtest.c. This commit introduces some tests to validate the
	conversion. The test does not include locale changes yet.

2017-07-08  Sri Ramanujam  <sramanujam@datto.com>

	news: Update news for new Hyper-V APIs

	hyperv: Add support for virDomainSetMemory
	Introduces support for virDomainSetMemory. This also serves an an
	example for how to use the new method invocation API with a more
	complicated method, this time including an EPR and embedded param.

	hyperv: support virDomainSendKey
	This commit adds support for virDomainSendKey. It also serves as an
	example of how to use the new method invocation APIs with a single
	"simple" type parameter.

	hyperv: add hypervInvokeMethod
	This commit adds support for invoking methods on remote objects
	via hypervInvokeMethod.

2017-07-08  Sri Ramanujam  <sramanujam@datto.com>

	hyperv: Generate object property type information
	Update the generator to generate basic property type information for
	each CIM object representation. Right now, it generates arrays of
	hypervCimType structs:

	struct _hypervCimType {
	    const char *name;
	    const char *type;
	    bool isArray;
	};

2017-07-08  Sri Ramanujam  <sramanujam@datto.com>

	hyperv: Functions to work with invocation parameters
	This commit introduces functionality for creating and working with
	invoke parameters. This commit does not include any code for serializing
	and actually performing the method invocations; it merely defines the
	functions and API for using invocation parameters in driver code.

	HYPERV_DEFAULT_PARAM_COUNT was chosen because almost no method
	invocations have more than 4 parameters.

	Functions added:
	* hypervInitInvokeParamsList
	* hypervFreeInvokeParams
	* hypervAddSimpleParam
	* hypervAddEprParam
	* hypervCreateEmbeddedParam
	* hypervSetEmbeddedProperty
	* hypervAddEmbeddedParam
	* hypervFreeEmbeddedParam

2017-07-07  Peter Krempa  <pkrempa@redhat.com>

	qemu: domain: Add missing newline to last element in status XML formatter
	Commit f9758109a7 did not put a newline after the element it added.

2017-07-05  Daniel P. Berrange  <berrange@redhat.com>

	docs: add entry to download table listing the Rust language binding
	Reviewed-by: John Ferlan <jferlan@redhat.com>

	Improve logging of shutdown inhibitor
	The log category for virnetdaemon.c was mistakenly set
	to rpc.netserver. Some useful info about the inhibitor
	file descriptor was also never logged.

2017-07-05  Daniel P. Berrange  <berrange@redhat.com>

	Fix conditional check for DBus
	The DBus conditional was renamed way back:

	  commit da77f04ed5fa0731d50b947be8c739bdbf8121ad
	  Author: Daniel P. Berrange <berrange@redhat.com>
	  Date:   Thu Sep 20 15:05:39 2012 +0100

	    Convert HAVE_DBUS to WITH_DBUS

	but the shutdown inhibit code was not updated. Thus libvirt
	was never inhibiting shutdown by a logged in user when VMs
	are running.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-07-05  John Ferlan  <jferlan@redhat.com>

	Post-release version bump to 3.6.0

2017-07-05  Daniel Veillard  <veillard@redhat.com>

	Release of libvirt-3.5.0
	* docs/news.xml: update
	* po/*.po* : regenerated

2017-07-04  Peter Krempa  <pkrempa@redhat.com>

	lib: Remove misplaced and redundant comments
	It's obvious that unsigned long long is 64 bit and also our web page
	generator would misplace the comment after the return value due to the
	way it's parsing them.

2017-07-04  Pavel Hrdina  <phrdina@redhat.com>

	news: CPU add migration fix into Bug fixes
	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-07-04  Andrea Bolognani  <abologna@redhat.com>

	news: Update for 3.5.0 release
	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-30  Martin Kletzander  <mkletzan@redhat.com>

	news: Add CAT capability information into improvements

	news: Add live coalesce settings to new features

2017-06-29  Mikhail Feoktistov  <mfeoktistov@virtuozzo.com>

	vz: nseclabels member is moved to virDomainChrSourceDef struct

	vz: add argument xmlopt for virDomainDefCheckABIStability call

2017-06-29  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	docs: Document bhyve's vgaconf support
	 - Add a news entry
	 - Update driver's page with information about the new
	   vgaconf attribute and provide usage example; while here,
	   fix a grammar mistake

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-06-28  Peter Krempa  <pkrempa@redhat.com>

	docs: news: Add entries for my recent changes

	util: netdevbridge: Refactor error handling in virNetDevBridgeCreate
	Replace the switch statement with a simpler if statement. This also
	removes the fallthrough path that coverity was complaining about.

2017-06-28  John Ferlan  <jferlan@redhat.com>

	hotplug: Create helper to remove vport
	Combine and "clean up" a bit two places that are removing the vport

	nodedev: Add check for NULL obj before call Unlock
	Commit id '95ea171b' was a bit too aggressive in removing the if (obj)
	check since cleanup is reachable after Unlock and obj = NULL.

2017-06-28  Peter Krempa  <pkrempa@redhat.com>

	qemu: hotplug: Disallow modification of vcpu 0 in inactive config
	vcpu 0 must be always enabled and non-hotpluggable, thus you can't
	modify it using the vcpu hotplug APIs. Disallow it so that users can't
	create invalid configurations.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1459785

2017-06-28  Lily Zhu  <lizhu@redhat.com>

	man: Fix documentation errors about the paths of the config files
	The default conf files, for example libvirtd.conf, virtlockd.conf, and
	virtlogd.conf, should be located under the directory "/etc/libvirt" when
	root as root, rather than "/etc". When run as non-root, the configuration
	files should be located under "$XDG_CONFIG_HOME/libvirt/", rather than
	"XDG_CONFIG_HOME".

2017-06-28  Martin Kletzander  <mkletzan@redhat.com>

	docs: Add callback-related info to virStream{Abort,Finish}
	When one has a non-blocking stream and aborts or finishes it without
	removing the callback, any event loop invocation will trigger that
	callback, but it cannot be removed any more.  We cannot remove the
	callback automatically from virStream{Abort,Finish} functions due to
	forward-compatibility.  So let's at least document this behaviour,
	because it is not easy to find out the reason for.

2017-06-28  Daniel Liu  <srwx4096@gmail.com>

	virsh: Fix --help problem for domxml-to-native DOMAIN COMMAND
	Resolves a bug in domxml-to-native command option, so that the
	following command displays the help information correctly:
	'virsh domxml-to-native --help'.

2017-06-27  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	bhyve: add vga configuration for video driver
	Add support for vgaconf driver configuration. In domain xml it looks like
	this:

	  <video>
	    <driver vgaconf='io|on|off'>
	    <model .../>
	  </video>

	It was added with bhyve gop video in mind to allow users control how the
	video device is exposed to the guest, specifically, how VGA I/O is
	handled.

	One can refer to the bhyve manual page to get more detailed description
	of the possible VGA configuration options:

	https://www.freebsd.org/cgi/man.cgi?query=bhyve&manpath=FreeBSD+12-current

	The relevant part could be found using the 'vgaconf' keyword.

	Also, add some tests for this new feature.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-27  Cole Robinson  <crobinso@redhat.com>

	Revert "qemu: Support chardevs with ARM virt machines"
	This reverts commit 70c9b44270f75bfb7a5701d81aa49380d139e8f0.

	This commit breaks existing aarch64 machvirt configs with:

	    <serial type='pty'>
	      <target port='0'/>
	    </serial>
	    <console type='pty'>
	      <target type='serial' port='0'/>
	    </console>

	Which fails with:

	error: Failed to start domain fedora25-aarch64
	error: internal error: process exited while connecting to monitor:
	2017-06-26T13:55:34.726293Z qemu-system-aarch64: -chardev pty,id=charserial0:
	char device redirected to /dev/pts/5 (label charserial0)
	2017-06-26T13:55:34.782121Z qemu-system-aarch64: -device
	isa-serial,chardev=charserial0,id=serial0: No 'ISA' bus found for device
	'isa-serial'

2017-06-27  Andrea Bolognani  <abologna@redhat.com>

	conf: Copy loadparm in virDomainDeviceInfoCopy()
	Commit 54fa1b44afc8 added virDomainDeviceInfo::loadparm
	and updated virDomainDeviceInfoClear() accordingly, but
	omitted the necessary virDomainDeviceInfoCopy() changes.

2017-06-26  Andrea Bolognani  <abologna@redhat.com>

	HACKING: Drop from the git repository
	Despite being a generated file, HACKING has been tracked in
	the git repository along with actual source files. As far as
	I'm aware, it's the only generated file for which that happens.

	Times and times again, people[1] have committed changes to
	the source file without refreshing the generated copy at the
	same time.

	The rationale for tracking the generated file is to help out
	people who just cloned the git repository looking to contribue;
	however, README-hacking already contains enough information to
	get perspective contributors to a place where they can simply
	look at docs/hacking.html instead.

	[1] Mostly me, to be honest

2017-06-26  Andrea Bolognani  <abologna@redhat.com>

	README: Remove 'git send-email' mention
	The use of 'git send-email' is described in detail in the
	contributor guidelines (docs/hacking.html), which are
	mentioned in docs/contribute.html, the non-local version
	of which is in turn mentioned in README.

	README: Various minor style tweaks

	docs: Point to hacking.html from contribute.html
	People looking to help out should really go through the
	contributor guidelines when getting started, so the more
	documents point to them the better.

2017-06-26  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Avoid fd leak on incoming tunneled migration
	While qemuProcessIncomingDefNew takes an fd argument and stores it in
	qemuProcessIncomingDef structure, the caller is still responsible for
	closing the file descriptor.

	Introduced by commit v1.2.21-140-ge7c6f4575.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-26  Andrea Bolognani  <abologna@redhat.com>

	README: Remove unnecessary empty line

2017-06-26  Martin Kletzander  <mkletzan@redhat.com>

	util: Extract locale-related fixes into separate functions

2017-06-26  Andrea Bolognani  <abologna@redhat.com>

	HACKING: Refresh after changes to source file
	Commit 79c1900fc1eb changed docs/hacking.html.in, but *of
	course* I forgot once again to update the text-only version
	of the file at the same time.

2017-06-26  Andrea Bolognani  <abologna@redhat.com>

	hacking: Improve 'git send-email' documentation
	For the benefit of first time contributors, we point out that 'git
	send-email' might have to be installed separately; however, we omit
	the fact that some configuration will likely be needed before it
	can successfully deliver patches to the mailing list.

	Some minor tweaks to the existing contents are included as well.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-25  Michal Privoznik  <mprivozn@redhat.com>

	qemuMonitorTextAddDrive: Fail on unrecognized disk format
	Since qemu commit 3ef6c40ad0b it can fail if trying to hotplug a
	disk that is not qcow2 despite us saying it is. We need to error
	out in that case.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-25  John Ferlan  <jferlan@redhat.com>

	events: Avoid double free possibility on remote call failure
	If a remote call fails during event registration (more than likely from
	a network failure or remote libvirtd restart timed just right), then when
	calling the virObjectEventStateDeregisterID we don't want to call the
	registered @freecb function because that breaks our contract that we
	would only call it after succesfully returning.  If the @freecb routine
	were called, it could result in a double free from properly coded
	applications that free their opaque data on failure to register, as seen
	in the following details:

	    Program terminated with signal 6, Aborted.
	    #0  0x00007fc45cba15d7 in raise
	    #1  0x00007fc45cba2cc8 in abort
	    #2  0x00007fc45cbe12f7 in __libc_message
	    #3  0x00007fc45cbe86d3 in _int_free
	    #4  0x00007fc45d8d292c in PyDict_Fini
	    #5  0x00007fc45d94f46a in Py_Finalize
	    #6  0x00007fc45d960735 in Py_Main
	    #7  0x00007fc45cb8daf5 in __libc_start_main
	    #8  0x0000000000400721 in _start

	The double dereference of 'pyobj_cbData' is triggered in the following way:

	    (1) libvirt_virConnectDomainEventRegisterAny is invoked.
	    (2) the event is successfully added to the event callback list
	        (virDomainEventStateRegisterClient in
	        remoteConnectDomainEventRegisterAny returns 1 which means ok).
	    (3) when function remoteConnectDomainEventRegisterAny is hit,
	        network connection disconnected coincidently (or libvirtd is
	        restarted) in the context of function 'call' then the connection
	        is lost and the function 'call' failed, the branch
	        virObjectEventStateDeregisterID is therefore taken.
	    (4) 'pyobj_conn' is dereferenced the 1st time in
	        libvirt_virConnectDomainEventFreeFunc.
	    (5) 'pyobj_cbData' (refered to pyobj_conn) is dereferenced the
	         2nd time in libvirt_virConnectDomainEventRegisterAny.
	    (6) the double free error is triggered.

	Resolve this by adding a @doFreeCb boolean in order to avoid calling the
	freeCb in virObjectEventStateDeregisterID for any remote call failure in
	a remoteConnect*EventRegister* API. For remoteConnect*EventDeregister* calls,
	the passed value would be true indicating they should run the freecb if it
	exists; whereas, it's false for the remote call failure path.

	Patch based on the investigation and initial patch posted by
	fangying <fangying1@huawei.com>.

2017-06-25  Christoffer Dall  <cdall@linaro.org>

	qemu: Support chardevs with ARM virt machines
	The function to check if -chardev is supported by QEMU was written a
	long time ago, where adding chardevs did not make sense on the fixed ARM
	platforms.  Since then, we now have a general purpose virt platform,
	which should support plugging in any device over PCIe which is supported
	in a similar fashion on x86.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-06-24  Daniel Liu  <srwx4096@gmail.com>

	virsh: add [--domain DOMAIN] option to domxml-to-native DOMAIN COMMAND
	The option allows someone to run domain-to-native on already existing
	domain without the need of supplying their XML.  It is basically
	wrapper around 'virsh dumpxml  | virsh domxml-to-native /dev/stdin'.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=835476
	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>
	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-24  John Ferlan  <jferlan@redhat.com>

	util: Force reading of meta data to get encryption capacity value
	https://bugzilla.redhat.com/show_bug.cgi?id=1371892

	As it turns out the volume create, build, and refresh path was not peeking
	at the meta data, so immediately after a create operation the value displayed
	for capacity was still incorrect. However, if a pool refresh was done the
	correct value was fetched as a result of a meta data peek.

	The reason is it seems historically if the file type is RAW then peeking
	at the file just took the physical value for the capacity. However, since
	we know if it's an encrypted file, then peeking at the meta data will be
	required in order to get a true capacity value.

	So check for encryption in the source and if present, use the meta data
	in order to fill in the capacity value and set the payload_offset.

2017-06-23  Peter Krempa  <pkrempa@redhat.com>

	tests: hotplug: Test disks with duplicate WWNs

2017-06-23  Peter Krempa  <pkrempa@redhat.com>

	Revert "qemu: Check duplicate WWNs also for hotplugged disks"
	Similarly to commit 5da28cc3069b573f54f0bcaf8eb75476bcfdc6e9 this check
	actually does not make sense since duplicate WWNs are used e.g. when
	multipathing disks.

	This reverts commit 780fe4e4baf7e2f10f65ba1a34f9274fc547cad2.

2017-06-23  Michal Privoznik  <mprivozn@redhat.com>

	virNetDevOpenvswitchInterfaceStats: Be more forgiving when fetching stats
	https://bugzilla.redhat.com/show_bug.cgi?id=1461270

	When fetching stats for a vhost-user type of interface, we run
	couple of ovs-vsctl commands and parse their output. However, not
	all stats exist at all times, for instance "rx_dropped" or
	"tx_errors" can be missing. Thing is, we ask for a bulk of
	statistics and if one of them is missing an error is reported
	instead of returning the rest. Since we ignore errors, we fail to
	set statistics. Fix this by asking for each piece alone.

2017-06-22  John Ferlan  <jferlan@redhat.com>

	util: Introduce virObjectGetLockableObj
	Split out the object fetch in virObject{Lock|Unlock} into a helper

	util: Formatting cleanups to virobject API
	Alter to use more recent formatting guidelines

2017-06-22  Martin Kletzander  <mkletzan@redhat.com>

	util: Move locale.h include from virutil to virstring
	Commit 5c54d29aaeb7 forgot to do that when moving the only function
	using it and it broke the build on some platforms.

2017-06-22  Michal Privoznik  <mprivozn@redhat.com>

	security: Don't skip relabel for all chardevs
	Our commit e13e8808f9 was way too generic. Currently, virtlogd is
	used only for chardevs type of file and nothing else. True, we
	must not relabel the path in this case, but we have to in all
	other cases. For instance, if you want to have a physical console
	attached to your guest:

	    <console type='dev'>
	      <source path='/dev/ttyS0'/>
	      <target type='virtio' port='1'/>
	    </console>

	Starting such domain fails because qemu doesn't have access to
	/dev/ttyS0 because we haven't relabelled the path.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-22  Julio Faracco  <jcfaracco@gmail.com>

	util: fix locale problem with virStrToDouble().
	This commit fixes a locale problem with locales that use comma as a mantissa
	separator. Example: 12.34 en_US = 12,34 pt_BR. Since strtod() is a non-safe
	function, virStrToDouble() will have problems to parse double numbers from
	kernel settings and other double numbers from static files (XMLs, JSONs, etc).

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1457634
	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1457481

2017-06-22  Julio Faracco  <jcfaracco@gmail.com>

	util: moving virDoubleToStr() from virutil to virstring.
	The function virDoubleToStr() is defined in virutil.* and virStrToDouble() is
	defined in virstring.*. Joining both functions into the same file makes more
	sense.

2017-06-22  Cole Robinson  <crobinso@redhat.com>

	tests: virstoragetest: fix --without-yajl
	Recently added JSON tests should be skipped if compiled --without-yajl

	https://bugzilla.redhat.com/show_bug.cgi?id=1463435

2017-06-21  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Do not skip virCPUUpdateLive if priv->origCPU is set
	Even though we got both the original CPU (used for starting a domain)
	and the updated version (the CPU really provided by QEMU) during
	incoming migration, restore, or snapshot revert, we still need to update
	the CPU according to the data we got from the freshly started QEMU.
	Otherwise we don't know whether the CPU we got from QEMU matches the one
	before migration. We just need to keep the original CPU in
	priv->origCPU.

	Messed up by me in v3.4.0-58-g8e34f4781.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-21  Michal Privoznik  <mprivozn@redhat.com>

	qemuProcessBuildDestroyHugepagesPath: Don't warn on destroying non-existent path
	This function is called unconditionally from qemuProcessStop to
	make sure we leave no dangling dirs behind. However, whenever the
	directory we want to rmdir() is not there (e.g. because it hasn't
	been created in the first place because domain doesn't use
	hugepages at all), we produce a warning like this:

	2017-06-20 15:58:23.615+0000: 32638: warning :
	qemuProcessBuildDestroyHugepagesPath:3363 : Unable to remove
	hugepage path: /dev/hugepages/libvirt/qemu/1-instance-00000001
	(errno=2)

	Fix this by not producing the warning on ENOENT.

	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>

2017-06-21  Martin Kletzander  <mkletzan@redhat.com>

	qemu: Change coalesce settings on hotplug when they are different
	Part of the condition was reverted so no value update was propagated
	through.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1414627

2017-06-21  Peter Krempa  <pkrempa@redhat.com>

	qemu: capabilities: Move comments separating groups of capabilities
	Similarly to how we specify the groups of 5 capabilities in the header
	file move the labels to separate line also for the VIR_ENUM_IMPL part.

	This simplifies rebase conflict resolution in the capability file since
	only lines have to be shuffled around, but they don't need to be edited.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Make @backingFormat optional in virStorageFileGetMetadataInternal
	Some callers don't need to know the backing format. Make the argument
	optional by using a dummy int if NULL is passed.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: snapshot: Load data necessary for relative block commit to work
	Commit 7456c4f5f introduced a regression by not reloading the backing
	chain of a disk after snapshot. The regression was caused as
	src->relPath was not set and thus the block commit code could not
	determine the relative path.

	This patch adds code that will load the backing store string if
	VIR_DOMAIN_SNAPSHOT_CREATE_REUSE_EXT and store it in the correct place
	when a snapshot is successfully completed.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1461303

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	storage: Add helper to retrieve the backing store string of a storage volume
	It is necessary for some parts of the code to refresh just data
	based on the based on the backing store string. Add a convenience
	function that will retrieve this data.

	util: storage: Export virStorageIsRelative

	qemu: block commit: Don't overwrite error when rolling back disk labels
	Calls to qemuDomainDiskChainElementPrepare resets the original error,
	thus we need to save it in the cleanup path of qemuDomainBlockCommit.

	qemu: block commit: Determine relative path of images before initializing
	Changing labelling of the images does not need to happen after setting
	the labeling and lock manager access. This saves the cleanup of the
	labeling if the relative path can't be determined.

2017-06-20  Farhan Ali  <alifm@linux.vnet.ibm.com>

	news: Update news for loadparm feature

2017-06-20  Farhan Ali  <alifm@linux.vnet.ibm.com>

	qemu: Add loadparm to qemu command line string
	Check for the LOADPARM capabilility and potentially add a loadparm=x to
	the "-machine" string for the QEMU command line.

	Also add xml2argv test cases for loadparm.

	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
	Reviewed-by: Marc Hartmayer <mhartmay@linux.vnet.ibm.com>

2017-06-20  Farhan Ali  <alifm@linux.vnet.ibm.com>

	qemu: Introduce a new QEMU capability for -machine loadparm
	Add new capability for the "-machine loadparm" QEMU option.

	Add the capabilities replies/xml for s390x for QEMU 2.9.50.

2017-06-20  Farhan Ali  <alifm@linux.vnet.ibm.com>

	conf: Add loadparm boot option for a boot device
	Update the per device boot schema to add an optional loadparm parameter.

	eg: <boot order='1' loadparm='2'/>

	Extend the virDomainDeviceInfo to support loadparm option.
	Modify the appropriate functions to parse loadparm from boot device xml.
	Add the xml2xml test to validate the field.

	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
	Reviewed-by: Marc Hartmayer <mhartmay@linux.vnet.ibm.com>

2017-06-20  Ján Tomko  <jtomko@redhat.com>

	check the return value of qemuBuildVirtioOptionsStr
	Only qemuBuildFSDevStr missed the return check.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	util: storage: adapt to changes in JSON format for sheepdog
	Since qemu 2.9 the options changed from a monolithic string into fine
	grained options for the json pseudo-protocol object.

	util: storage: adapt to changes in JSON format for ssh
	Since qemu 2.9 the options changed from a monolithic string into fine
	grained options for the json pseudo-protocol object.

	util: storage: adapt to changes in JSON format for ceph/rbd
	Since qemu 2.9 the options changed from a monolithic string into fine
	grained options for the json pseudo-protocol object.

	util: storage: adapt to changes in JSON format for NBD
	Since 2.9 the host and port for NBD are no longer directly under the
	json pseudo-protocol object, but rather belong to a sub-object called
	'server'.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Add JSON parser for new options in iSCSI protocol
	Starting from qemu 2.9, more granular options are supported. Add parser
	for the relevant bits.

	With this patch libvirt is able to parse the host and target IQN of from
	the JSON pseudo-protocol specification.

	This corresponds to BlockdevOptionsIscsi in qemu qapi.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Report errors when source host data is missing
	Merge the reporting of the missing source host data into the parser
	functions so that callers don't have to do it separately.

	util: storage: Split out parsing of TCP network host from JSON pseudoprotocol
	Few backing protocols support only TCP. Split out the function which
	will correspond to parsing qemu's InetSocketAddressBase.

2017-06-20  Peter Krempa  <pkrempa@redhat.com>

	util: storage: Add support for type 'inet' in virStorageSourceParseBackingJSONSocketAddress
	'SocketAddress' structure was changed to contain 'inet' instead of
	'tcp' since qemu commit c5f1ae3ae7b. Existing entries have a backward
	compatibility layer.

	Libvirt will parse 'inet' and 'tcp' as equivalents.

2017-06-20  Andrea Bolognani  <abologna@redhat.com>

	qemu: Remove coverity[negative_returns] annotation
	It was added in commit 6c2e4c3856c8ed48c378bf1bf357cab46271a47a
	so that Coverity would not complain about passing -1 to
	qemuDomainDetachThisHostDevice(), but the function in question
	has changed since and so the annotation doesn't apply anymore.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-19  Peter Krempa  <pkrempa@redhat.com>

	util: storage: make virStorageSourceParseBackingJSONGlusterHost universal
	The same json strucutre is used for NBD and sheepdog volumes for
	specifying of the host. Rename the function and fix up error messages to
	be more universal.

	util: storage: Add missing return to virStorageSourceParseBackingJSONGluster
	If the number of servers is not expected the code would report an error
	but would not return failure.

	util: storage: Output parsed network backing store string to debug log

2017-06-19  Martin Kletzander  <mkletzan@redhat.com>

	qemu: Pass the number of heads even with -vga qxl
	When added in multiple previous commits, it was used only with -device
	qxl(-vga), but for some QEMUs (< 1.6) we need to add this
	functionality when using -vga qxl as well.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1283207

2017-06-16  Pavel Hrdina  <phrdina@redhat.com>

	security: don't relabel chardev source if virtlogd is used as stdio handler
	In the case that virtlogd is used as stdio handler we pass to QEMU
	only FD to a PIPE connected to virtlogd instead of the file itself.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1430988

	Reviewed-by: Martin Kletzander <mkletzan@redhat.com>

2017-06-16  Pavel Hrdina  <phrdina@redhat.com>

	qemu: propagate chardevStdioLogd to qemuBuildChrChardevStr
	Improve the code to decide whether to use virtlogd or not by checking
	the same variable that is updated in qemuProcessPrepareDomain().

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Pavel Hrdina  <phrdina@redhat.com>

	qemu: introduce chardevStdioLogd to qemu private data
	In QEMU driver we can use virtlogd as stdio handler for source backend
	of char devices if current QEMU is new enough and it's enabled in
	qemu.conf.  We should store this information while starting a guest
	because the config option may change while the guest is running.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Pavel Hrdina  <phrdina@redhat.com>

	conf: move seclabel for chardev source to the correct sturcture
	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainGetPreservedMounts: Fix suffixes for corner cases
	https://bugzilla.redhat.com/show_bug.cgi?id=1431112

	Imagine a FS mounted on /dev/blah/blah2. Our process of creating
	suffix for temporary location where all the mounted filesystems
	are moved is very simplistic. We want:

	/var/run/libvirt/qemu/$domName.$suffix\

	were $suffix is just the mount point path stripped of the "/dev/"
	prefix. For instance:

	/var/run/libvirt/qemu/fedora.mqueue  for /dev/mqueue
	/var/run/libvirt/qemu/fedora.pts     for /dev/pts

	and so on. Now if we plug /dev/blah/blah2 into the example we see
	some misbehaviour:

	/var/run/libvirt/qemu/fedora.blah/blah2

	Well, misbehaviour if /dev/blah/blah2 is a file, because in that
	case we call virFileTouch() instead of virFileMakePath().
	The solution is to replace all the slashes in the suffix with say
	dots. That way we don't have to care about nested directories.
	IOW, the result we want for given example is:

	/var/run/libvirt/qemu/fedora.blah.blah2

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainGetPreservedMounts: Prune nested mount points
	https://bugzilla.redhat.com/show_bug.cgi?id=1431112

	There can be nested mount points. For instance /dev/shm/blah can
	be a mount point and /dev/shm too. It doesn't make much sense to
	return the former path because callers preserve the latter (and
	with that the former too). Therefore prune nested mount points.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainBuildNamespace: Clean up temp files
	https://bugzilla.redhat.com/show_bug.cgi?id=1431112

	After 290a00e41d we know how to deal with file mount points.
	However, when cleaning up the temporary location for preserved
	mount points we are still calling rmdir(). This won't fly for
	files. We need to call unlink(). Now, since we don't really care
	if the cleanup succeeded or not (it's the best effort anyway), we
	can call both rmdir() and unlink() without need for
	differentiation between files and directories.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-16  Martin Kletzander  <mkletzan@redhat.com>

	Report more correct information for cache control
	On some platforms the number of bits in the cbm_mask might not be
	divisible by 4 (and not even by 2), so we need to properly count the
	bits.  Similar file, min_cbm_bits, is properly parsed and used, but if
	the number is greater than one, we lose the information about
	granularity when reporting the data in capabilities.  For that matter
	always report granularity, but if it is not the same as the minimum,
	add that information in there as well.

2017-06-16  Serge Hallyn  <serge.hallyn@ubuntu.com>

	apparmor, libvirt-qemu: Allow access to certificates used by libvirt-vnc
	When setting up VncTLS according to the official Libvirt documentation,
	only one certificate for libvirt/libvirt-vnc is used. The document
	indicates to use the following directories :

	 /etc/pki/CA
	 /etc/pki/libvirt
	 /etc/pki/libvirt/private

	in order to manage the certificates used by libvirt-vnc.

	Bug-Ubuntu: https://bugs.launchpad.net/bugs/901272

2017-06-16  Serge Hallyn  <serge.hallyn@ubuntu.com>

	apparmor, libvirt-qemu: Allow access to ceph config

2017-06-16  Stefan Bader  <stefan.bader@canonical.com>

	apparmor, libvirtd: Allow libxl-save-helper to run on Debian/Ubuntu
	On Debian/Ubuntu the libxl-save-helper (used when saving/restoring
	a domain through libxl) is located under /usr/lib/xen-<version>/bin.

	Bug-Ubuntu: https://bugs.launchpad.net/bugs/1334195

2017-06-16  Serge Hallyn  <serge.hallyn@ubuntu.com>

	apparmor, libvirt-qemu: Add ppc64el related changes
	Updates profile to allow running on ppc64el.

	Bug-Ubuntu: https://bugs.launchpad.net/bugs/1374554

2017-06-16  William Grant  <wgrant@ubuntu.com>

	apparmor, virt-aa-helper: Allow aarch64 UEFI.
	Allow access to aarch64 UEFI images.

	Acked-by: Guido Günther <agx@sigxcpu.org>

2017-06-16  Christian Ehrhardt  <christian.ehrhardt@canonical.com>

	virt-aa-helper: Generalize test for firmware paths
	This replaces individual tests for firmware locations by
	a generic function which will simplify having additional
	locations in the future.

2017-06-16  Simon McVittie  <smcv@debian.org>

	virt-aa-helper, apparmor: allow /usr/share/OVMF/ too
	The split firmware and variables files introduced by
	https://bugs.debian.org/764918 are in a different directory for
	some reason. Let the virtual machine read both.

2017-06-16  Martin Kletzander  <mkletzan@redhat.com>

	qemu: Allow live-updates of coalesce settings
	Change the settings from qemuDomainUpdateDeviceLive() as otherwise the
	call would succeed even though nothing has changed.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1414627

2017-06-15  Daniel P. Berrange  <berrange@redhat.com>

	Temporarily disable format truncation warnings
	GCC 7.1 introduces a new -Wformat-truncation warning
	flag that reports if it thinks the maximum possible
	size of the formatted output will exceed the provided
	fixed buffer. This is enabled automatically by the
	-Wformat warning flag. There are quite a few places
	hit by this in libvirt which need rewriting. This is
	non-trivial work in some places, so temporarily
	disable the new warning until those fixes can be
	implemented.

2017-06-15  Daniel P. Berrange  <berrange@redhat.com>

	Disable the -Wduplicated-branches warning
	Depending on the platform/architecture, a number of conditionals
	in libvirt code expand the same on both branches. This is expected
	behaviour and harmless, so disable the warning to avoid creating
	unexpected build failures

	Two examples, mingw32:

	../../src/util/vircommand.c: In function 'virCommandWait':
	../../src/util/vircommand.c:2562:51: error: this condition has identical branches [-Werror=duplicated-branches]
	             *exitstatus = cmd->rawStatus ? status : WEXITSTATUS(status);
	                                                   ^
	and gcc7.1

	In file included from util/virobject.c:28:0:
	util/virobject.c: In function 'virClassNew':
	util/viratomic.h:176:46: error: this condition has identical branches [-Werror=duplicated-branches]
	            (void)(0 ? *(atomic) ^ *(atomic) : 0);                      \
	                                             ^
	util/virobject.c:144:20: note: in expansion of macro 'virAtomicIntInc'
	    klass->magic = virAtomicIntInc(&magicCounter);
	                   ^~~~~~~~~~~~~~~

2017-06-14  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Use qemuDomainCheckABIStability where needed
	Most places which want to check ABI stability for an active domain need
	to call this API rather than the original
	qemuDomainDefCheckABIStability. The only exception is in snapshots where
	we need to decide what to do depending on the saved image data.

	https://bugzilla.redhat.com/show_bug.cgi?id=1460952

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-14  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add qemuDomainCheckABIStability
	When making ABI stability checks for an active domain, we need to make
	sure we use the same migratable definition which virDomainGetXMLDesc
	with the MIGRATABLE flag provides, otherwise the ABI check will fail.
	This is implemented in the new qemuDomainCheckABIStability which takes a
	domain object and generates the right migratable definition from it.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-14  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add qemuDomainMigratableDefCheckABIStability
	This patch separates the actual ABI checks from getting migratable defs
	in qemuDomainDefCheckABIStability so that we can create another wrapper
	which will use different methods to get the migratable defs.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-14  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Introduce qemuDomainDefFromXML helper
	The main goal of this function is to enable reusing the parsing code
	from qemuDomainDefCopy.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-14  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Don't try to use hugepages if not enabled
	https://bugzilla.redhat.com/show_bug.cgi?id=1214369

	My fix 671d18594f4 was incomplete. If domain doesn't have
	hugepages enabled, because of missing condition we would still be
	putting hugepages path onto qemu cmd line. Clean up the
	conditions so that it's more visible next time.

2017-06-14  Daniel P. Berrange  <berrange@redhat.com>

	Use sys/uio.h for writev()
	With glibc >= 2.25.90 writev() is only available if you explicitly
	include sys/uio.h. This matches the documented requirements, but
	older glibc and other *NIX pulled in writev indirectly so the bug
	wasn't noticed previously.

	maint: update to latest gnulib
	This fixes an incompatibility with glibc 2.25.90

2017-06-14  Erik Skultety  <eskultet@redhat.com>

	qemu: monitor: Fix a memory leak in qemuMonitorJSONAttachCharDevCommand
	With the current logic, we only free @tlsalias as part of the error
	label and would have to free it explicitly earlier in the code. Convert
	the error label to cleanup, so that we have only one sink, where we
	handle all frees. Since JSON object append operation consumes pointers,
	make sure @backend is cleared before we hit the cleanup label.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Prefer hugepages over mem source='file'
	https://bugzilla.redhat.com/show_bug.cgi?id=1214369

	Consider the following XML:

	  <memoryBacking>
	    <hugepages>
	      <page size='2048' unit='KiB' nodeset='1'/>
	    </hugepages>
	    <source type='file'/>
	    <access mode='shared'/>
	  </memoryBacking>

	  <numa>
	    <cell id='0' cpus='0-3' memory='512000' unit='KiB'/>
	    <cell id='1' cpus='4-7' memory='512000' unit='KiB'/>
	  </numa>

	The following cmd line is generated:

	  -object
	  memory-backend-file,id=ram-node0,mem-path=/var/lib/libvirt/qemu/ram,
	  share=yes,size=524288000 -numa node,nodeid=0,cpus=0-3,memdev=ram-node0
	  -object
	  memory-backend-file,id=ram-node1,mem-path=/var/lib/libvirt/qemu/ram,
	  share=yes,size=524288000 -numa node,nodeid=1,cpus=4-7,memdev=ram-node1

	This is obviously wrong as for node 1 hugepages should have been
	used. The hugepages configuration is more specific than <source
	type='file'/>.

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Allow memAccess for hugepages again
	https://bugzilla.redhat.com/show_bug.cgi?id=1214369
	https://bugzilla.redhat.com/show_bug.cgi?id=1458638

	Historically, we've always supported memAccess for domains backed
	by hugepages. However, somewhere along the way we've regressed
	and stopped allowing such configuration. Fix it.

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	qemuxml2xmltest: Test hugepage enabled domains
	We have couple of hugepage enabled domains for qemuxml2argvtest.
	Unfortunately, often when adding a test case there I forget to
	add it to xml2xml test too.

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainAttachMemory: Crate hugepage dir if needed
	https://bugzilla.redhat.com/show_bug.cgi?id=1455819

	It may happen that a domain is started without any huge pages.
	However, user might try to attach a DIMM module later. DIMM
	backed by huge pages (why would somebody want to mix regular and
	huge pages is beyond me). Therefore we have to create the dir if
	we haven't done so far.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	qemuProcessBuildDestroyHugepagesPath: create path more frequently
	https://bugzilla.redhat.com/show_bug.cgi?id=1455819

	Currently, the per-domain path for huge pages mmap() for qemu is
	created iff domain has memoryBacking and hugepages in it
	configured. However, this alone is not enough because there can
	be a DIMM module with hugepages configured too.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-13  Michal Privoznik  <mprivozn@redhat.com>

	daemonUnixSocketPaths: Unify exit paths
	Right now, there is a lot of exit points from the function.
	Depending on their position they need to copy the same free
	calls. This goes against our style where we usually have just one
	exit point from the function which also does the necessary free.

2017-06-13  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Fix starting a domain with corrupted managed save file
	Commit v3.4.0-44-gac793bd71 fixed a memory leak, but failed to return
	the special -3 value. Thus an attempt to start a domain with corrupted
	managed save file would removed the corrupted file and report
	"An error occurred, but the cause is unknown" instead of starting the
	domain from scratch.

	https://bugzilla.redhat.com/show_bug.cgi?id=1460962

2017-06-13  Yi Wang  <wang.yi59@zte.com.cn>

	daemon: fix memory leak in daemonUnixSocketPaths
	@rundir, allocated by virGetUserRuntimeDirectory, is leaked in case
	virFileMakePath fails.

2017-06-13  Jiri Denemark  <jdenemar@redhat.com>

	cpu_ppc64: Add support for host-model on POWER9

2017-06-13  Philipp Hahn  <hahn@univention.de>

	qemu/doc: Fix function name for handling events
	Insert missing "IO" into function name.

2017-06-13  Andrea Bolognani  <abologna@redhat.com>

	qemu: Explain why mdevs are assumed to be PCI Express

2017-06-13  Marc Hartmayer  <mhartmay@linux.vnet.ibm.com>

	Use ATTRIBUTE_FALLTHROUGH
	Use ATTRIBUTE_FALLTHROUGH, introduced by commit
	5d84f5961b8e28e802f600bb2d2c6903e219092e, instead of comments to
	indicate that the fall through is an intentional behavior.

	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>

2017-06-13  Marc Hartmayer  <mhartmay@linux.vnet.ibm.com>

	qemu: add a comment for mon->watch
	Add a comment for mon->watch to make clear what's the purpose of this
	value.

	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>

2017-06-13  Marc Hartmayer  <mhartmay@linux.vnet.ibm.com>

	rpc: first allocate the memory and then set the count
	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>

2017-06-12  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	bhyve: tests: add vnc test to bhyvexml2xmltest
	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-06-12  Shivaprasad G Bhat  <sbhat@linux.vnet.ibm.com>

	qemu: Release address for redirected device hotplug attach failure
	The virDomainUSBAddressEnsure returns 0 or -1, so commit id 'de325472'
	checking for 1 like qemuDomainAttachChrDeviceAssignAddr was wrong.

2017-06-12  Pavel Hrdina  <phrdina@redhat.com>

	Revert "util: virqemu: introduce virQEMUBuildBufferEscape"
	This reverts commit 22b02f44920388534d3da65cc6f0a70714dcf075.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-06-12  Pavel Hrdina  <phrdina@redhat.com>

	qemu: skip only ',' for VNC and Spice unix socket
	Commit 824272cb28d attempted to fix escaping of characters in unix
	socket path but it was wrong.  We need to escape only ',', there is
	no escape character for '='.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-06-12  Jie Wang  <wangjie88@huawei.com>

	qemu: Fix memory leak in qemuDomainBlockCopyCommon()
	Exiting early through the cleanup path did result in 'mirror'
	being leaked.

2017-06-09  Ján Tomko  <jtomko@redhat.com>

	qemu: report an error if usb keyboards are unsupported
	Be nicer to the user and report a proper error instead of:
	An error occurred, but the cause is unknown

	https://bugzilla.redhat.com/show_bug.cgi?id=1460086

2017-06-09  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	virsh: workaround readline prototypes warnings
	When building with clang 4.0.0, virsh build fails like this:

	gmake[3]: Entering directory '/usr/home/novel/code/libvirt/tools'
	  CC       virsh-virsh.o
	In file included from virsh.c:45:
	In file included from /usr/local/include/readline/readline.h:31:
	/usr/local/include/readline/rltypedefs.h:35:22: error: this function declaration is not a prototype [-Werror,-Wstrict-prototypes]
	typedef int Function () __attribute__ ((deprecated));
	                     ^
	                      void
	/usr/local/include/readline/rltypedefs.h:36:24: error: this function declaration is not a prototype [-Werror,-Wstrict-prototypes]
	typedef void VFunction () __attribute__ ((deprecated));
	                       ^
	                        void
	/usr/local/include/readline/rltypedefs.h:37:26: error: this function declaration is not a prototype [-Werror,-Wstrict-prototypes]
	typedef char *CPFunction () __attribute__ ((deprecated));
	                         ^
	                          void
	/usr/local/include/readline/rltypedefs.h:38:28: error: this function declaration is not a prototype [-Werror,-Wstrict-prototypes]
	typedef char **CPPFunction () __attribute__ ((deprecated));
	                           ^
	                            void
	In file included from virsh.c:45:
	/usr/local/include/readline/readline.h:385:23: error: this function declaration is not a prototype [-Werror,-Wstrict-prototypes]
	extern int rl_message ();
	                      ^
	                       void
	5 errors generated.
	gmake[3]: *** [Makefile:2823: virsh-virsh.o] Error 1

	Fix that by adding -D_FUNCTION_DEF to READLINE_CFLAGS to fix *Function
	related warnings and add a check for stdarg.h so we have HAVE_STDARG_H
	defined that's needed by the readline headers to use proper rl_message
	declaration.

	Bug report on the readline mailing list:

	 http://lists.gnu.org/archive/html/bug-readline/2017-05/msg00004.html

2017-06-08  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainChangeNet: Forbid changing MTU
	https://bugzilla.redhat.com/show_bug.cgi?id=1447618

	Currently, any attempt to change MTU on an interface that is
	plugged to a running domain is silently ignored. We should either
	do what's asked or error out. Well, we can update the host side
	of the interface, but we cannot change 'host_mtu' attribute for
	the virtio-net device. Therefore we have to error out.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-06-08  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Set iface MTU on hotplug
	https://bugzilla.redhat.com/show_bug.cgi?id=1408701

	While implementing MTU (572eda12ad and friends), I've forgotten
	to actually set MTU on the host NIC in case of hotplug. We
	correctly tell qemu on the monitor what the MTU should be, but we
	are not actually setting it on the host NIC.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	qemu: format virtio-related options on the command line
	Format iommu_platform= and ats= for virtio devices.

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	qemuxml2argvtest: add virtio-options test case
	Add a test case to demonstrate the addition of new command line options

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to input devices
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to video
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to rng devices
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to filesystems
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to controllers
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to disks
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	add virtio-related options to memballoon
	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	Add virtio-related options to interfaces
	<interface type='user'>
	  <mac address='52:54:56:5a:5c:5e'/>
	  <model type='virtio'/>
	  <driver iommu='on' ats='on'/>
	</interface>

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	conf: use a leading space in virDomainVirtioNetDriverFormat
	Instead of formatting a space after every option.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	qemuxml2xmltest: add virtio-options test
	Add a test case with all the virtio devices we know to demonstrate
	the addition of new options.

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	qemu: format device-iotlb on intel-iommu command line
	Format the device-iotlb attribute.

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	conf: add iotlb attribute to iommu
	Add a new iotlb attribute to the iommu device
	to control the device IOTLB support for intel-iommu.

	https://bugzilla.redhat.com/show_bug.cgi?id=1283251

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-08  Michal Privoznik  <mprivozn@redhat.com>

	virNetDevOpenvswitchGetVhostuserIfname: Fix off by one error
	https://bugzilla.redhat.com/show_bug.cgi?id=1459091

	We try to get the last element of the passed path by calling
	strrch(path, '/'). However, the pointer that strrchr() returns
	points at the slash, We want string that starts right after that.

2017-06-08  Michal Privoznik  <mprivozn@redhat.com>

	qemu: Query for vhostuser iface names at runtime
	https://bugzilla.redhat.com/show_bug.cgi?id=1459091

	Currently, we are querying for vhostuser interface name in post
	parse callback. At that time interface might not yet exist.
	However, it has to exist when starting domain. Therefore it makes
	more sense to query its name at that point. This partially
	reverts 57b5e27.

2017-06-08  Ján Tomko  <jtomko@redhat.com>

	virDomainControllerDefFormat: do not mix attributes and subelements
	Move out the PCI controller's subelements formatting out of the switch
	handling attributes. This removes the need for a few bool variables.

	conf: eliminate monster condition in virDomainControllerDefFormat
	Move most of the subelement formatting out of the giant if.

2017-06-08  Michal Privoznik  <mprivozn@redhat.com>

	virNetClientStreamQueuePacket: Set st->incomingEOF on the end of stream
	While reworking client side of streams, I had to postpone payload
	decoding so that stream holes and stream data can be
	distinguished in virNetClientStreamRecvPacket. That's merely what
	18944b7aea46d does. However, I accidentally removed one important
	bit: when server sends us an empty STREAM packet (with no
	payload) - meaning end of stream - st->incomingEOF flag needs to
	be set. It used to be before I touched the code. After I removed
	it, virNetClientStreamRecvPacket will try to fetch more data from
	the stream, but it will never come.

	Reviewed-by: Jim Fehlig <jfehlig@suse.com>

2017-06-07  Michal Privoznik  <mprivozn@redhat.com>

	virDomainNetDefParseXML: Fix typo
	In 9cb891141c we've introduced some logic to clearing suggested
	macvtap/macvlan ifnames. The logic consists of comparing ifname
	string with strings that libvirt would generate. However, due to
	a typo only VIR_NET_GENERATED_MACVTAP_PREFIX was compared. Twice.

2017-06-07  Laine Stump  <laine@laine.org>

	docs: correct improper information about domain states in virsh manpage
	Commit 24d4a0a1f removed the non-existent "dying" state from the list
	of possible domain states given in the virsh manpage, but didn't
	correct the count of states from 8 down to 7. This patch fixes that
	mismatch by completely removing any reference to the exact number of
	states (thus preventing a potential future mismatch), while wording
	the sentence in a more readable/truthful manner.

2017-06-07  Erik Skultety  <eskultet@redhat.com>

	qemu: Fix serial stub console allocation
	When adding the aliased serial stub console, the structure wasn't
	properly allocated (VIR_ALLOC instead of virDomainChrDefNew) which then
	resulted in SIGSEGV in virDomainChrSourceIsEqual during a serial device
	coldplug.

	https://bugzilla.redhat.com/show_bug.cgi?id=1434278

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Use updated CPU when starting QEMU if possible
	If QEMU is new enough and we have the live updated CPU definition in
	either save or migration cookie, we can use it to enforce ABI. The
	original guest CPU from domain XML will be stored in private data.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Store updated CPU in save cookie
	Since the domain XML saved in a snapshot or saved image uses the
	original guest CPU definition but we still want to enforce ABI when
	restoring the domain if libvirt and QEMU are new enough, we save the
	live updated CPU definition in a save cookie.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Send updated CPU in migration cookie
	Since the domain XML send during migration uses the original guest CPU
	definition but we still want the destination to enforce ABI if it is new
	enough, we send the live updated CPU definition in a migration cookie.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Always send persistent XML during migration
	When persistent migration of a transient domain is requested but no
	custom XML is passed to the migration API we would just let the
	destination daemon make a persistent definition from the live definition
	itself. This is not a problem now, but once the destination daemon
	starts replacing the original CPU definition with the one from migration
	cookie before starting a domain, it would need to add more ugly hacks to
	reverse the operation. Let's just always send the persistent definition
	in the cookie to make things a bit cleaner.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Report the original CPU in migratable xml
	The destination host may not be able to start a domain using the live
	updated CPU definition because either libvirt or QEMU may not be new
	enough. Thus we need to send the original guest CPU definition.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Remember CPU def from domain start
	When starting a domain we update the guest CPU definition to match what
	QEMU actually provided (since it is allowed to add or removed some
	features unless check='full' is specified). Let's store the original CPU
	in domain private data so that we can use it to provide a backward
	compatible domain XML.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Store save cookie in save images and snapshots
	The following patches will add an actual content in the cookie and use
	the data when restoring a domain.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Implement virSaveCookie object and callbacks
	This patch implements a new save cookie object and callbacks for qemu
	driver. The actual useful content will be added in the object later.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	conf: Add save cookie callbacks to xmlopt
	virDomainXMLOption gains driver specific callbacks for parsing and
	formatting save cookies.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	conf: Introduce virSaveCookie
	The code will be used by snapshots and domain save/restore code to store
	additional data for a saved running domain. It is analogous to migration
	cookies, but simple and one way only.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Introduce virQEMUSaveData structure
	The new structure encapsulates save image header and associated data
	(domain XML).

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Refactor qemuDomainSaveHeader
	The function is now called virQEMUSaveDataWrite and it is now doing
	everything it needs to save both the save image header and domain XML to
	a file. Be it a new file or an existing file in which a user wants to
	change the domain XML.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Introduce virQEMUSaveDataFinish
	The function is supposed to update the save image header after a
	successful migration to the save image file.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Introduce virQEMUSaveData{New,Free}
	This is a preparation for creating a new virQEMUSaveData structure which
	will encapsulate all save image header data.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Fix memory leaks in qemuDomainSaveImageOpen
	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Rename xml_len in virQEMUSaveHeader as data_len
	Since virQEMUSaveHeader will be followed by more than just domain XML,
	the old name would be confusing as it was designed to describe the
	length of all data following the save image header.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	conf: Pass xmlopt to virDomainSnapshotDefFormat
	This will be used later when a save cookie will become part of the
	snapshot XML using new driver specific parser/formatter functions.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	conf: Make virDomainSnapshotDefFormat easier to read
	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

	conf: Refactor virCPUDefParseXML
	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	conf: Make error reporting in virCPUDefIsEqual optional
	The function will be used in paths where mismatching CPU defs are not an
	error.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-06-07  Peter Krempa  <pkrempa@redhat.com>

	virsh: Add support for VIR_DOMAIN_BLOCK_COPY_TRANSIENT_JOB
	Allow using the new flag with virsh.

2017-06-07  Peter Krempa  <pkrempa@redhat.com>

	qemu: Conditionally allow block-copy for persistent domains
	Allow starting the block-copy job for a persistent domain if a user
	declares by using a flag that the job will not be recovered if the VM is
	switched off while the job is active.

	This allows to use the block-copy job with persistent VMs under the same
	conditions as would apply to transient domains.

2017-06-07  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Set operation on completed migration job
	Without this patch libvirt would just report the operation of a
	completed job as "unknown" instead of "incoming migration".

	https://bugzilla.redhat.com/show_bug.cgi?id=1457052

2017-06-07  John Ferlan  <jferlan@redhat.com>

	interface: Convert virInterfaceObj to use virObjectLockable
	Now that we have a bit more control, let's convert our object into
	a lockable object and let that magic handle the create and lock/unlock.

	This commit also introduces virInterfaceObjEndAPI in order to handle the
	lock unlock and object unref in one call for consumers returning a NULL
	obj upon return. This removes the need for virInterfaceObj{Lock|Unlock}
	external API's.

2017-06-07  John Ferlan  <jferlan@redhat.com>

	interface: Consume @def in virInterfaceObjNew
	Move the consumption of @def in virInterfaceObjNew and then handle that
	in the error path of virInterfaceObjListAssignDef since it's caller expects
	to need to free @def when NULL is returned and so would virInterfaceObjFree.

	interface: Introduce virInterfaceObjNew
	Create/use a helper to perform the object allocation

2017-06-06  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Save vcpu ordering information on reconnect
	vCPU ordering information would not be updated if a vCPU emerged or
	disappeared during the time libvirtd is not running. This allowed to
	create invalid configuration like:

	    [...]
	    <vcpu id='56' enabled='yes' hotpluggable='yes' order='57'/>
	    <vcpu id='57' enabled='yes' hotpluggable='yes' order='58'/>
	    <vcpu id='58' enabled='yes' hotpluggable='yes'/>

	Call the function that records the information on reconnect.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1451251

2017-06-05  Michal Privoznik  <mprivozn@redhat.com>

	virFDStreamThread: Make sure we won't exceed @length
	There's a problem with current streams after I switched them from
	iohelper to thread implementation. Previously, iohelper made sure
	not to exceed specified @length resulting in the pipe EOF
	appearing at the exact right moment (the pipe was used to tunnel
	the data from the iohelper to the daemon). Anyway, when switching
	to thread I had to write the I/O code from scratch. Whilst doing
	that I took an inspiration from the iohelper code, but since the
	usage of pipe switched to slightly different meaning, there was
	no 1:1 relationship between the codes.

	Moreover, after introducing VIR_FDSTREAM_MSG_TYPE_HOLE, the
	condition that should made sure we won't exceed @length was
	completely wrong.

	The fix is to:

	a) account for holes for @length
	b) cap not just data sections but holes too (if @length would be
	exceeded)

	For this purpose, the condition needs to be brought closer to the
	code that handles holes and data sections.

2017-06-05  Ján Tomko  <jtomko@redhat.com>

	conf: only format <controller> as a pair tag when needed
	Make the decision based on the usage of childBuf buffer.

	This fixes the oddity in the test case introduced by commit c1c4d0d
	where we would format an empty pair tag.

2017-06-05  Ján Tomko  <jtomko@redhat.com>

	conf: use a separate buffer for the subelements of <controller>
	We need to decide whether to format <controller> as a single tag
	or if it has any subelements.

	Rewrite the function to use a separate buffer for subelements,
	to make adding new options easier.

2017-06-05  Ján Tomko  <jtomko@redhat.com>

	conf: introduce virDomainControllerDriverFormat
	Split out formatting the <driver> subelement of <controller>
	to make adding new options easier.

2017-06-05  Martin Kletzander  <mkletzan@redhat.com>

	audit: Fix the output message for shmem
	After some discussion on and off the linux-audit mailing list, we
	should use different fields for the audit messages.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1218603

2017-06-05  Martin Kletzander  <mkletzan@redhat.com>

	remote: Consolidate remoteStream{Abort,Finish} functions
	They do the same thing with only one difference.  Let's put them
	together (like we already do with virFDStreamCloseInt) so that future
	changes don't miss one of the implementations.  Also to clean up the
	code.

2017-06-05  Michal Privoznik  <mprivozn@redhat.com>

	bhyveargv2xmltest: Fix call of virDomainDefCheckABIStability
	In 4f0aeed I've expanded the list of arguments for
	virDomainDefCheckABIStability() but I forgot to fix
	bhyveargv2xmltest.

2017-06-05  Martin Kletzander  <mkletzan@redhat.com>

	Reset the whole stack in testutils
	The memset() was resetting only 30 bytes in the array (size of the
	array), but it is array of pointers.  Since it is a static array,
	let's just reset it by its size.

	Found by gcc-7.1:

	  testutils.c: In function 'virTestRun':
	  testutils.c:243:13: error: 'memset' used with length equal to number
	  of elements without multiplication by element size [-Werror=memset-elt-size]
	    memset(testAllocStack, 0, ARRAY_CARDINALITY(testAllocStack));
	    ^~~~~~

2017-06-05  Eli Qiao  <liyong.qiao@intel.com>

	Expose resource control capabilities for caches
	Add cache resource control into capabilities for CAT without CDP:

	  <cache>
	    <bank id='0' level='3' type='unified' size='15360' unit='KiB' cpus='0-5'>
	      <control min='768' unit='KiB' scope='both' max_allocation='4'/>
	    </bank>
	  </cache>

	and with CDP:

	  <cache>
	    <bank id='0' level='3' type='unified' size='15360' unit='KiB' cpus='0-5'>
	      <control min='768' unit='KiB' scope='code' max_allocation='4'/>
	      <control min='768' unit='KiB' scope='data' max_allocation='4'/>
	    </bank>
	  </cache>

	Also add new test cases for vircaps2xmltest.

2017-06-05  Michal Privoznik  <mprivozn@redhat.com>

	virQEMUDriverDomainABIStability: Check for memoryBacking
	https://bugzilla.redhat.com/show_bug.cgi?id=1450349

	Problem is, qemu fails to load guest memory image if these
	attribute change on migration/restore from an image.

2017-06-05  Michal Privoznik  <mprivozn@redhat.com>

	virDomainXMLOption: Introduce virDomainABIStabilityDomain
	While checking for ABI stability, drivers might pose additional
	checks that are not valid for general case. For instance, qemu
	driver might check some memory backing attributes because of how
	qemu works. But those attributes may work well in other drivers.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	nodedev: Remove privateData from virNodeDeviceObj
	It was only ever used in node_device_hal.c which really never used it
	anyway since the NODE_DEV_UDI was never referenced.  Remove free_udi()
	and @privData as well as the references to obj->privateData & obj->privateFree.

	nodedev: Introduce virNodeDeviceObjGetDef
	In preparation for privatizing the virNodeDeviceObj - create an accessor
	for the @def field and then use it for various callers.

	nodedev: Create helper for finding by name in driver
	Create nodeDeviceObjFindByName which will perform the corresponding
	virNodeDeviceObjFindByName call for various node_device_driver callers
	rather than having the same repetitive code.

	nodedev: Alter param to nodeDeviceUpdateCaps
	Rather than taking an virNodeDeviceObjPtr and dereffing the obj->def,
	just pass the def.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	nodedev: Alter param to nodeDeviceUpdateDriverName
	Rather than taking an virNodeDeviceObjPtr and dereffing the obj->def,
	just pass the def.

	Also check for an error in the function to have the calling function goto
	cleanup on error.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	nodedev: Cleanup driver code and prototypes
	Alter the node_device_driver source and prototypes to follow more
	recent code style guidelines w/r/t spacing between functions, format
	of the function, and the prototype definitions.

	While the new names for nodeDeviceUpdateCaps, nodeDeviceUpdateDriverName,
	and nodeDeviceGetTime don't follow exactly w/r/t a "vir" prefix, they
	do follow other driver nomenclature style.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	nodedev: Use switch for virNodeDeviceObjHasCap and virNodeDeviceCapMatch
	In order to ensure that whenever something is added to virNodeDevCapType
	that both functions are considered for processing of a new capability,
	change the if-then-else construct into a switch statement.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	nodedev: Need to check for vport capable scsi_host for vHBA searches
	When searching for an NPIV capable fc_host, not only does there need to
	be an "fc_host" capability with the specified wwnn/wwpn or fabric_wwn,
	but that scsi_host must be vport capable; otherwise, one could end up
	picking an exising vHBA/NPIV which wouldn't be good.

	Currently not a problem since scsi_hosts are in an as found forward linked
	list and the vport capable scsi_hosts will always appear before a vHBA by
	definition. However, in the near term future a hash table will be used to
	lookup the devices and that could cause problems for these algorithms.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	interface: Clean up virInterfaceObjListFindByMACString
	Alter the algorithm to return a list of matching names rather than a
	list of match virInterfaceObjPtr which are then just dereferenced
	extracting the def->name and def->mac. Since the def->mac would be
	the same as the passed @mac, just return a list of names and as long
	as there's only one, extract the [0] entry from the passed list.
	Also alter the error message on failure to include the mac that wasn't
	found.

	interface: Rename some virInterfaceObj* API's
	Prefix should have been virInterfaceObjList since the API is operating
	on the list of interfaces.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	interface: Make _virInterfaceObjList struct private
	Move the structs into virinterfaceobj.c, create necessary accessors, and
	initializers.

	This also includes reworking virInterfaceObjListClone to handle receiving
	a source interfaces list pointer, creating the destination interfaces object,
	and copying everything from source into dest.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	interface: Make _virInterfaceObj struct private
	Move the struct into virinterfaceobj.c, create necessary accessors, and
	initializers.

2017-06-03  John Ferlan  <jferlan@redhat.com>

	interface: Use virInterfaceDefPtr rather than deref from virInterfaceObjPtr
	We're about to make the obj much more private, so make it easier to
	see future changes which will require accessors for the obj->def

	This also includes modifying some interfaces->objs[i]->X references to be
	obj = interfaces->objs[i]; and then def = obj->def

2017-06-03  John Ferlan  <jferlan@redhat.com>

	interface: Remove some unnecessary goto's for Interface tests
	Rather than using goto cleanup on object find failure and having cleanup
	need to check if the obj was present before unlocking, just return immediately.

	interface: Consistently use 'obj' for a virInterfaceObjPtr
	Alter variable names to be obj rather than 'iface' and/or 'obj'.

2017-06-02  Peter Krempa  <pkrempa@redhat.com>

	daemon: Don't initialize SASL context if not necessary
	SASL context would be initialized even if the corresponding TCP or TLS
	sockets are not enabled.

	fe772f24a68 attempted to fix the symptom by commenting out the settings,
	but that did not fix the root cause. 3c647ee4bbb later reverted those
	changes so that the more secure algorithm is used.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1450095

2017-06-02  Peter Krempa  <pkrempa@redhat.com>

	qemu: Don't error out if allocation info can't be queried
	qemuDomainGetBlockInfo would error out if qemu did not report
	'wr_highest_offset'. This usually does not happen, but can happen
	briefly during active layer block commit. There's no need to report the
	error, we can simply report that the disk is fully alocated at that
	point.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1452045

2017-06-02  Julio Faracco  <jcfaracco@gmail.com>

	util: remove dead code inside virstoragefile
	The host address or the socket path have already been checked at the
	begining of the function virStorageSourceParseNBDColonString(). So,
	when the parameter is not a unix socket, there is no reason to check
	the address again because if it does not exists, the logic will fail
	in the first IF conditional.

	util: fix wrong comparison inside virStoragePermsCopy()
	VIR_STRDUP returns -1 if the string copy was not successful. So, the
	current comparison/logic is throwing an error when VIR_STRDUP() returns
	1. Only when source is NULL, it is considering as a success which is
	not right.

2017-06-02  Peter Krempa  <pkrempa@redhat.com>

	Post-release version bump to 3.5.0

2017-06-02  Daniel Veillard  <veillard@redhat.com>

	Release of libvirt-3.4.0
	* docs/news.xml: updated for the release
	* po/*.po*: regenerated

2017-06-01  Daniel P. Berrange  <berrange@redhat.com>

	Fix closing XML element in news file

2017-06-01  Martin Kletzander  <mkletzan@redhat.com>

	news: Minor cleanups

	Add some news items for the 3.4.0 release

2017-05-31  Michal Privoznik  <mprivozn@redhat.com>

	qemu: mkdir memory_backing_dir on startup
	In 48d9e6cdcc and friends we've allowed users to back guest
	memory by a file inside the host. And in order to keep things
	manageable the memory_backing_dir variable was introduced to
	qemu.conf to specify the directory where the files are kept.
	However, libvirt's policy is that directories are created on
	domain startup if they don't exist. We've missed this one.

2017-05-31  Erik Skultety  <eskultet@redhat.com>

	udev: Fix build on older platforms
	Caused by commit @d1eea6c1 due to the missing symbol on older platforms.

2017-05-30  Erik Skultety  <eskultet@redhat.com>

	qemu: json: Fix daemon crash on handling domain shutdown event
	commit a8eba5036 added further checking of the guest shutdown cause, but
	this enhancement is available since qemu 2.10, causing a crash because
	of a NULL pointer dereference on older qemus.

	Thread 1 "libvirtd" received signal SIGSEGV, Segmentation fault.
	0x00007ffff72441af in virJSONValueObjectGet (object=0x0,
	                                             key=0x7fffd5ef11bf "guest")
	    at util/virjson.c:769
	769	    if (object->type != VIR_JSON_TYPE_OBJECT)
	(gdb) bt
	0  in virJSONValueObjectGet
	1  in virJSONValueObjectGetBoolean
	2  in qemuMonitorJSONHandleShutdown
	3  in qemuMonitorJSONIOProcessEvent
	4  in qemuMonitorJSONIOProcessLine
	5  in qemuMonitorJSONIOProcess
	6  in qemuMonitorIOProcess

2017-05-30  Nitesh Konkar  <niteshkonkar.libvirt@gmail.com>

	util: hostcpu: Correctly report total number of vcpus in virHostCPUGetMap
	Callers expect the return value to be the total number of vcpus in the
	host (including offline vcpus). The refactor in c67e04e25fa58104e0fae41
	broke this assumption by using virHostCPUGetOnlineBitmap which only
	creates a bitmap long enough to hold the last online vcpu.

	Report the full number of host vcpus by returning value from
	virHostCPUGetCount().

2017-05-29  ning.bo  <ning.bo9@zte.com.cn>

	nodedev: Increase the netlink socket buffer size to the one used by udev
	When a number of SRIOV VFs (up to 128 on Intel XL710) is created:
	for i in `seq 0 1`; do
	  echo 63 > /sys/class/net/<interface>/device/sriov_numvfs
	done

	libvirtd will then report "udev_monitor_receive_device returned NULL"
	error because the netlink socket buffer is not big enough (using GDB on
	libudev confirmed this with ENOBUFFS) and thus some udev events were
	dropped. This results in some devices being missing in the nodedev-list
	output. This patch overrides the system's rmem_max limit but for that,
	we need to make sure we've got root privileges.

	https://bugzilla.redhat.com/show_bug.cgi?id=1450960

2017-05-29  Michal Privoznik  <mprivozn@redhat.com>

	virCapabilitiesInitCaches: Don't leak @cpus
	The @cpus is allocated by virFileReadValueBitmap() but never
	freed:

	==21274== 40 (32 direct, 8 indirect) bytes in 1 blocks are definitely lost in loss record 808 of 1,004
	==21274==    at 0x4C2E080: calloc (vg_replace_malloc.c:711)
	==21274==    by 0x54BA561: virAlloc (viralloc.c:144)
	==21274==    by 0x54BC604: virBitmapNewEmpty (virbitmap.c:126)
	==21274==    by 0x54BD059: virBitmapParseUnlimited (virbitmap.c:570)
	==21274==    by 0x54EECE9: virFileReadValueBitmap (virfile.c:4113)
	==21274==    by 0x5563132: virCapabilitiesInitCaches (capabilities.c:1548)
	==21274==    by 0x2BB86E59: virQEMUCapsInit (qemu_capabilities.c:1132)
	==21274==    by 0x2BBEC067: virQEMUDriverCreateCapabilities (qemu_conf.c:928)
	==21274==    by 0x2BC3DEAA: qemuStateInitialize (qemu_driver.c:845)
	==21274==    by 0x5625AAC: virStateInitialize (libvirt.c:770)
	==21274==    by 0x124519: daemonRunStateInit (libvirtd.c:881)
	==21274==    by 0x554C927: virThreadHelper (virthread.c:206)

2017-05-27  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	util: fix virfcp build on non-Linux
	 - Include virerror.h for virReportSystemError
	 - Rename stub functions to match original function names

2017-05-26  Bjoern Walk  <bwalk@linux.vnet.ibm.com>

	docs: update news.xml
	Mention CCW and fc_remote_port capablities in the news.xml file.

	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>

2017-05-26  Bjoern Walk  <bwalk@linux.vnet.ibm.com>

	node_device: introduce new capability FC_RPORT
	Similar to scsi_host and fc_host, there is a relation between a
	scsi_target and its transport specific fc_remote_port. Let's expose this
	relation and relevant information behind it.

	An example for a virsh nodedev-dumpxml:

	    virsh # nodedev-dumpxml scsi_target0_0_0
	    <device>
	      <name>scsi_target0_0_0</name>
	      <path>/sys/devices/[...]/host0/rport-0:0-0/target0:0:0</path>
	      <parent>scsi_host0</parent>
	      <capability type='scsi_target'>
	        <target>target0:0:0</target>
	        <capability type='fc_remote_port'>
	          <rport>rport-0:0-0</rport>
	          <wwpn>0x9d73bc45f0e21a86</wwpn>
	        </capability>
	      </capability>
	    </device>

	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>

2017-05-26  Bjoern Walk  <bwalk@linux.vnet.ibm.com>

	util: helper functions for fibre channel devices
	We will need some convenient helper functions for managing sysfs-entries
	for fibre channel-backed devices. Let's implement them and make them
	available in the private API.

2017-05-26  Bjoern Walk  <bwalk@linux.vnet.ibm.com>

	virsh: nodedev: ability to filter CCW capabilities
	Now that the node_device driver is aware of CCW devices, let's hook up
	virsh so that we can filter them properly.

	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>
	Reviewed-by: Marc Hartmayer <mhartmay@linux.vnet.ibm.com>

2017-05-26  Bjoern Walk  <bwalk@linux.vnet.ibm.com>

	node_device: detect CCW devices
	Make CCW devices available to the node_device driver. The devices are
	already seen by udev so let's implement necessary code for detecting
	them properly.

	Topologically, CCW devices are similar to PCI devices, e.g.:

	    +- ccw_0_0_1a2b
	        |
	        +- scsi_host0
	            |
	            +- scsi_target0_0_0
	                |
	                +- scsi_0_0_0_0

	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>

2017-05-26  Marc Hartmayer  <mhartmay@linux.vnet.ibm.com>

	node_device: Unlock obj in case of an error too
	Unlock @obj in case of an error too.

	Reviewed-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>
	Reviewed-by: Boris Fiuczynski <fiuczy@linux.vnet.ibm.com>

2017-05-26  Marc Hartmayer  <mhartmay@linux.vnet.ibm.com>

	node_device: Use the @cap iterator variable
	Since the switch statement is already using the deref'd @cap variable
	and the VIR_NODE_DEV_CAP_NET case uses it, the SCSI_HOST and PCI_DEV
	cases may as well use it too.

	Suggested-by: Bjoern Walk <bwalk@linux.vnet.ibm.com>

2017-05-26  Martin Kletzander  <mkletzan@redhat.com>

	qemu: Report shutdown event details
	QEMU will likely report the details of it shutting down, particularly
	whether the shutdown was initiated by the guest or host.  We should
	forward that information along, at least for shutdown events.  Reset
	has that as well, however that is not a lifecycle event and would add
	extra constants that might not be used.  It can be added later on.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1384007

2017-05-26  Richard W.M. Jones  <rjones@redhat.com>

	rpc: Allow up to 256K records to be returned per domain from virConnectGetAllDomainStats.
	The number of records that virConnectGetAllDomainStats can return per
	domain is currently limited to 4096.  This is quite low -- for
	example, a single guest with ~320 disks will hit this limit.  This
	increases the limit to make it much larger.  Note that
	VIR_NET_MESSAGE_MAX still protects the total message size in the case
	where there are many domains and many disks per domain.

	I tested this using a guest with 500 disks with no issues.

	Bugzilla: https://bugzilla.redhat.com/show_bug.cgi?id=1440683

2017-05-26  Richard W.M. Jones  <rjones@redhat.com>

	rpc: Double buffer size instead of quadrupling buffer size.
	When increasing the buffer size up to VIR_NET_MESSAGE_MAX, we
	currently quadruple it each time.  This unfortunately means that we
	cannot allow certain buffer sizes -- for example the current
	VIR_NET_MESSAGE_MAX == 33554432 can never be "hit" since ‘newlen’
	jumps from 16MB to 64MB.

	Instead of quadrupling, double it each time.

	Thanks: Daniel Berrange.

2017-05-26  Peter Krempa  <pkrempa@redhat.com>

	node: Don't return invalid pointers
	Commit 4337bc57be introduced code that would in certain error paths
	unref the last reference of a pointer, but return it.

	Clear the pointers before returning them.

2017-05-26  Yi Wang  <wang.yi59@zte.com.cn>

	node_device: fix memory leak in nodeDeviceSysfsGetSCSIHostCaps
	@tmp is leaked after the second call to virVHBAGetConfig within
	virVHBAIsVportCapable code block because it wasn't freed after making the
	first call to the function.

	util: fix memory leak in virSocketAddrFormatFull
	The @ipv6_host allocated in virAsprintf may be lost when virAsprintf
	addrstr failed.

2017-05-26  Julio Faracco  <jcfaracco@gmail.com>

	lxc: Fix wrong VIR_FREE after a return statement
	There is a VIR_FREE after a return statement. That code section is never
	executed and for this reason the "tty" variable is not being freed. This
	commit rearranges the logic.

	m4: Fix missing with_acl variable
	This commit fixes an acl missing variable. The virt-acl.m4 inside the
	macro directory does not contain the variable 'with_acl'. So, it is
	being set as an empty string "with_acl=''". This is causing a missing
	option during the configuration, even if you have acl libs installed.

2017-05-26  Ján Tomko  <jtomko@redhat.com>

	qemu: format eim on intel-iommu command line
	This option turns on extended interrupt mode,
	which allows more than 255 vCPUs.

	https://bugzilla.redhat.com/show_bug.cgi?id=1451282

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-05-26  Ján Tomko  <jtomko@redhat.com>

	conf: add eim attribute to <iommu><driver>
	Add an attribute to control extended interrupt mode.

	https://bugzilla.redhat.com/show_bug.cgi?id=1451282

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-05-26  John Ferlan  <jferlan@redhat.com>

	virsh: Track when create pkttyagent
	https://bugzilla.redhat.com/show_bug.cgi?id=1374126

	Due to how the processing for authentication using polkit works, the
	virshConnect code must first "attempt" an virConnectOpenAuth and then
	check for a "special" return error code VIR_ERR_AUTH_UNAVAILABLE in
	order to attempt to "retry" the authentication after performing a creation
	of a pkttyagent to handle the challenge/response for the client.

	However, if pkttyagent creation is not possible for the authentication
	being attempted (such as perhaps a "qemu+ssh://someuser@localhost/system"),
	then the same failure pattern would be returned and another attempt to
	create a pkttyagent would be done. This would continue "forever" until
	someone forced quit (e.g. ctrl-c) from virsh as the 'authfail' was not
	incremented when creating the pkttyagent.

	So add a 'agentCreated' boolean to track if we've attempted to create the
	agent at least once and force a failure if that creation returned the same
	error pattern.

	This resolves a possible never ending loop and will generate an error:

	error: failed to connect to the hypervisor
	error: authentication unavailable: no polkit agent available to authenticate action 'org.libvirt.unix.manage'

	NB: If the authentication was for a sufficiently privileged client, such as
	qemu+ssh://root@localhost/system, then the remoteDispatchAuthList "allows"
	the authentication to use libvirt since @callerUid would be 0.

2017-05-25  Peter Krempa  <pkrempa@redhat.com>

	qemu: Use correct variable in qemuDomainSetBlockIoTune
	'param' contains the correct element from 'params'.

	If the group name would not be the first parameter libvirtd would crash.

	Introduced in c53bd25b13.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1455510

2017-05-25  Claudio André  <claudioandre.br@gmail.com>

	CI: show the log in case of failure
	Disclose the content of the 'test-suite.log' file (if available) in
	case of failures inside Travis-CI. This is needed to understand what
	happened and to provide hints about the proper fix (if applicable).

2017-05-25  Michal Privoznik  <mprivozn@redhat.com>

	virDomainDefCheckABIStabilityFlags: move memtune checks into a separate function
	The checks are scattered all over the place. Move them into a
	single function.

2017-05-25  Chen Hanxiao  <chenhanxiao@gmail.com>

	util: display leading zeros of USB vendor/product id's in log messages
	Many vendor id's and product id's have leading zeros.  We should show
	them in the logs.

	Reviewed-by: Laine Stump <laine@laine.org>

2017-05-24  Yi Wang  <wang.yi59@zte.com.cn>

	qemu: Fix memory leak in qemuDomainUpdateMemoryDeviceInfo
	The @meminfo allocated in qemuMonitorGetMemoryDeviceInfo() may be
	lost when qemuDomainObjExitMonitor() failed.

2017-05-24  John Ferlan  <jferlan@redhat.com>

	conf: Resolve corner case on fc_host deletion
	https://bugzilla.redhat.com/show_bug.cgi?id=1420740

	Testing found an inventive way to cause an error at shutdown by providing the
	parent name for the fc host creation using the "same name" as the HBA. Since
	the code thus assumed the parent host name provided was the parent HBA and
	just extracted out the host number and sent that along to the vport_destroy
	this avoided checks made for equality.

	So just add the equality check to that path to resolve.

2017-05-24  Pavel Hrdina  <phrdina@redhat.com>

	conf: fix build issue caused by shadowing global declaration

2017-05-24  Peter Krempa  <pkrempa@redhat.com>

	rpc: Bump maximum message size to 32M
	While most of the APIs are okay with 16M messages, the bulk stats API
	can run into the limit in big configurations. Before we devise a new
	plan for this, bump this limit slightly to accomodate some more configs.

2017-05-24  Pavel Hrdina  <phrdina@redhat.com>

	conf: don't iterate over backcompat console in virDomainChrDefForeach
	If the first console is just a copy of the first serial device we
	don't need to iterate over the same device twice in order to perform
	actions like security labeling, cgroup configuring, etc.

	Currently only security SELinux manager was aware of this fact.

2017-05-24  Konstantin Neumoin  <kneumoin@virtuozzo.com>

	vz: minor cleanup in prlsdkDomainSetUserPassword
	No need begin job for asynchronous operation.

	vz: fix raise in vzDomainBlock
	Put domain access after acquiring job condition, otherwise
	another job can change it meanwhile.

	vz: unlock dom until resize operation
	We have to use waitDomainJob instead of waitJob, because of it
	unlock the domain until job has finished, so domain will be available
	for other clients.

2017-05-24  Peter Krempa  <pkrempa@redhat.com>

	qemu: Properly check return value of VIR_STRDUP in qemuDomainGetBlockIoTune
	Setting the 'group_name' for a disk would falsely trigger a error path
	as in commit 4b57f76502 we did not properly check the return value of
	VIR_STRDUP.

2017-05-24  Jim Fehlig  <jfehlig@suse.com>

	libxl: add default controllers for USB devices
	Attempting to start a domain with USB hostdevs but no USB controllers
	fails with the rather cryptic error

	libxl: error: libxl_qmp.c:287:qmp_handle_error_response: received an
	error message from QMP server: Bus 'xenusb-0.0' not found

	This can be fixed by creating default USB controllers. When no USB
	controllers are defined, create the number of 8 port controllers
	necessary to accommodate the number of defined USB devices.

	Note that USB controllers are already created as needed in the
	domainAttachDevice code path. E.g. a USB controller will be created,
	if necessary, when attaching a USB device with
	'virsh attach-device dom usbdev.xml'.

2017-05-23  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Clear priv->namespaces on VM shutdown
	Otherwise the private data entry would be kept across instances of the
	same VM even if it's not configured to do so.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1453142

2017-05-23  Kothapally Madhu Pavan  <kmp@linux.vnet.ibm.com>

	qemu: Remove unused variables in qemuDomainUpdateDeviceConfig
	priv and qemuCaps variables are not used anymore.

2017-05-23  Laine Stump  <laine@laine.org>

	Revert "qemu: propagate bridge MTU into qemu "host_mtu" option"
	This reverts commit 2841e675.

	It turns out that adding the host_mtu field to the PCI capabilities in
	the guest bumps the length of PCI capabilities beyond the 32 byte
	boundary, so the virtio-net device gets 64 bytes of ioport space
	instead of 32, which offsets the address of all the other following
	devices. Migration doesn't work very well when the location and length
	of PCI capabilities of devices is changed between source and
	destination.

	This means that we need to make sure that the absence/presence of
	host_mtu on the qemu commandline always matches between source and
	destination, which means that we need to make setting of host_mtu an
	opt-in thing (it can't happen automatically when the bridge being used
	has a non-default MTU, which is what commit 2841e675 implemented).

	I do want to re-implement this feature with an <mtu auto='on'/>
	setting, but probably won't backport that to any stable branches, so
	I'm first reverting the original commit, and that revert can be pushed
	to the few releases that have been made since the original (3.1.0 -
	3.3.0)

	Resolves: https://bugzilla.redhat.com/1449346

2017-05-23  Jim Fehlig  <jfehlig@suse.com>

	libxl: add default listen address for VNC and spice
	If a VNC listen address is not specified in domXML, libxl
	will default to 127.0.0.1, but this is never reflected in the domXML.
	In the case of spice, a missing listen address resulted in listening
	on all interfaces, i.e. '0.0.0.0'. If not specified, set the listen
	address in virDomainGraphicsDef struct to the libxl default when
	creating the frame buffer device. Additionally, set default spice
	listen address to 127.0.0.1.

	maint: define a macro for IPv4 loopback address
	Use a macro instead of hardcoding "127.0.0.1" throughout the
	sources.

2017-05-23  Daniel P. Berrange  <berrange@redhat.com>

	Provide a useful README file
	The current README file contents has almost no useful info, and that
	which does exist is very outdated.

	Reviewed-by: Andrea Bolognani <abologna@redhat.com>

2017-05-22  Michal Privoznik  <mprivozn@redhat.com>

	virStreamSparseSendAll: Reset @want in each iteration
	There's a slight problem with the current function. Assume we are
	currently in a data section and we have say 42 bytes until next
	section. Therefore, just before (handler) is called to fill up
	the buffer with data, @want is changed to 42 to match the amount
	of data left in the current section. However, after hole is
	processed, we are back in data section but with incredibly small
	@want size. Nobody will ever reset it back. This results in
	incredible data fragmentation.

2017-05-22  Andrea Bolognani  <abologna@redhat.com>

	docs: Update pointer to networking information
	Commit 6fb5dd4fd804 removed docs/archnetwork.html.in, but
	left behind a pointer to it in docs/formatnetwork.html.in.

	Update it so that it points to the wiki, which contains
	more detailed and recent information anyway.

2017-05-22  Michal Privoznik  <mprivozn@redhat.com>

	virCapabilitiesInitCaches: Don't leak cache dir
	To every virDirOpen we must have VIR_DIR_CLOSE otherwise FD is
	leaked.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-05-22  Ján Tomko  <jtomko@redhat.com>

	Do not release unreserved address in qemuDomainAttachRNGDevice
	Only set releaseaddr to true after the address has been
	reserved successfully.

	https://bugzilla.redhat.com/show_bug.cgi?id=1452581

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-05-22  Peter Krempa  <pkrempa@redhat.com>

	qemu: hotplug: print correct vcpu when validating hot(un)plug config
	The error message would contain first vcpu id after the list of vcpus
	selected for modification. To print the proper vcpu id remember the
	first vcpu selected to be modified.

2017-05-22  Wang King  <king.wang@huawei.com>

	util: Don't leak @reply in virSystemdGetMachineNameByPID
	@reply is a DBusMessage object returned by virDBusCallMethod in
	get machine object call path, dereference it before calling
	virDBusCallMethod again to get machine name.

2017-05-22  Julio Faracco  <jcfaracco@gmail.com>

	test: fixing variable names for test suite inside configure.ac.
	Both variables for gcov and oom have wrong names inside configure.ac.
	For this reason, the Test Suite configuration is not showing the current
	configuration.

	Before patching:
	configure:    windres: no
	configure:
	configure: Test suite
	configure:
	configure:          Coverage:
	configure:         Alloc OOM:
	configure:
	configure: Miscellaneous

	After patching (using --enable-test-coverage and --enable-test-oom):
	configure:    windres: no
	configure:
	configure: Test suite
	configure:
	configure:          Coverage: yes
	configure:         Alloc OOM: yes
	configure:
	configure: Miscellaneous

2017-05-19  Wim ten Have  <wim.ten.have@oracle.com>

	xenconfig: fix handling of NULL disk source
	It is possible to crash libvirtd when converting xl native config to
	domXML when the xl config contains an empty disk source, e.g. an empty
	CDROM. Fix by checking that the disk source is non-NULL before parsing it.

2017-05-19  Michal Privoznik  <mprivozn@redhat.com>

	virfiletest: include linux/falloc.h
	On systems with older glibc including fcntl.h for getting
	FALLOC_FL_PUNCH_HOLE defined is not enough. We must also include
	linux/falloc.h.

	virfiletest: Test virFileInData iff SEEK_HOLE is defined
	Yet another place where we need to wrap code in
	HAVE_DECL_SEEK_HOLE block.

	virfile: Provide stub for virFileInData
	Some older systems (such as RHEL6) lack SEEK_HOLE and SEEK_DATA
	which virFileInData relies on. Provide a stub for these systems.

2017-05-19  Peter Krempa  <pkrempa@redhat.com>

	conf: Don't assign value from ..TypeFromString directly to enum
	Enums are unsigned, so it's impossible to check whether the helper
	returned -1 for invalid conversions.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1452454

2017-05-19  Felix Geyer  <fgeyer@debian.org>

	apparmor, virt-aa-helper: Explicit denies for host devices
	Add explicit denies for disk devices to avoid cluttering dmesg with
	(acceptable) denials.

	Acked-by: Guido Günther <agx@sigxcpu.org>

2017-05-19  Felix Geyer  <fgeyer@debian.org>

	apparmor, virt-aa-helper: Allow access to libnl-3 config files
	Allow access to libnl-3 config files

	Acked-by: Guido Günther <agx@sigxcpu.org>

2017-05-19  Peter Krempa  <pkrempa@redhat.com>

	qemu: monitor: Don't bother extracting vCPU halted state in text monitor
	The code causes the 'offset' variable to be overwritten (possibly with
	NULL if neither of the vCPUs is halted) which causes a crash since the
	variable is still used after that part.

	Additionally there's a bug, since strstr() would look up the '(halted)'
	string in the whole string rather than just the currently processed line
	the returned data is completely bogus.

	Rather than switching to single line parsing let's remove the code
	altogether since it has a commonly used JSON monitor alternative and
	the data itself is not very useful to report.

	The code was introduced in commit cc5e695bde

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1452106

2017-05-19  Julio Faracco  <jcfaracco@gmail.com>

	datatypes: removing unnecessary return statement.
	There is a wrong 'return' statement after a 'goto' statement inside the
	function virConnectCloseCallbackDataRegister(). This commit only removes
	the 'return'.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	virStream: Forbid negative seeks
	Currently, we don't assign any meaning to that. Our current view
	on virStream is that it's merely a pipe. And pipes don't support
	seeking.

	news: Document sparse streams

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	nodedev: mdev: Fix build caused by symbol shadowing
	GCC 4.6 complains about a local declaration shadowing a global symbol.

2017-05-18  Wang King  <king.wang@huawei.com>

	util: Do not leak @handles in stop netlink event service
	Commit e3ba4025 introduced srv->handles and VIR_RESIZE_N to allocate
	@handles as necessary, but did not free the handles during when calling
	virNetlinkEventServiceStop.

	util: Deduplicate code in virNetlinkEventServiceStopAll
	Commit 15a71e60 introduced the virNetlinkEventServiceStopAll function, and
	the code in virNetlinkEventServiceStop is copied to this function, so just
	call virNetlinkEventServiceStop instead.

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	docs: Document the mediated devices within the nodedev driver
	https://bugzilla.redhat.com/show_bug.cgi?id=1452072

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	nodedev: Introduce mdev capability for mediated devices
	Start discovering the mediated devices on the host system and format the
	attributes for the mediated device into the XML. Compared to the parent
	device which reports generic information about the abstract mediated
	devices types, a child device only reports the type name it has been
	instantiated from and the IOMMU group number, since that's device
	specific compared to the rest of the info that can be gathered about
	mediated devices at the moment.
	This patch introduces both the formatting and parsing routines, updates
	nodedev.rng schema, adding a testcase as well.

	The resulting mdev child device XML:
	<device>
	  <name>mdev_4b20d080_1b54_4048_85b3_a6a62d165c01</name>
	  <path>/sys/devices/.../4b20d080-1b54-4048-85b3-a6a62d165c01</path>
	  <parent>pci_0000_06_00_0</parent>
	  <driver>
	    <name>vfio_mdev</name>
	  </driver>
	  <capability type='mdev'>
	    <type id='vendor_supplied_type_id'/>
	    <iommuGroup number='NUM'/>
	  <capability/>
	<device/>

	https://bugzilla.redhat.com/show_bug.cgi?id=1452072

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	nodedev: Introduce the mdev capability to a PCI parent device
	The parent device needs to report the generic stuff about the supported
	mediated devices types, like device API, available instances, type name,
	etc. Therefore this patch introduces a new nested capability element of
	type 'mdev_types' with the resulting XML of the following format:

	<device>
	  ...
	  <capability type='pci'>
	    ...
	    <capability type='mdev_types'>
	      <type id='vendor_supplied_id'>
	        <name>optional_vendor_supplied_codename</name>
	        <deviceAPI>vfio-pci</deviceAPI>
	        <availableInstances>NUM</availableInstances>
	      </type>
	        ...
	      <type>
	        ...
	      </type>
	    </capability>
	  </capability>
	  ...
	</device>

	https://bugzilla.redhat.com/show_bug.cgi?id=1452072

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	nodedev: Introduce new mdev_types and mdev nodedev capabilities
	The reason for introducing two capabilities, one for the device itself
	(cap 'mdev') and one for the parent device listing the available types
	('mdev_types'), is that we should be able to do
	'virsh nodedev-list --cap' not only for existing mdev devices but also
	for devices that support creation of mdev devices, since one day libvirt
	might be actually able to create the mdev devices in an automated way
	(just like we do for NPIV/vHBA).

	https://bugzilla.redhat.com/show_bug.cgi?id=1452072

2017-05-18  Erik Skultety  <eskultet@redhat.com>

	nodedev: conf: Split PCI sub-capability parsing to separate methods
	Since there's at least SRIOV and MDEV sub-capabilities to be parsed,
	let's make the code more readable by splitting it to several logical
	blocks.

	mdev: Pass a uuidstr rather than an mdev object to some util functions
	Namely, this patch is about virMediatedDeviceGetIOMMUGroup{Dev,Num}
	functions. There's no compelling reason why these functions should take
	an object, on the contrary, having to create an object every time one
	needs to query the IOMMU group number, discarding the object afterwards,
	seems odd.

2017-05-18  Marek Marczykowski-Górecki  <marmarek@invisiblethingslab.com>

	pci: fix link maximum speed detection
	Commit 8e09663 "pci: recognize/report GEN4 (PCIe 4.0) card 16GT/s Link
	speed" introduced another speed into enum, but mistakenly also altered
	field width, so one bit of link width was included there.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	virsh: Implement sparse stream to vol-upload
	Similarly to previous commit, implement sparse streams feature
	for vol-upload. This is, however, slightly different approach,
	because we must implement a function that will tell us whether
	we are in a data section or in a hole. But there's no magic
	hidden in here.

	virsh: Implement sparse stream to vol-download
	Add a new --sparse switch that does nothing more than
	enables the sparse streams feature for this command. Among with
	the switch new helper function is introduced: virshStreamSkip().
	This is the callback that is called whenever daemon sends us a
	hole. In the callback we reflect the hole in underlying file by
	seeking as many bytes as told.

	Introduce virStorageVol{Download,Upload}Flags
	These flags to APIs will tell if caller wants to use sparse
	stream for storage transfer. At the same time, it's safe to
	enable them in storage driver frontend and rely on our backends
	checking the flags. This way we can enable specific flags only on
	some specific backends, e.g. enable
	VIR_STORAGE_VOL_DOWNLOAD_SPARSE_STREAM for filesystem backend but
	not iSCSI backend.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	gendispatch: Introduce @sparseflag for our calls
	Now, not all APIs are going to support sparse streams. To some it
	makes no sense at all, e.g. virDomainOpenConsole() or
	virDomainOpenChannel(). To others, we will need a special flag to
	indicate that client wants to enable sparse streams. Instead of
	having to write RPC dispatchers by hand we can just annotate in
	our .x files that a certain flag to certain RPC call enables this
	feature. For instance:

	     /**
	      * @generate: both
	      * @readstream: 1
	      * @sparseflag: VIR_SPARSE_STREAM
	      * @acl: storage_vol:data_read
	      */
	     REMOTE_PROC_DOMAIN_SOME_API = XXX,

	Therefore, whenever client calls virDomainSomeAPI(..,
	VIR_SPARSE_STREAM); daemon will mark that down and send stream
	skips when possible.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	fdstream: Implement sparse stream
	Basically, what is needed here is to introduce new message type
	for the messages passed between the event loop callbacks and the
	worker thread that does all the I/O. The idea is that instead of
	a queue of read buffers we will have a queue where "hole of size
	X" messages appear. That way the event loop callbacks can just
	check the head of the queue and see if the worker thread is in
	data or a hole section and how long the section is.

	daemonStreamHandleRead: Wire up seekable stream
	Whenever client is able to receive some data from stream
	daemonStreamHandleRead is called. But now the behaviour of this
	function needs to be changed a bit. Previously it just read data
	from underlying file (of chardev or whatever) and sent those
	through the stream to client. This model will not work any longer
	because it does not differentiate whether underlying file is in
	data or hole section. Therefore, at the beginning of this
	function add code that checks this situation and acts
	accordingly.
	So after the this, when wanting to send some data we always check
	whether we are not in a hole and if so, skip it an inform client
	about its size.

	remote_driver: Implement VIR_STREAM_RECV_STOP_AT_HOLE
	This is fairly trivial now that we have everything in place.

	virNetClientStream: Wire up VIR_NET_STREAM_HOLE
	Whenever server sends a client stream packet (either regular with
	actual data or stream skip one) it is queued on @st->rx. So the
	list is a mixture of both types of stream packets. So now that we
	have all the helpers needed we can wire their processing up. But
	since virNetClientStreamRecvPacket doesn't support
	VIR_STREAM_RECV_STOP_AT_HOLE flag yet, let's turn all received
	skips into zeroes repeating requested times.

	remote: Implement virStreamRecvHole

	Introduce virNetClientStreamRecvHole
	This function will fetch previously processed stream holes and
	return their sum.

	virNetClientStreamRecvPacket: Introduce @flags argument

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	remote_driver: Implement virStreamSendHole
	Now that we have RPC wrappers over VIR_NET_STREAM_HOLE we can
	start wiring them up. This commit wires up situation when a
	client wants to send a hole to daemon.

	To keep stream offsets synchronous, upon successful call on the
	daemon skip the same hole in local part of the stream.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	virnetclientstream: Introduce virNetClientStreamHandleHole
	This is a function that handles an incoming STREAM_HOLE packet.
	Even though it is not wired up yet, it will be soon. At the
	beginning do couple of checks whether server plays nicely and
	sent us a STREAM_HOLE packed only after we've enabled sparse
	streams. Then decodes the message payload to see how big the hole
	is and stores it in passed @length argument.

	daemon: Implement VIR_NET_STREAM_HOLE handling
	Basically, whenever the new type of stream packet arrives to the
	daemon call this function that decodes it and calls
	virStreamSendHole(). Otherwise a regular data stream packet has
	arrived and therefore continue its processing.

	virnetclientstream: Introduce virNetClientStreamSendHole
	While the previous commit implemented a helper for sending a
	STREAM_HOLE packet for daemon, this is a client's counterpart.

	daemon: Introduce virNetServerProgramSendStreamHole
	This is just a helper function that takes in a length value,
	encodes it into XDR and sends to client.

	Teach wireshark plugin about VIR_NET_STREAM_HOLE
	Ideally, this would be generated, but to achieve that
	corresponding XDR definitions needed to go into a different .x
	file. But they belong just to the one that they are right now.

	Introduce VIR_NET_STREAM_HOLE message type
	This is a special type of stream packet, that is bidirectional
	and contains information regarding how many bytes each side will
	be skipping in the stream.

	RPC: Introduce virNetStreamHole
	This is going to be RPC representation for virStreamSendHole.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	Add new flag to daemonCreateClientStream and virNetClientStreamNew
	Add a new argument to daemonCreateClientStream in order to allow for
	future expansion to mark that a specific stream can be used to skip
	data, such as the case with sparsely populated files. The new flag will
	be the eventual decision point between client/server to decide whether
	both ends can support and want to use sparse streams.

	A new bool 'allowSkip' is added to both _virNetClientStream and
	daemonClientStream in order to perform the tracking.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	virNetClientStreamNew: Track origin stream
	Add a virStreamPtr pointer to the _virNetClientStream
	in order to reverse track the parent stream.

	Introduce virStreamInData
	This is just an internal API, that calls corresponding function
	in stream driver. This function will set @data = 1 if the
	underlying file is in data section, or @data = 0 if it is in a
	hole. At any rate, @length is set to number of bytes remaining in
	the section the file currently is.

	Introduce virStreamSparseSendAll
	This is just a wrapper over new function that have been just
	introduced: virStreamSendHole() . It's very similar to
	virStreamSendAll() except it handles sparse streams well.

	Introduce virStreamSparseRecvAll
	This is just a wrapper over new functions that have been just
	introduced: virStreamRecvFlags(), virStreamRecvHole(). It's very
	similar to virStreamRecvAll() except it handles sparse streams
	well.

	Introduce VIR_STREAM_RECV_STOP_AT_HOLE flag
	Add a new flag to virStreamRecvFlags in order to handle being able to
	stop reading from the stream so that the consumer can generate a "hole"
	in stream target. Generation of a hole replaces the need to receive and
	handle a sequence of zero bytes for sparse stream targets.

	Introduce virStreamRecvHole
	This function is basically a counterpart for virStreamSendHole().
	If one side of a stream called virStreamSendHole() the other
	should call virStreamRecvHole() to get the size of the hole.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	Introduce virStreamSendHole
	This API is used to tell the other side of the stream to skip
	some bytes in the stream. This can be used to create a sparse
	file on the receiving side of a stream.

	It takes @length argument, which says how big the hole is. This
	skipping is done from the current point of stream. Since our
	streams are not rewindable like regular files, we don't need
	@whence argument like seek(2) has.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	Implement virStreamRecvFlags to some drivers
	There are three virStreamDriver's currently supported:

	 * virFDStream
	 * remote driver
	 * ESX driver

	For now, backend virStreamRecvFlags support for only remote driver and
	ESX driver is sufficient. Future patches will update virFDStream.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	Introduce virStreamRecvFlags
	This patch is adding the virStreamRecvFlags as a variant to the
	virStreamRecv function in order to allow for future expansion of
	functionality for processing sparse streams using a @flags
	argument.

	util: Introduce virFileInData
	This function takes a FD and determines whether the current
	position is in data section or in a hole. In addition to that,
	it also determines how much bytes are there remaining till the
	current section ends.

2017-05-18  Michal Privoznik  <mprivozn@redhat.com>

	virfdstream: Use messages instead of pipe
	One big downside of using the pipe to transfer the data is that
	we can really transfer just bare data. No metadata can be carried
	through unless some formatted messages are introduced. That would
	be quite painful to achieve so let's use a message queue. It's
	fairly easy to exchange info between threads now that iohelper is
	no longer used.

	The reason why we cannot use the FD for plain files directly is
	that despite us setting noblock flag on the FD, any
	read()/write() blocks regardless (which is a show stopper since
	those parts of the code are run from the event loop) and poll()
	reports such FD as always readable/writable - even though the
	subsequent operation might block.

	The pipe is still not gone though. It is used to signal the event
	loop that an event occurred (e.g. data is available for reading
	in the queue, or vice versa).

2017-05-18  Gordon Messmer  <gordon@dragonsdawn.net>

	virsh: add --io when attaching disks to guests
	virt-install and virt-manager both default to explicitly setting
	"io='native'" in the disk "driver" tag. virsh, however, does not and also
	does not provide an option to specify that setting at all.  As a result,
	disks use a different IO mechanism (the default, "threads") when attached
	post-setup using virsh.  Adding this option allows users to keep disk
	performance consistent for disks attached at install, and those attached
	afterward.

2017-05-17  Peter Krempa  <pkrempa@redhat.com>

	qemu: driver: Allow passing disk target as top image with block commit
	Since we allow active layer block commit the users are allowed to commit
	the top of the chain (e.g. vda) into the backing image. The API would
	not accept that parameter, as it tried to look up the image in the
	backing chain.

	Add the ability to use the top level image target name explicitly as the
	top image of the block commit operation.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1451394

2017-05-16  Andrea Bolognani  <abologna@redhat.com>

	news: Update for GIC version on TCG changes

	gic: Remove VIR_GIC_VERSION_DEFAULT
	The QEMU default is GICv2, and some of the code in libvirt
	relies on the exact value. Stop pretending that's not the
	case and use GICv2 explicitly where needed.

2017-05-16  Andrea Bolognani  <abologna@redhat.com>

	qemu: Use GICv2 for aarch64/virt TCG guests
	There are currently some limitations in the emulated GICv3
	that make it unsuitable as a default. Use GICv2 instead.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1450433

2017-05-16  Andrea Bolognani  <abologna@redhat.com>

	tests: Check default GIC version for aarch64/virt TCG guests

	qemu: Use qemuDomainMachineIsVirt() more

2017-05-16  Pavel Hrdina  <phrdina@redhat.com>

	qemu: improve detection of UNIX path generated by libvirt
	Currently we consider all UNIX paths with specific prefix as generated
	by libvirt, but that's a wrong assumption.  Let's make the detection
	better by actually checking whether the whole path matches one of the
	paths that we generate or generated in the past.

	The UNIX path isn't stored in config XML since libvirt-1.3.1.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1446980

2017-05-16  Daniel P. Berrange  <berrange@redhat.com>

	remove hack for debian etch limits.h
	The debian etch distro was end-of-life a long time ago so we no
	longer need the ULLONG_MAX hack. In any case gnulib now provides
	an equivalent fix by default, and so our definition now triggers
	syntax-check rule failure

	src/internal.h:#    define ULLONG_MAX   ULONG_LONG_MAX
	maint.mk: define the above via some gnulib .h file
	maint.mk:843: recipe for target 'sc_prohibit_always-defined_macros' failed

2017-05-15  Daniel P. Berrange  <berrange@redhat.com>

	maint: update to latest gnulib
	This pulls in the fixes for poll() on Win32 which finally
	makes the remote driver work again.

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	conf: add ABI stability checks for IOMMU options
	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

	conf: split out virDomainIOMMUDefCheckABIStability

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	qemu: format caching-mode on iommu command line
	Format the caching-mode option for the intel-iommu device,
	based on its <driver caching> attribute value.

	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	conf: add caching_mode attribute to iommu device
	Add a new attribute to control the caching mode.

	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	qemu: format intel-iommu,intremap on the command line
	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	conf: add <driver intremap> to <iommu>
	Add a new attribute to control interrupt remapping.

	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	qemu: format kernel_irqchip on the command line
	Add kernel_irqchip=split/on to the QEMU command line
	and a capability that looks for it in query-command-line-options
	output. For the 'split' option, use a version check
	since it cannot be reasonably probed.

	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Ján Tomko  <jtomko@redhat.com>

	conf: add <ioapic driver> to <features>
	Add a new <ioapic> element with a driver attribute.

	Possible values are qemu and kvm. With 'qemu', the I/O
	APIC can be put in the userspace even for KVM domains.

	https://bugzilla.redhat.com/show_bug.cgi?id=1427005

2017-05-15  Peter Krempa  <pkrempa@redhat.com>

	util: conf: Don't log when adding commented out lines
	virConfAddEntry spams debug logs even for fully commented out lines.
	Skip such messages to avoid:

	2017-05-12 12:35:38.867+0000: 10820: debug : virConfAddEntry:241 : Add entry (null) (nil)
	2017-05-12 12:35:38.867+0000: 10820: debug : virConfAddEntry:241 : Add entry (null) (nil)
	2017-05-12 12:35:38.867+0000: 10820: debug : virConfAddEntry:241 : Add entry (null) (nil)
	2017-05-12 12:35:38.867+0000: 10820: debug : virConfAddEntry:241 : Add entry (null) (nil)
	2017-05-12 12:35:38.867+0000: 10820: debug : virConfAddEntry:241 : Add entry (null) (nil)
	...

	This also fixes NULL passed to printf.

2017-05-15  Serge Hallyn  <serge.hallyn@ubuntu.com>

	storage: use 0711 as the default perms for dirs
	There should be no need to make dir based pools world/group readable.
	So use 0711, not 0755, as the default perms for storage dirs.

	Updates in v2:
	 - adapt commit wording to mention dropping group readable as well

2017-05-15  Daniel P. Berrange  <berrange@redhat.com>

	Detect VMDK version 3 files
	The metadata libvirt cares about is identical for version 3
	as for previous versions, so we merely need list the new
	version number.

2017-05-15  Christian Ehrhardt  <christian.ehrhardt@canonical.com>

	qemu: monitor: do not report error on shutdown
	If a shutdown is expected because it was triggered via libvirt we can
	also expect the monitor to close. In those cases do not report an
	internal error like:
	  "internal error: End of file from qemu monitor"

2017-05-15  Martin Kletzander  <mkletzan@redhat.com>

	test-wrap-argv.pl: Accept short parameter -i for --in-place
	I like to use it that way and every time I try running it I just
	instinctively use '-i' (like with sed, etc.) and it makes sense, IMHO.

2017-05-12  Pavel Hrdina  <phrdina@redhat.com>

	util: introduce virBufferEscapeRegex
	Add a helper to escape all possible meta-characters used for
	POSIX extended regular expressions.

	util: introduce virStringMatch
	Simply tries to match the provided regex on a string and returns
	the result.  Useful if caller don't care about the matched substring
	and want to just test if some pattern patches a string.

2017-05-12  Nikolay Shirokovskiy  <nshirokovskiy@virtuozzo.com>

	docs: install html fonts and related

2017-05-12  John Ferlan  <jferlan@redhat.com>

	virsh: Add --tls description for the virsh man page
	https://bugzilla.redhat.com/show_bug.cgi?id=1448806

	Commit id '6a8d898d' neglected to update the man page.

2017-05-12  John Ferlan  <jferlan@redhat.com>

	conf: Fix resource leak in virCapabilitiesInitCaches
	The @type from virFileReadValueString needs to be VIR_FREE each time
	through the loop since it's not saved and since cleanup can be reached
	prior to decoding it for @kernel_type amd bank->type, the cleanup code
	needs to also have a VIR_FREE

	Found by Coverity

2017-05-12  Andrea Bolognani  <abologna@redhat.com>

	spec: Use HTTPS instead of HTTP
	libvirt.org supports HTTPS, so might as well use it.

2017-05-12  Andrea Bolognani  <abologna@redhat.com>

	spec: Support maintenance releases on mingw
	The regular spec file contains code to deal with the fact
	that maintenance releases are uploaded to their own
	directory: copy it over to the mingw spec file so that it's
	possible to build maintenance releases there as well.

	This also switches the source URL from FTP to HTTP for
	consistency with the main spec file.

2017-05-11  Erik Skultety  <eskultet@redhat.com>

	qemu: Provide a much clearer message on device hot-plug
	Adjust the current message to make it clear, that it is the hotplug
	operation that is unsupported with the given host device type.

	https://bugzilla.redhat.com/show_bug.cgi?id=1450072

2017-05-11  Daniel P. Berrange  <berrange@redhat.com>

	tests: stub out virfilewrapper.c on Win32
	The Win32 platform can not do link time overrides in the same way
	that we can on POSIX / ELF based platforms, so we cannot build
	the virfilewrapper.c code reliably. Just stub it out on Win32
	so it is a no-op. Tests that use this file are already written
	to skip on Win32.

2017-05-11  Wim ten Have  <wim.ten.have@oracle.com>

	libxl: report numa sibling distances on host capabilities
	When running on a NUMA machine, populate the sibling node
	and distance information using data supplied by Xen.

	With locality distances information, under Xen, new host
	capabilities would like:

	    <topology>
	      <cells num='4'>
	        <cell id='0'>
	          <memory unit='KiB'>263902380</memory>
	          <distances>
	            <sibling id='0' value='10'/>
	            <sibling id='1' value='21'/>
	          </distances>
	          ...
	        </cell>
	        ...
	      </cells>
	      ...
	    </topology>

	Reviewed-by: Joao Martins <joao.m.martins@oracle.com>
	Reviewed-by: Jim Fehlig <jfehlig@suse.com>

2017-05-10  Daniel P. Berrange  <berrange@redhat.com>

	Add missing deps on virfilewrapper.h
	The test programs depend on virfilewrapper.h as well as the
	virfilewrapper.c. Adding the dep ensures that virfilewrapper.h
	gets included in the dist tarball.

2017-05-10  Peter Krempa  <pkrempa@redhat.com>

	qemu: driver: Fix usage of qemuOpenFile
	The function returns -errno on failure, not only -1.

	qemu: driver: Document qemuOpenFile
	The function is nontrivial to follow and has non-standard return values.
	Recent usage was buggy.

2017-05-10  Jiri Denemark  <jdenemar@redhat.com>

	conf: Check CPU cache for ABI stability
	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-05-10  Daniel P. Berrange  <berrange@redhat.com>

	Don't inline virStringTrimOptionalNewline
	GCC complains that inlining virStringTrimOptionalNewline is not
	likely on some platforms:

	  cc1: warnings being treated as errors
	  ../../src/util/virfile.c: In function 'virFileReadValueBitmap':
	  ../../src/util/virstring.h:292: error: inlining failed in call to 'virStringTrimOptionalNewline': call is unlikely and code size would grow [-Winline]
	  ../../src/util/virfile.c:3987: error: called from here [-Winline]

	Inlining this function is not going to be a measurable performance
	benefit either, since the time required to execute it is going to
	be dominated by running of strlen() over the string, not by the
	function call overhead.

2017-05-10  Cole Robinson  <crobinso@redhat.com>

	spec: Update version check for maint Source URL
	New maint release version numbers of just A.B.C format, not the old
	A.B.C.D format. Adjust the check that dynamically changes the Source
	URL for maint releases

	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-05-09  Kothapally Madhu Pavan  <kmp@linux.vnet.ibm.com>

	Adding POWER9 cpu model to cpu_map.xml
	As POWER9 model is not available in cpu_map.xml virsh capabilities
	donot display the cpu model and vendor details. This patch
	provides those details

2017-05-09  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	tests: fix virfilewrapper
	If __lxstat() and __xstat() functions are not available, build fails with:

	  CC       virfilewrapper.o
	virfilewrapper.c:180:5: error: no previous prototype for function '__lxstat' [-Werror,-Wmissing-prototypes]
	int __lxstat(int ver, const char *path, struct stat *sb)
	    ^
	virfilewrapper.c:208:5: error: no previous prototype for function '__xstat' [-Werror,-Wmissing-prototypes]
	int __xstat(int ver, const char *path, struct stat *sb)

	Luckily, we already check presence of these functions in configure
	using AC_CHECK_FUNCS, so just don't wrap these if they're not available.

2017-05-09  Martin Kletzander  <mkletzan@redhat.com>

	util: Define SYSFS_SYSTEM_PATH unconditionally in virhostcpu
	The code is already prepared to handle the non-existence of it.

	tests: Add resctrl test for vircaps2xmltest
	Add info from yet another machine, this time with resctrl data so that
	we can extend tests easily in a test-driven way.

	tests: Add support for more complicated hierarchies in vircaps2xmltest
	More directories will need to be mocked, so let's prepare for that.

	Init host cache info in drivers
	Added only in drivers that were already calling
	virCapabilitiesInitNUMA().  Instead of refactoring all the callers to
	behave the same way in case of error, just follow what the callers are
	doing for all the functions.

2017-05-09  Martin Kletzander  <mkletzan@redhat.com>

	Add host cache information in capabilities
	We're only adding only info about L3 caches, we can add more
	later (just by changing one line), but for now that's more than enough
	without overwhelming anyone.

	XML snippet of how this should look like (also seen as part of the commit):

	  <cache>
	    <bank id='0' level='3' type='both' size='8192' unit='KiB' cpus='0-7'/>
	  </cache>

2017-05-09  Martin Kletzander  <mkletzan@redhat.com>

	tests: Add missing cache data for vircaps2xmltest
	Commit a0fdd2f6f9a0cc77ae285c289e2c16d314b6a907 added some data from
	the system but forgot 3 files for each cache.

	tests: Test vircaps2xmldata XMLs in virschematest

2017-05-09  Martin Kletzander  <mkletzan@redhat.com>

	util: Remove virsysfs and instead enhance virFileReadValue* functions
	It is no longer needed thanks to the great virfilewrapper.c.  And this
	way we don't have to add a new set of functions for each prefixed
	path.

	While on that, add two functions that weren't there before, string and
	scaled integer reading ones.  Also increase the length of the string
	being read by one to accompany for the optional newline at the
	end (i.e. change INT_STRLEN_BOUND to INT_BUFSIZE_BOUND).

2017-05-09  Martin Kletzander  <mkletzan@redhat.com>

	tests: Add virfilewrapper -- the new super "mock"
	This mock (which is actually not mock at all, see later) can redirect
	all accesses to a path into another path.  There is no need to
	create mocks for particular directories, you just create a directory
	with all the data a redirect the test there.

	In the future, this should also be able to register callbacks for
	calls/paths, e.g. when the test is going to write into anything under
	"/sys/devices", call function fce();  Then in the open() call we would
	add information about the fd into some structure and in write() we
	would call fce() with parameters like @path to write to, @data to
	be written and pointer to optional return value, so that fce() itself
	could stop the call from happening or change its behaviour.  But
	that's an idea for a latter day.

	This is not a mock because it will not be preloaded, but compiled in
	the test itself.  See future patches for usage.

2017-05-09  Erik Skultety  <eskultet@redhat.com>

	mdev: Cleanup code after commits @daf5081b and @2739a983
	So, because mingw is somehow OK with dereferencing a pointer within a
	VIR_DEBUG macro, compared to outside of it to which it complained with a
	"potential NULL pointer dereference" error (still a false positive), we
	can make the code a tiny bit cleaner.

	Sighed-by: Erik Skultety <eskultet@redhat.com>

2017-05-09  Daniel P. Berrange  <berrange@redhat.com>

	Don't use ceph-devel on Fedora
	A previous commit changed the spec to use librbd1-devel on
	RHEL-7, since this replaces ceph-devel from RHEL-6:

	  commit 6cfc8834c858849cc74c3082078dc91fb1cbae38
	  Author: Peter Krempa <pkrempa@redhat.com>
	  Date:   Thu Mar 5 11:40:54 2015 +0100

	    spec: Enable RBD storage driver in RHEL-7

	    Use correct package names too as they differ.

	RHEL-7 inherited this rename from Fedora though, so it should
	have also made Fedora use the new names.

	This was missed, because Fedora still provides a (deprecated)
	back-compat RPM for ceph-devel that just pulls in librbd1-devel
	(and others).

	Fixing this stops libvirt pulling Java into the build root in
	Fedora.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-05-09  Andrea Bolognani  <abologna@redhat.com>

	HACKING: Document developer tooling
	Advertise some of the useful developer tooling libvirt
	integrates with out of the box.

2017-05-09  Andrea Bolognani  <abologna@redhat.com>

	Add YouCompleteMe support
	YouCompleteMe[1] is a vim plugin that implements semantic
	code completion using libclang.

	For non-trivial projects such as libvirt, the plugin needs
	some help figuring out where to find the various header
	files: generate its configuration file at configure time
	so that the plugin works out of the box.

	[1] http://valloric.github.io/YouCompleteMe/

2017-05-09  Andrea Bolognani  <abologna@redhat.com>

	Add color_coded support
	color_coded[1] is a vim plugin that implements semantic
	syntax highlighting using libclang.

	For non-trivial projects such as libvirt, the plugin needs
	some help figuring out where to find the various header
	files: generate its configuration file at configure time
	so that the plugin works out of the box.

	[1] https://github.com/jeaye/color_coded

2017-05-09  Erik Skultety  <eskultet@redhat.com>

	Post-release version bump to 3.4.0

2017-05-09  Daniel P. Berrange  <berrange@redhat.com>

	configure: enforce presence of python for build
	The API docs extractor, ESX code generator and keycodemapdb tools
	rely on python. Historically every platform that this present, but
	with switch to Python3 by default, we're increasingly seeing
	installs without a /usr/bin/python.

	This tightens up the check during configure, so it exits immediately
	if python is missing, rather than leaving an empty $(PYTHON) make
	variable which leads to more obscure errors later.

	Also add it as a build dep for Mingw, since Fedora build roots no
	longer get python2 by default. This was not previously a major
	problem, since both ESX & API generated files were included in
	EXTRA_DIST, but the keycodemapdb generated files are not, so we
	require python all the time now.

2017-05-06  Daniel Veillard  <veillard@redhat.com>

	Release of libvirt-3.3.0
	* docs/news.xml: updated for release
	* po/*.po*: regenerated

2017-05-05  Michal Privoznik  <mprivozn@redhat.com>

	virNWFilterObjListFree: Don't leak nwfilters->objs
	When adding a nwfilter onto the list in
	virNWFilterObjListAssignDef() this array is re-allocated to match
	demand for new size. However, it is never freed leading to a
	leak:

	==26535== 136 bytes in 1 blocks are definitely lost in loss record 1,079 of 1,250
	==26535==    at 0x4C2E2BE: realloc (vg_replace_malloc.c:785)
	==26535==    by 0x54BA28E: virReallocN (viralloc.c:245)
	==26535==    by 0x54BA384: virExpandN (viralloc.c:294)
	==26535==    by 0x54BA657: virInsertElementsN (viralloc.c:436)
	==26535==    by 0x55DB011: virNWFilterObjListAssignDef (virnwfilterobj.c:362)
	==26535==    by 0x55DB530: virNWFilterObjListLoadConfig (virnwfilterobj.c:503)
	==26535==    by 0x55DB635: virNWFilterObjListLoadAllConfigs (virnwfilterobj.c:539)
	==26535==    by 0x2AC5A28B: nwfilterStateInitialize (nwfilter_driver.c:250)
	==26535==    by 0x5621C64: virStateInitialize (libvirt.c:770)
	==26535==    by 0x124379: daemonRunStateInit (libvirtd.c:881)
	==26535==    by 0x554AC78: virThreadHelper (virthread.c:206)
	==26535==    by 0x8F5F493: start_thread (in /lib64/libpthread-2.23.so)

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-05-04  Michal Privoznik  <mprivozn@redhat.com>

	virPerfEventIsEnabled: Accept NULL @perf
	After bdcf6e481 there is a crasher in libvirt. The commit assumes
	that priv->perf is always set. That is not true. For inactive
	domains, the priv->perf is not allocated as it is set in
	qemuProcessLaunch(). Now, usually we differentiate between
	accesses to inactive and active definition and it works just
	fine. Except for 'domstats'. There priv->perf is accessed without
	prior check for domain inactivity. While we could check for that,
	more robust solution is to make virPerfEventIsEnabled() accept
	NULL.

	How to reproduce:
	1) ensure you have at least one inactive domain
	2) virsh domstats

	Reviewed-by: Daniel P. Berrange <berrange@redhat.com>

2017-05-04  Erik Skultety  <eskultet@redhat.com>

	mdev: Fix mingw build by adding a check for non-NULL pointer
	This patch fixes the following MinGW error (although actually being a
	false positive):

	../../src/util/virmdev.c: In function 'virMediatedDeviceListMarkDevices':
	../../src/util/virmdev.c:453:21: error: potential null pointer
	dereference [-Werror=null-dereference]
	          const char *mdev_path = mdev->path;
	                      ^~~~~~~~~

2017-05-04  Andrea Bolognani  <abologna@redhat.com>

	news: Fix typo
	Pointed-out-during-review-by: Ján Tomko <jtomko@redhat.com>
	Not-fixed-before-pushing-by: Andrea Bolognani <abologna@redhat.com>

	news: Add even more v3.3.0 entries

2017-05-04  Erik Skultety  <eskultet@redhat.com>

	mdev: Fix daemon crash on domain shutdown after reconnect
	The problem resides in virHostdevUpdateActiveMediatedDevices which gets
	called during qemuProcessReconnect. The issue here is that
	virMediatedDeviceListAdd takes a pointer to the item to be added to the
	list to which VIR_APPEND_ELEMENT is used, which also clears the pointer.
	However, in this case only the local copy of the pointer got cleared,
	leaving the original pointing to valid memory. To sum it up, during
	cleanup phase, the original pointer is freed and the daemon crashes
	basically any time it would access it.

	Backtrace:
	0x00007ffff3ccdeba in __strcmp_sse2_unaligned
	0x00007ffff72a444a in virMediatedDeviceListFindIndex
	0x00007ffff7241446 in virHostdevReAttachMediatedDevices
	0x00007fffc60215d9 in qemuHostdevReAttachMediatedDevices
	0x00007fffc60216dc in qemuHostdevReAttachDomainDevices
	0x00007fffc6046e6f in qemuProcessStop
	0x00007fffc6091596 in processMonitorEOFEvent
	0x00007fffc6091793 in qemuProcessEventHandler
	0x00007ffff7294bf5 in virThreadPoolWorker
	0x00007ffff7294184 in virThreadHelper
	0x00007ffff3fdc3c4 in start_thread () from /lib64/libpthread.so.0
	0x00007ffff3d269cf in clone () from /lib64/libc.so.6

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1446455

	Reviewed-by: Laine Stump <laine@laine.org>

2017-05-04  Erik Skultety  <eskultet@redhat.com>

	util: mdev: Use a local variable instead of a direct pointer access
	Use a local variable to hold data, rather than accessing the pointer
	after calling virMediatedDeviceListAdd (therefore VIR_APPEND_ELEMENT).
	Although not causing an issue at the moment, this change is a necessary
	prerequisite for tweaking virMediatedDeviceListAdd in a separate patch,
	which will take a reference for the source pointer (instead of pointer
	value) and will clear it along the way.

	Reviewed-by: Laine Stump <laine@laine.org>
	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-05-03  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainDetachDeviceUnlink: Don't unlink files we haven't created
	Even though there are several checks before calling this function
	and for some scenarios we don't call it at all (e.g. on disk hot
	unplug), it may be possible to sneak in some weird files (e.g. if
	domain would have RNG with /dev/shm/some_file as its backend). No
	matter how improbable, we shouldn't unlink it as we would be
	unlinking a file from the host which we haven't created in the
	first place.

	Reviewed-by: Cedric Bosdonnat <cbosdonnat@suse.com>

2017-05-03  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainAttachDeviceMknodRecursive: Don't try to create devices under preserved mount points
	Just like in previous commit, this fixes the same issue for
	hotplug.

	Reviewed-by: Cedric Bosdonnat <cbosdonnat@suse.com>

2017-05-03  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainCreateDeviceRecursive: Don't try to create devices under preserved mount points
	While the code allows devices to already be there (by some
	miracle), we shouldn't try to create devices that don't belong to
	us. For instance, we shouldn't try to create /dev/shm/file
	because /dev/shm is a mount point that is preserved. Therefore if
	a file is created there from an outside (e.g. by mgmt application
	or some other daemon running on the system like vhostmd), it
	exists in the qemu namespace too as the mount point is the same.
	It's only /dev and /dev only that is different. The same
	reasoning applies to all other preserved mount points.

	Reviewed-by: Cedric Bosdonnat <cbosdonnat@suse.com>

2017-05-03  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainCreateDeviceRecursive: pass a structure instead of bare path
	Currently, all we need to do in qemuDomainCreateDeviceRecursive() is to
	take given @device, get all kinds of info on it (major & minor numbers,
	owner, seclabels) and create its copy at a temporary location @path
	(usually /var/run/libvirt/qemu/$domName.dev), if @device live under
	/dev. This is, however, very loose condition, as it also means
	/dev/shm/* is created too. Therefor, we will need to pass more arguments
	into the function for better decision making (e.g. list of mount points
	under /dev). Instead of adding more arguments to all the functions (not
	easily reachable because some functions are callback with strictly
	defined type), lets just turn this one 'const char *' into a 'struct *'.
	New "arguments" can be then added at no cost.

	Reviewed-by: Cedric Bosdonnat <cbosdonnat@suse.com>

2017-05-03  Michal Privoznik  <mprivozn@redhat.com>

	qemuDomainBuildNamespace: Move /dev/* mountpoints later
	When setting up mount namespace for a qemu domain the following
	steps are executed:

	1) get list of mountpoints under /dev/
	2) move them to /var/run/libvirt/qemu/$domName.ext
	3) start constructing new device tree under /var/run/libvirt/qemu/$domName.dev
	4) move the mountpoint of the new device tree to /dev
	5) restore original mountpoints from step 2)

	Note the problem with this approach is that if some device in step
	3) requires access to a mountpoint from step 2) it will fail as
	the mountpoint is not there anymore. For instance consider the
	following domain disk configuration:

	    <disk type='file' device='disk'>
	      <driver name='qemu' type='raw'/>
	      <source file='/dev/shm/vhostmd0'/>
	      <target dev='vdb' bus='virtio'/>
	      <address type='pci' domain='0x0000' bus='0x00' slot='0x0a' function='0x0'/>
	    </disk>

	In this case operation fails as we are unable to create vhostmd0
	in the new device tree because after step 2) there is no /dev/shm
	anymore. Leave aside fact that we shouldn't try to create devices
	living in other mountpoints. That's a separate bug that will be
	addressed later.

	Currently, the order described above is rearranged to:

	1) get list of mountpoints under /dev/
	2) start constructing new device tree under /var/run/libvirt/qemu/$domName.dev
	3) move them to /var/run/libvirt/qemu/$domName.ext
	4) move the mountpoint of the new device tree to /dev
	5) restore original mountpoints from step 3)

	Reviewed-by: Cedric Bosdonnat <cbosdonnat@suse.com>

2017-05-03  Andrea Bolognani  <abologna@redhat.com>

	news: Add more v3.3.0 entries
	These entries cover a number of features, improvements and
	bug fixes that had not been documented during the development
	cycle.

	news: Tweak existing v3.3.0 entries
	Some of the content was not following the (loosely established)
	style, and some of the XML was not aligned properly.

2017-05-03  Jiri Denemark  <jdenemar@redhat.com>

	client: Report proper close reason
	When we get a POLLHUP or VIR_EVENT_HANDLE_HANGUP event for a client, we
	still want to read from the socket to process any accumulated data. But
	doing so inevitably results in an error and a call to
	virNetClientMarkClose before we get to processing the hangup event (and
	another call to virNetClientMarkClose). However the close reason passed
	to the second virNetClientMarkClose call is ignored because another one
	was already set. We need to pass the correct close reason when marking
	the socket to be closed for the first time.

	https://bugzilla.redhat.com/show_bug.cgi?id=1373859

2017-05-03  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Fix persistent migration of transient domains
	While fixing a bug with incorrectly freed memory in commit
	v3.1.0-399-g5498aa29a, I accidentally broke persistent migration of
	transient domains. Before adding qemuDomainDefCopy in the path, the code
	just took NULL from vm->newDef and used it as the persistent def, which
	resulted in no persistent XML being sent in the migration cookie. This
	scenario is perfectly valid and the destination correctly handles it by
	using the incoming live definition and storing it as the persistent one.

	After the mentioned commit libvirtd would just segfault in the described
	scenario.

	https://bugzilla.redhat.com/show_bug.cgi?id=1446205

2017-05-03  Daniel P. Berrange  <berrange@redhat.com>

	Fix padding of encrypted data
	If we are encoding a block of data that is 16 bytes in length,
	we cannot leave it as 16 bytes, we must pad it out to the next
	block boundary, 32 bytes. Without this padding, the decoder will
	incorrectly treat the last byte of plain text as the padding
	length, as it can't distinguish padded from non-padded data.

	The problem exhibited itself when using a 16 byte passphrase
	for a LUKS volume

	  $ virsh secret-set-value 55806c7d-8e93-456f-829b-607d8c198367 \
	       $(echo -n 1234567812345678 | base64)
	  Secret value set

	  $ virsh start demo
	  error: Failed to start domain demo
	  error: internal error: process exited while connecting to monitor: >>>>>>>>>>Len 16
	  2017-05-02T10:35:40.016390Z qemu-system-x86_64: -object \
	    secret,id=virtio-disk1-luks-secret0,data=SEtNi5vDUeyseMKHwc1c1Q==,\
	    keyid=masterKey0,iv=zm7apUB1A6dPcH53VW960Q==,format=base64: \
	    Incorrect number of padding bytes (56) found on decrypted data

	Notice how the padding '56' corresponds to the ordinal value of
	the character '8'.

2017-05-02  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Don't reset "events" migration capability
	When creating v3.2.0-77-g8be3ccd04 commit, I completely forgot that one
	migration capability is very special. It's the "events" capability which
	tells QEMU to report "MIGRATION" events. Since libvirt always wants the
	events, it is enabled in qemuConnectMonitor and the rest of the code
	should not touch it.

	https://bugzilla.redhat.com/show_bug.cgi?id=1439841
	https://bugzilla.redhat.com/show_bug.cgi?id=1441165

	Messed-up-by: Jiri Denemark <jdenemar@redhat.com>

2017-05-02  Julio Faracco  <jcfaracco@gmail.com>

	virsh-domain-monitor: add human readable output for 'domblkinfo'.
	https://bugzilla.redhat.com/show_bug.cgi?id=1330940

	The virsh command 'domblkinfo' returns the capacity, allocation and phisycal
	size of the devices attached in a domain. Usually, this sizes are very big
	and hard to understand and calculate. This commits introduce a human readable
	support to check the size of each field easilly.

	For example, the command before:

	virsh # domblkinfo my_domain hda
	Capacity:       21474836480
	Allocation:     14875545600
	Physical:       21474836480

	and after this patch:

	virsh # domblkinfo my_domain hda --human
	Capacity:       20.000G
	Allocation:     13.900G
	Physical:       20.000G

	Reviewed-by: Michal Privoznik <mprivozn@redhat.com>

2017-04-28  Jim Fehlig  <jfehlig@suse.com>

	news: Document libxl nested HVM support
	Nested HVM support in the libxl driver is a news-worthy
	improvement for libvirt 3.3.0.

	Reviewed-by: Pavel Hrdina <phrdina@redhat.com>

2017-04-28  Laine Stump  <laine@laine.org>

	util: rename/move VIR_NET_GENERATED_PREFIX to be consistent
	... with VIR_NET_GENERATED_MACV???_PREFIX, which is defined in
	util/virnetdevmacvlan.h.

	Since VIR_NET_GENERATED_PREFIX is used for plain tap devices, it is
	renamed to VIR_NET_GENERATED_TAP_PREFIX and moved to virnetdev.h

2017-04-28  Laine Stump  <laine@laine.org>

	conf: don't ignore <target dev='blah'/> for macvtap interfaces
	The parser had been clearing out *all* suggested device names for
	type='direct' (aka macvtap) interfaces. All of the code implementing
	macvtap allows for a user-specified device name, so we should allow
	it. In the case that an interface name starts with "macvtap" or
	"macvlan" though, we do still clear it out, just as we do with "vnet"
	(which is the prefix used for automatically generated tap device
	names), since those are the prefixes for the names we autogenerate for
	macvtap and macvlan devices.

	Resolves: https://bugzilla.redhat.com/1335798

2017-04-28  Laine Stump  <laine@laine.org>

	util: make macvtap/macvlan generated name #defines available to other files
	MACVTAP_NAME_PREFIX and MACVLAN_NAME_PREFIX could be useful to other
	files if they were defined in virnetdevmacvlan.h instead of
	virnetdevmacvlan.c, so do that (while slightly renaming them and also
	adding yet another #define that chooses between macvlan/macvtap based
	on flags).

	This is a prerequisite to fix: https://bugzilla.redhat.com/1335798

2017-04-28  Laine Stump  <laine@laine.org>

	network: better log message when network is inactive during reconnect
	If the network isn't active during networkNotifyActualDevice(), we
	would log an error message stating that the bridge device didn't
	exist. This patch adds a check to see if the network is active, making
	the logs more useful in the case that it isn't.

	Partially resolves: https://bugzilla.redhat.com/1442700

2017-04-28  Laine Stump  <laine@laine.org>

	qemu: don't kill qemu process on restart if networkNotify fails
	Nothing that could happen during networkNotifyActualDevice() could
	justify unceremoniously killing the qemu process, but that's what we
	were doing.

	In particular, new code added in commit 85bcc022 (first appearred in
	libvirt-3.2.0) attempts to reattach tap devices to their assigned
	bridge devices when libvirtd restarts (to make it easier to recover
	from a restart of a libvirt network). But if the network has been
	stopped and *not* restarted, the bridge device won't exist and
	networkNotifyActualDevice() will fail.

	This patch changes networkNotifyActualDevice() and
	qemuProcessNotifyNets() to return void, so that qemuProcessReconnect()
	will soldier on regardless of what happens (any errors will still be
	logged though).

	Partially resolves: https://bugzilla.redhat.com/1442700

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	conf: format only relevant attributes for graphics based on listen type
	This patch changes following output:

	    ...
	    <graphics type='vnc' port='-1' autoport='yes'>
	      <listen type='none'/>
	    </graphics>
	    ...

	into this output:

	    ...
	    <graphics type='vnc'>
	      <listen type='none'/>
	    </graphics>
	    ...

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	iohelper: Remove unused mode
	After 1eb6647979f8c nobody calls the iohelper with 6 arguments.
	Everybody uses the other mode. Well, the only user of iohelper
	after the previous commit is virFileWrapperFd really.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	virfdstream: Drop iohelper in favour of a thread
	Currently we use iohelper for virFDStream implementation. This is
	because UNIX I/O can lie sometimes: even though a FD for a
	file/block device is set as unblocking, actual read()/write() can
	block. To avoid this, a pipe is created and one end is kept for
	read/write while the other is handed over to iohelper to
	write/read the data for us. Thus it's iohelper which gets blocked
	and not our event loop.

	This approach has two problems:
	1) we are spawning a new process.
	2) any exchange of information between daemon and iohelper can be
	done only through the pipe.

	Therefore, iohelper is replaced with an implementation in thread
	which is created just for the stream lifetime. The data are still
	transferred through pipe (for now), but both problems described
	above are solved.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	virFDStreamData: Turn into virObjectLockable
	While this is no functional change, it makes the code look a bit
	nicer. Moreover, it prepares ground for future work.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	fdstream: s/struct virFDStreamData */virFDStreamDataPtr/
	There is really no reason why we should have to have 'struct'
	everywhere.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	fdstreamtest: Print more info on read failure
	It helps with debugging if we know what's the return value of
	saferead().

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Michal Privoznik  <mprivozn@redhat.com>

	fdstreamtest: Rename tempdir
	Because of copy-paste the temporary directory used for this test
	is called "fakesysdir". That's probably misleading.

	Reviewed-by: John Ferlan <jferlan@redhat.com>

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	qemu: use qemu-xhci USB controller by default for ppc64 and aarch64
	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1438682

	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	qemu: add support for qemu-xhci USB controller
	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1438682

	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	qemu: introduce QEMU_CAPS_DEVICE_QEMU_XHCI
	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	qemu: use nec-usb-xhci as a default controller for aarch64 if available
	This is a USB3 controller and it's a better choice than piix3-uhci.

	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-04-28  Pavel Hrdina  <phrdina@redhat.com>

	qemu: change the logic of setting default USB controller
	The new logic will set the piix3-uhci if available regardless of
	any architecture and it will be updated to better model based on
	architecture and device existence.

	Acked-by: Andrea Bolognani <abologna@redhat.com>

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	tests: genericxml2xml: Add test case for HTTP based disk

	conf: Extract formatting of network disk source into separate function

	docs: schemas: Split up definitions for NBD and gluster
	NBD does not mandate a "filename". Gluster can have more servers. Split
	them so that we can tighten the schema.

	docs: schemas: Split out simple network protocols
	ftp/tftp/sheepdog have a mandatory filename and support only one host.
	There are no additional options for them.

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	docs: schemas: Extract HTTP disk source specification
	Make the schema more strict for HTTP disks requiring a name and
	mandating exactly one source host.

	ftp/tftp entries were not moved here, since http transport also will
	support cookies and other options, which will be added later.

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	docs: schemas: Extract RBD-specific data
	RBD driver supports specifying a snapshot image name or config file.
	Create a define for RBD and move the specifics there.

	docs: schemas: Move the interleave definition into network disk source
	Move it to the place where actually interleaving elements can be placed.

	docs: schemas: Extract disk source host specification
	'diskSourceNetwork' schema define was rather big and it would be hard to
	simplify it. Split out the host portion subelement into a separate
	define.

	docs: schemas: Remove <interleave> from file/block/dir/volume disks
	They don't contain any elements to interleave.

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	qemu: Don't fail if physical size can't be updated in qemuDomainGetBlockInfo
	Since commit c5f6151390 qemuDomainBlockInfo tries to update the
	"physical" storage size for all network storage and not only block
	devices.

	Since the storage driver APIs to do this are not implemented for certain
	storage types (RBD, iSCSI, ...) the code would fail to retrieve any data
	since the failure of qemuDomainStorageUpdatePhysical is fatal.

	Since it's desired to return data even if the total size can't be
	updated we need to ignore errors from that function and return plausible
	data.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1442344

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	qemu: Move freeing of PCI address list to qemuProcessStop
	Rather than freeing the list before starting a new VM clear it after
	stopping the old instance when the data becomes invalid.

	qemu: process: Clean up priv->migTLSAlias
	The alias would be leaked, since it's not freed on the vm stop path.

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Don't leak priv->usbaddrs after VM restart
	Since the private data structure is not freed upon stopping a VM, the
	usbaddrs pointer would be leaked:

	==15388== 136 (16 direct, 120 indirect) bytes in 1 blocks are definitely lost in loss record 893 of 1,019
	==15388==    at 0x4C2CF55: calloc (vg_replace_malloc.c:711)
	==15388==    by 0x54BF64A: virAlloc (viralloc.c:144)
	==15388==    by 0x5547588: virDomainUSBAddressSetCreate (domain_addr.c:1608)
	==15388==    by 0x144D38A2: qemuDomainAssignUSBAddresses (qemu_domain_address.c:2458)
	==15388==    by 0x144D38A2: qemuDomainAssignAddresses (qemu_domain_address.c:2515)
	==15388==    by 0x144ED1E3: qemuProcessPrepareDomain (qemu_process.c:5398)
	==15388==    by 0x144F51FF: qemuProcessStart (qemu_process.c:5979)
	[...]

2017-04-28  Peter Krempa  <pkrempa@redhat.com>

	qemu: process: Clean automatic NUMA/cpu pinning information on shutdown
	Clean the stale data after shutting down the VM. Otherwise the data
	would be leaked on next VM start. This happens due to the fact that the
	private data object is not freed on destroy of the VM.

2017-04-28  Wim ten Have  <wim.ten.have@oracle.com>

	xlconfigtest: add tests for 'nestedhvm' support
	Testing various configuration schemas targeting postive and negative
	nestedhvm under libvirt <cpu mode="host-passthrough"> configuration.

	Mode "host-passthrough" generates nestedhvm=1 in/from xl format where

	Intel virtualization (VT-x):
	<feature policy='disable' name='vmx'/>

	    or

	AMD virtualization (AMD-V):
	<feature policy='disable' name='svm'/>

	disables virtualization mode under guest domains.

2017-04-28  Wim ten Have  <wim.ten.have@oracle.com>

	xenconfig: add conversions for xen-xl
	Per xen-xl conversions from and to native under host-passthrough
	mode we take care for Xen (nestedhvm = mode) applied and inherited
	settings generating or processing correct feature policy:

	[On Intel (VT-x) architectures]
	<feature policy='disable' name='vmx'/>

	or

	[On AMD (AMD-V) architectures]
	<feature policy='disable' name='svm'/>

	It will then generate (or parse) for nestedhvm=1 in/from xl format.

2017-04-28  Wim ten Have  <wim.ten.have@oracle.com>

	libxl: set nestedhvm for mode host-passthrough
	Xen feature nestedhvm is the option on Xen 4.4+ which enables
	nested virtualization when mode host-passthrough is applied.

	nested HVM is enabled by adding below on the target domain;
	<cpu mode='host-passthrough'/>

	Virtualization on target domain can be disabled by specifying
	such under feature policy rule on target name;

	[On Intel (VT-x) architecture]
	<feature policy='disable' name='vmx'/>

	or:

	[On AMD (AMD-V) architecture]
	<feature policy='disable' name='svm'/>

2017-04-28  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Add support for guest CPU cache
	This patch maps /domain/cpu/cache element into -cpu parameters:

	- <cache mode='passthrough'/> is translated to host-cache-info=on
	- <cache level='3' mode='emulate'/> is transformed into l3-cache=on
	- <cache mode='disable'/> is turned in host-cache-info=off,l3-cache=off

	Any other <cache> element is forbidden.

	The tricky part is detecting whether QEMU supports the CPU properties.

	The 'host-cache-info' property is introduced in v2.4.0-1389-ge265e3e480,
	earlier QEMU releases enabled host-cache-info by default and had no way
	to disable it. If the property is present, it defaults to 'off' for any
	QEMU until at least 2.9.0.

	The 'l3-cache' property was introduced later by v2.7.0-200-g14c985cffa.
	Earlier versions worked as if l3-cache=off was passed. For any QEMU
	until at least 2.9.0 l3-cache is 'off' by default.

	QEMU 2.9.0 was the first release which supports probing both properties
	by running device-list-properties with typename=host-x86_64-cpu. Older
	QEMU releases did not support device-list-properties command for CPU
	devices. Thus we can't really rely on probing them and we can just use
	query-cpu-model-expansion QMP command as a witness.

	Because the cache property probing is only reliable for QEMU >= 2.9.0
	when both are already supported for quite a few releases, we let QEMU
	report an error if a specific cache mode is explicitly requested. The
	other mode (or both if a user requested CPU cache to be disabled) is
	explicitly turned off for QEMU >= 2.9.0 to avoid any surprises in case
	the QEMU defaults change. Any older QEMU already turns them off so not
	doing so explicitly does not make any harm.

2017-04-28  Jiri Denemark  <jdenemar@redhat.com>

	Add support for CPU cache specification
	This patch introduces

	    <cache level='N' mode='emulate'/>
	    <cache mode='passthrough'/>
	    <cache mode='disable'/>

	sub element of /domain/cpu. Currently only a single <cache> element is
	allowed.

2017-04-28  Jiri Denemark  <jdenemar@redhat.com>

	conf: Rename mode parameter in virCPUDefParseXML
	The type of this parameter is virCPUType so calling it 'mode' is pretty
	strange, 'type' is a much better name.

2017-04-27  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Report VIR_DOMAIN_JOB_OPERATION
	Not all async jobs are visible via virDomainGetJobStats (either they are
	too fast or getting the stats is not allowed during the job), but
	forcing all of them to advertise the operation is easier than hunting
	the jobs for which fetching statistics is allowed. And we won't need to
	think about this when we add support for getting stats for more jobs.

	https://bugzilla.redhat.com/show_bug.cgi?id=1441563

2017-04-27  Jiri Denemark  <jdenemar@redhat.com>

	Add VIR_DOMAIN_JOB_OPERATION typed parameter
	The parameter is reported by virDomainGetJobStats API and
	VIR_DOMAIN_EVENT_ID_JOB_COMPLETED event and it can be used to identify
	the operation (migration, snapshot, ...) to which the reported
	statistics belong.

	https://bugzilla.redhat.com/show_bug.cgi?id=1441563

2017-04-27  Eric Farman  <farman@linux.vnet.ibm.com>

	qemu: Remove extra messages for vhost-scsi hotplug
	As with virtio-scsi, the "internal error" messages after
	preparing a vhost-scsi hostdev overwrites more meaningful
	error messages deeper in the callchain.  Remove it too.

2017-04-27  Eric Farman  <farman@linux.vnet.ibm.com>

	qemu: Remove extra messages from virtio-scsi hotplug
	I tried to attach a SCSI LUN to two different guests, and forgot
	to specify "shareable" in the hostdev XML.  Attaching the device
	to the second guest failed, but the message was not helpful in
	telling me what I was doing wrong:

	  $ cat scsi_scratch_disk.xml
	    <hostdev mode='subsystem' type='scsi'>
	      <source>
	        <adapter name='scsi_host3'/>
	        <address bus='0' target='15' unit='1074151456'/>
	      </source>
	    </hostdev>

	  $ virsh attach-device dasd_sles_d99c scsi_scratch_disk.xml
	  Device attached successfully

	  $ virsh attach-device dasd_fedora_0e1e scsi_scratch_disk.xml
	  error: Failed to attach device from scsi_scratch_disk.xml
	  error: internal error: Unable to prepare scsi hostdev: scsi_host3:0:15:1074151456

	I eventually discovered my error, but thought it was weird that
	Libvirt doesn't provide something more helpful in this case.
	Looking over the code we had just gone through, I commented out
	the "internal error" message, and got something more useful:

	  $ virsh attach-device dasd_fedora_0e1e scsi_scratch_disk.xml
	  error: Failed to attach device from scsi_scratch_disk.xml
	  error: Requested operation is not valid: SCSI device 3:0:15:1074151456 is already in use by other domain(s) as 'non-shareable'

	Looking over the error paths here, we seem to issue better
	messages deeper in the callchain so these "internal error"
	messages overwrite any of them.  Remove them, so that the
	more detailed errors are seen.

2017-04-27  Eric Farman  <farman@linux.vnet.ibm.com>

	qemu: Check return code from qemuHostdevPrepareSCSIDevices

2017-04-27  Nikolay Shirokovskiy  <nshirokovskiy@virtuozzo.com>

	qemu: migration: fix race on cancelling drive mirror
	0feebab2 adds calling qemuBlockNodeNamesDetect for completed job
	on updating block jobs. This affects cancelling drive mirror logic as
	this function drops vm lock. Now we have to recheck all disks
	before the disk with the completed block job before going
	to wait for block job events.

	qemu: take current async job into account in qemuBlockNodeNamesDetect
	Becase it can be called during migration out (namely on cancelling
	blockjobs).

2017-04-27  Peter Krempa  <pkrempa@redhat.com>

	qemu: numa: Don't return automatic nodeset for inactive domain
	qemuDomainGetNumaParameters would return the automatic nodeset even for
	the persistent config if the domain was running. This is incorrect since
	the automatic nodeset will be re-queried upon starting the vm.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1445325

2017-04-27  Michal Privoznik  <mprivozn@redhat.com>

	lib: Fix c99 style comments
	We prefer c89 style of comments.

2017-04-27  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Properly reset non-p2p migration
	While peer-to-peer migration enters the Confirm phase even if the
	Perform phase fails, the client which initiated a non-p2p migration will
	never call virDomainMigrateConfirm* API if the Perform phase failed.
	Thus we need to explicitly reset migration before reporting a failure
	from the Perform phase API.

	https://bugzilla.redhat.com/show_bug.cgi?id=1425003

2017-04-27  Wang King  <king.wang@huawei.com>

	util: Drop unused var @errbuf from virPCIGetDeviceAddressFromSysfsLink
	Commit @a7035662 forgot to remove it when doing a refactor.

2017-04-27  Jiri Denemark  <jdenemar@redhat.com>

	locking: Add support for sanlock_strerror
	The recently added sanlock_strerror function can be used to translate
	sanlock's numeric errors into human readable strings.

	https://bugzilla.redhat.com/show_bug.cgi?id=1409511

2017-04-27  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Ignore missing query-migrate-parameters
	Migration with old QEMU which does not support query-migrate-parameters
	would fail because the QMP command is called unconditionally since the
	introduction of TLS migration. Previously it was only called if the user
	explicitly requested a feature which uses QEMU migration parameters. And
	even then the situation was not ideal, instead of reporting an
	unsupported feature we'd just complain about missing QMP command.

	Trivially no migration parameters are supported when
	query-migrate-parameters QMP command is missing. There's no need to
	report an error if it is missing, the callers will report better error
	if needed.

	https://bugzilla.redhat.com/show_bug.cgi?id=1441934

2017-04-27  Pavel Hrdina  <phrdina@redhat.com>

	tests: update QEMU 2.9.0 caps data to final version

2017-04-27  John Ferlan  <jferlan@redhat.com>

	secret: Generate configDir during driver initialization
	Rather than waiting for the first save to fail, let's generate the
	directory with the correct privs during initialization.

	secret: Combine virSecretObjListAdd with Locked function
	There's no need to separate, so just have one.

	secret: Split apart NumOfSecrets and GetUUIDs callback function
	Rather than overloading one function - split apart the logic to have
	separate interfaces and local/private structures to manage the data
	for which the helper is collecting.

	secret: Rename 'filter' to 'aclfilter'
	Makes it a bit more clear what it is.

	secret: Change variable names for list traversals
	Rather than 'nuuids' it should be 'maxuuids' and rather than 'got'
	it should be 'nuuids'.  Alter the logic of the list traversal to
	utilize those names.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	secret: Alter cleanup path for virSecretObjListGetUUIDs
	Rather than using "ret = -1" and cleanup processing, alter the return
	path on failure to goto error and then just return the data.got.

	In the error path, we no longer check for ret < 0, we just can free
	anything added to the array and return -1 directly.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	secret: Use virSecretDefPtr rather than deref from virSecretObjPtr
	Rather than dereferencing obj->def->X, create a local 'def' variable
	that will dereference the def and use directly.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	secret: Use consistent naming for variables
	When processing a virSecretPtr use 'secret' as a variable name.

	When processing a virSecretObjPtr use 'obj' as a variable name.

	When processing a virSecretDefPtr use 'def' as a variable name,
	unless a distinction needs to be made with a 'newdef' such as
	virSecretObjListAddLocked (which also used the VIR_STEAL_PTR macro
	for the configFile and base64File).

2017-04-27  John Ferlan  <jferlan@redhat.com>

	secret: Add NULL obj check to virSecretObjListRemove
	Rather than have the caller check if !obj before calling, just check
	in the function for !obj and return.

	secret: Make some virSecretObj* functions static
	Make various virSecretObjList*Locked functions static and make
	virSecretObjNew static since they're only called within virtsecretobj.c.

	nwfilter: Move save of config until after successful assign
	Only save the config when using a generated UUID if we were able to
	create an object for the def. There could have been "other reasons"
	for the assignment to fail, so saving the config could be incorrect.

	nwfilter: Move creation of configDir to driver initialization
	Rather than "wait" for the first config file to be created, force creation
	of the configDir during driver state initialization.

	nwfilter: Replace virNWFilterSaveDef with virNWFilterSaveConfig
	Essentially virNWFilterSaveDef executed in a different order the same
	sequence of calls, so let's just make one point of reference.

	nwfilter: Replace virNWFilterConfigFile with virFileBuildPath
	Remove open coded helper.

	nwfilter: Make a common UUID lookup function from driver
	Rather than separate calls, use a common call and generate a better
	error message which includes the incorrect uuidstr.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Make _virNWFilterObjList private
	Move from virnwfilterobj.h to virnwfilterobj.c.

	Create the virNWFilterObjListNew() API in order to allocate.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Rename some virNWFilterObj* API's
	Prefix should have been virNWFilterObjList since the API is operating on
	the list of filters.

	nwfilter: Introduce virNWFilterObjNew
	Perform the object initialization in a helper rather than inline.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Make _virNWFilterObjPtr private
	Move the structure to virnwfilterobj.c and create necessary accessor API's
	for the various fields.

	Also make virNWFilterObjFree static since there's no external callers.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Convert wantRemoved to bool
	It is what it is anyway, so let's describe it that way too.

	nwfilter: Remove unused 'active' in virNWFilterObj
	It was only ever set to false, which is ironically the default.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Use virNWFilterDefPtr rather than deref virNWFilterObjPtr
	Rather than dereferencing obj->def->XXX or nwfilters->objs[i]->X
	create local virNWFilterObjPtr and virNWFilterDefPtr variables.

	Future adjustments will be privatizing the object more, so this just
	prepares the code for that reality.

2017-04-27  John Ferlan  <jferlan@redhat.com>

	nwfilter: Use consistent naming for variables
	When processing a virNWFilterPtr use 'nwfilter' as a variable name.

	When processing a virNWFilterObjPtr use 'obj' as a variable name.

2017-04-27  Cédric Bosdonnat  <cbosdonnat@suse.com>

	IPv6 route check: list devices only once
	If several RA routes are found for the same device, only list that
	device once in the error message.

2017-04-26  Ján Tomko  <jtomko@redhat.com>

	Use a separate buffer for <filesystem><driver>
	Format the attributes in a separate buffer and only
	print the element if it's not empty.

	Use a separate buffer for <controller><driver>
	Make adding new attributes easier.

	Use a separate buffer for <disk><driver>
	Eliminate the big condition at the start.
	Instead use a buffer and only format the element if the buffer
	is non-empty.

	Use a separate buffer for <input> subelements
	Instead of figuring out upfront whether <input> will be a single
	or a pair element, format the subelements into a separate buffer
	and close <input/> early if this buffer is empty.

2017-04-26  Erik Skultety  <eskultet@redhat.com>

	docs: Provide a nodedev driver stub documentation
	There's lot more to document about the nodedev driver, besides PCI and
	SR-IOV (even this might need to be extended), but let's start small-ish
	and at least have a page for it linked from the drivers.html.

2017-04-26  John Ferlan  <jferlan@redhat.com>

	disk: Use virStorageBackendZeroPartitionTable
	https://bugzilla.redhat.com/show_bug.cgi?id=1439132

	During 'matrix' testing of all possible combinations I found that if
	device is formated with "gpt" first, then an attempt is made to format
	using "mac", a startup will fail.

	Deeper analysis by Peter Krempa indicates that the "mac" table fits
	into the first block on the disk. Since the GPT disklabel is stored
	at LBA address 1 it is not overwritten at all. Thus it's apparent that
	the (blkid) detection tool then prefers GPT over a older disklabel.

	The GPT disklabel has also a secondary copy at the last LBA of the disk.

	So, follow the same logic as the logical pool in clearing a 1MB swath
	at the beginning and end of the device to avoid potential issues with
	larger sector sizes for the device.

	Also fixed a minor formatting nit in virStorageBackendDeviceIsEmpty call.

2017-04-26  John Ferlan  <jferlan@redhat.com>

	logical: Increase the size of the data to wipe
	Since a sector size may be larger than 512 bytes, let's just increase
	the size to wipe to 1MB rather than 2KB

	logical: Use virStorageBackendZeroPartitionTable
	Rather than open code it, use the new function which uses the wipe algorithm
	in order to zero the front and tail of the partition.

	storage: Introduce virStorageBackendZeroPartitionTable
	Create a wrapper/helper that can be used to call the storage backend
	wipe helper - storageBackendVolWipeLocalFile for future use by logical
	and disk backends to clear out the partition table rather than having
	each open code the same algorithm.

2017-04-26  John Ferlan  <jferlan@redhat.com>

	storage: Modify storageBackendWipeLocal to allow zero from end of device
	Add bool 'zero_end' and logic that would allow a caller to wipe specific
	portions of a target device either from the beginning (the default) or
	from the end when zero_end is true.

	This will allow for this code to wipe out partition table information
	from a device.

2017-04-26  Daniel P. Berrange  <berrange@redhat.com>

	Update keycodemapdb submodule for python2 compat fixes
	There were a few bugs in keycodemap tool that broke it
	when run on python circa 2.7.5 or older, which affected
	RHEL builds.

	Add ability to generate man page describing key code names & values

2017-04-26  Daniel P. Berrange  <berrange@redhat.com>

	util: switch over to use keycodemapdb GIT submodule
	A long time ago we imported the keymaps.csv file from GTK-VNC so we
	can do conversions between keycode sets. Meanwhile lots of bug fixes
	have gone into this CSV file and libvirt hasn't kept in sync. The
	keymaps.csv file and associated generator script has been pulled out
	of GTK-VNC into a dedicated GIT repo for use as a submodule. This
	allows GTK-VNC, SPICE-GTK, QEMU and libvirt to share the same master
	database and tools and pushing updates merely requires a submodule
	commit update as with gnulib.

	The test suite is updated to cover some extra boundary conditions.

2017-04-26  John Ferlan  <jferlan@redhat.com>

	secret: Clean up virSecretObjListExport logic
	Shorten the time needed to keep the list lock and alter the cleanup
	path to be more of an error path.

	Utilize the the virObjectListFree function to handle the calls for
	virObjectUnref on each list element and the VIR_FREE of the list
	instead of open coding it.

	Change the name of the virHashForEach callback to match the name
	of the Export function with the Callback added onto it.

2017-04-26  John Ferlan  <jferlan@redhat.com>

	secret: Have virSecretObjNew return locked object
	Rather than have caller need to do it, have the object returned locked.

	secret: Convert virsecretobjs.h to use "newer" formatting style
	Alter the prototypes to use the newer formatting style

	secret: Need to set data->error on VIR_ALLOC_N failure
	Commit id 'bb1fba629' neglected to set when creating the function.

2017-04-25  John Ferlan  <jferlan@redhat.com>

	test: Remove unnecessary unlocks in cleanup paths
	Commit id '865f479da' altered the logic to use a common test*ObjFindByName
	helpers which would lock/unlock the test driver; however, a few cleanup paths
	in that cleanup missed removing the Unlock, so remove it now.

2017-04-25  John Ferlan  <jferlan@redhat.com>

	remote: Fix possible use-after-free when sending event message
	Based upon an idea and some research by Wang King <king.wang@huawei.com>
	and xinhua.Cao <caoxinhua@huawei.com>.

	Since we're assigning the 'client' to our callback event lookaside list,
	it's imperative that we grab a reference to the object; otherwise, when
	the object is unref'd during virNetServerProcessClients when it's determined
	that the virNetServerClientIsClosed and the memory is free'd before perhaps
	the object event state callbacks are run.  When a virObjectLock() is run,
	before sending the message the following trace occurs;

	    #0  0x00007fda223d66d8 in virClassIsDerivedFrom
	        (klass=0xdeadbeef, parent=0x7fda24c81b40)
	         at util/virobject.c:169
	    #1  0x00007fda223d6a1e in virObjectIsClass
	        (anyobj=anyobj@entry=0x7fd9e575b400, klass=<optimized out>)
	         at util/virobject.c:365
	    #2  0x00007fda223d6a44 in virObjectLock
	        (anyobj=0x7fd9e575b400)
	        at util/virobject.c:317
	    #3  0x00007fda22507f71 in virNetServerClientSendMessage
	        (client=client@entry=0x7fd9e575b400, msg=msg@entry=0x7fd9ec30de90)
	        at rpc/virnetserverclient.c:1422
	    #4  0x00007fda230d714d in remoteDispatchObjectEventSend
	        (client=0x7fd9e575b400, program=0x7fda24c844e0, procnr=348,
	         proc=0x7fda2310e5e0 <xdr_remote_domain_event_callback_tunable_msg>,
	         data=0x7ffc3857fdb0)
	        at remote.c:3803
	    #5  0x00007fda230dd71b in remoteRelayDomainEventTunable
	        (conn=<optimized out>, dom=0x7fda27cd7660, params=0x7fda27f3aae0,
	         nparams=1,opaque=0x7fd9e6c99e00)
	        at remote.c:1033
	    #6  0x00007fda224484cb in virDomainEventDispatchDefaultFunc
	        (conn=0x7fda27cd0120, event=0x7fda2736ea00, cb=0x7fda230dd610
	         <remoteRelayDomainEventTunable>, cbopaque=0x7fd9e6c99e00)
	        at conf/domain_event.c:1910
	    #7  0x00007fda22446871 in virObjectEventStateDispatchCallbacks
	        (callbacks=<optimized out>, callbacks=<optimized out>,
	         event=0x7fda2736ea00,state=0x7fda24ca3960)
	        at conf/object_event.c:722
	    #8  virObjectEventStateQueueDispatch
	        (callbacks=0x7fda24c65800, queue=0x7ffc3857fe90, state=0x7fda24ca3960)
	        at conf/object_event.c:736
	    #9  virObjectEventStateFlush (state=0x7fda24ca3960)
	        at conf/object_event.c:814
	    #10 virObjectEventTimer (timer=<optimized out>, opaque=0x7fda24ca3960)
	        at conf/object_event.c:560
	    #11 0x00007fda223ae8b9 in virEventPollDispatchTimeouts ()
	        at util/vireventpoll.c:458
	    #12 virEventPollRunOnce ()
	        at util/vireventpoll.c:654
	    #13 0x00007fda223ad1d2 in virEventRunDefaultImpl ()
	        at util/virevent.c:314
	    #14 0x00007fda225046cd in virNetDaemonRun (dmn=0x7fda24c775c0)
	        at rpc/virnetdaemon.c:818
	    #15 0x00007fda230d6351 in main (argc=<optimized out>, argv=<optimized out>)
	        at libvirtd.c:1623

2017-04-25  John Ferlan  <jferlan@redhat.com>

	daemon: Rework remoteClientFreeFunc cleanup loops into C macro
	Rather than 'n' repetitive code segments, let's create a single macro
	which will make the code easier to read.

2017-04-25  Wang King  <king.wang@huawei.com>

	daemon: Remove unnecessary goto error
	Freeing the dst is unnecessary if the VIR_STRDUP fails, and therefore
	we need to remove the error label as well.

	daemon: Fix domain name leak in error path
	Domain name is duplicated in make_nonnull_domain, but not freed when
	virTypedParamsSerialize returns error.

2017-04-25  ZhiPeng Lu  <lu.zhipeng@zte.com.cn>

	qemu: fix argument of virDomainNetGetActualDirectMode
	it should be a comparison of modes between new and old devices. So
	the argument of the second virDomainNetGetActualDirectMode should be
	newdev.

2017-04-25  Andrea Bolognani  <abologna@redhat.com>

	autogen.sh: Improve and generalize
	The goal is twofold: firstly, we want to extend the script so
	that it can deal with more than a single git submodule, and
	secondly we'd like to reduce the amount of duplicated code.
	Moreover, since we're making heavy changes to the code anyway,
	we might as well make sure it follows a somewhat consistent
	coding style too.

	To reduce code duplication, we introduce a new --dry-run
	option, which can be used by third parties to figure out
	whether calling autogen.sh is necessary or not: this allows
	us to get rid of the reimplementation of part of the logic
	in cfg.mk and guarantee they'll never get out of sync.

	Other changes include: making dirty submodules checking and
	cleaning entirely independent of other operations; removing
	the use of 'set -e' and handling errors explicitly instead;
	better parsing of command line arguments.

2017-04-24  Yuri Chornoivan  <yurchor@ukr.net>

	Fix minor typos

2017-04-24  Roman Bogorodskiy  <bogorodskiy@gmail.com>

	util: relax virNetDevSetCoalesce() stub
	Currently, virNetDevSetCoalesce() stub is always returning error. As
	it's used by virNetDevTapCreateInBridgePort(), it essentially breaks
	bridged networking if coalesce is not supported.

	To make it work, relax the stub to trigger error only when its
	coalesce argument is not NULL, otherwise report success.

2017-04-24  Erik Skultety  <eskultet@redhat.com>

	docs: Utilize our XSLT list generating template more
	Since we do have this template at hand, why not using it wherever
	possible (list of supported pool types and remote access section).
	Also, perform some stylistic micro adjustments.

	nodedev: udevProcessPCI: Drop syspath variable
	Since we have that information provided by @def which is not a private
	object, there is really no need for the variable.

	conf: nodedev: Split virNodeDeviceDefFormat into more functions
	Make the code look cleaner by moving the capability specific bits into
	separate functions.

	nodedev: Make use of the compile-time missing enum in switch error
	So udevGetDeviceDetails was one those functions using an enum in a
	switch, but since it had a 'default' case, compiler didn't warn about an
	unhandled enum. Moreover, the error about an unsupported device type
	reported in the default case is unnecessary, since by the time we get
	there, udevGetDeviceType (which was called before) already made sure
	that any unrecognized device types had been handled properly.

2017-04-24  Yi Wang  <wang.yi59@zte.com.cn>

	rpc: fix keep alive timer segfault
	ka maybe have been freeed in virObjectUnref, application using
	virKeepAliveTimer will segfault when unlock ka. We should keep
	ka's refs positive before using it.

	#0  0x00007fd8f79970e8 in virClassIsDerivedFrom (klass=0xdeadbeef, parent=0x7fd8e8001b80) at util/virobject.c:169
	#1  0x00007fd8f799742e in virObjectIsClass (anyobj=anyobj entry=0x7fd8e800b9c0, klass=＜optimized out＞) at util/virobject.c:365
	#2  0x00007fd8f79974e4 in virObjectUnlock (anyobj=0x7fd8e800b9c0) at util/virobject.c:338
	#3  0x00007fd8f7ac477e in virKeepAliveTimer (timer=＜optimized out＞, opaque=0x7fd8e800b9c0) at rpc/virkeepalive.c:177
	#4  0x00007fd8f7e5c9cf in libvirt_virEventInvokeTimeoutCallback () from /usr/lib64/python2.7/site-packages/libvirtmod.so
	#5  0x00007fd8ff64db94 in PyEval_EvalFrameEx () from /lib64/libpython2.7.so.1.0
	#6  0x00007fd8ff64f1ad in PyEval_EvalCodeEx () from /lib64/libpython2.7.so.1.0
	#7  0x00007fd8ff64d85f in PyEval_EvalFrameEx () from /lib64/libpython2.7.so.1.0
	#8  0x00007fd8ff64d950 in PyEval_EvalFrameEx () from /lib64/libpython2.7.so.1.0
	#9  0x00007fd8ff64d950 in PyEval_EvalFrameEx () from /lib64/libpython2.7.so.1.0
	#10 0x00007fd8ff64f1ad in PyEval_EvalCodeEx () from /lib64/libpython2.7.so.1.0
	#11 0x00007fd8ff5dc098 in function_call () from /lib64/libpython2.7.so.1.0
	#12 0x00007fd8ff5b7073 in PyObject_Call () from /lib64/libpython2.7.so.1.0
	#13 0x00007fd8ff5c6085 in instancemethod_call () from /lib64/libpython2.7.so.1.0
	#14 0x00007fd8ff5b7073 in PyObject_Call () from /lib64/libpython2.7.so.1.0
	#15 0x00007fd8ff648ff7 in PyEval_CallObjectWithKeywords () from /lib64/libpython2.7.so.1.0
	#16 0x00007fd8ff67d7e2 in t_bootstrap () from /lib64/libpython2.7.so.1.0
	#17 0x00007fd8ff358df3 in start_thread () from /lib64/libpthread.so.0
	#18 0x00007fd8fe97d3ed in clone () from /lib64/libc.so.6

2017-04-23  Martin Kletzander  <mkletzan@redhat.com>

	Remove pointless check for !ret in virDomainNetDefCoalesceParseXML
	It was left there after removing a macro it was part of in first
	version or so.  Now it will always be NULL.

	Don't leak str in virDomainNetDefCoalesceParseXML

2017-04-21  Laine Stump  <laine@redhat.com>

	util: allow ignoring SIOCSIFHWADDR when errno is EPERM
	Commit f4ef3a71 made a variation of virNetDevSetMAC that would return
	without logging an error message if errno was set to
	EADDRNOTAVAIL. This errno is set by some SRIOV VF drivers (in
	particular igbvf) when they fail to set the device's MAC address due
	to the PF driver refusing the request. This is useful if we want to
	try a different method of setting the VF MAC address before giving up
	(Commit 86556e16 actually does this, setting the desired MAC address
	to the "admin MAC in the PF, then detaching and reattaching the VF
	netdev driver to force a reinit of the MAC address).

	During testing of Bug 1442040 t was discovered that the ixgbe driver
	returns EPERM in this situation, so this patch changes the exception
	case for silent+non-terminal failure to account for this difference.

	Completes resolution to: https://bugzilla.redhat.com/1415609 (RHEL 7.4)
	                         https://bugzilla.redhat.com/1442040 (RHEL 7.3.z)

2017-04-21  Daniel P. Berrange  <berrange@redhat.com>

	util: fix virNetDevSetCoalesce fallback on Win32/FreeBSD
	The current fallback stub for virNetDevSetCoalesce is inside an
	earlier conditional block. This deals with the feature being
	missing on older Linux platforms. We need a second fallback stub
	though, outside the top level conditional, to ensure builds work
	on Win32/FreeBSD platforms too.

	docs: fix typo in closing HTML element

2017-04-21  Martin Kletzander  <mkletzan@redhat.com>

	Set coalesce settings for domain interfaces
	This patch makes use of the virNetDevSetCoalesce() function to make
	appropriate settings effective for devices that support them.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1414627

2017-04-21  Martin Kletzander  <mkletzan@redhat.com>

	conf, docs: Add support for coalesce setting(s)
	We are currently parsing only rx/frames/max because that's the only
	value that makes sense for us.  The tun device just added support for
	this one and the others are only supported by hardware devices which
	we don't need to worry about as the only way we'd pass those to the
	domain is using <hostdev/> or <interface type='hostdev'/>.  And in
	those cases the guest can modify the settings itself.

	util: Add virNetDevSetCoalesce function
	That function is able to configure coalesce settings for an interface,
	similarly to 'ethtool -C'.  This function also updates back the
	structure so that it contains actual data on the device (if the device
	doesn't support some settings kernel might just return 0 and not set
	whatever is not supported), so this way we'll have up-to-date
	information in the live domain XML.

2017-04-21  Pavel Hrdina  <phrdina@redhat.com>

	util: check ifa_addr pointer before accessing its elements
	Reported by Rafał Wojciechowski <it@rafalwojciechowski.pl>.

	Thread 1 (Thread 0x7f194b99d700 (LWP 5631)):
	0  virNetDevGetifaddrsAddress (addr=0x7f194b99c7c0, ifname=0x7f193400e2b0 "ovirtmgmt") at util/virnetdevip.c:738
	1  virNetDevIPAddrGet (ifname=0x7f193400e2b0 "ovirtmgmt", addr=addr@entry=0x7f194b99c7c0) at util/virnetdevip.c:795
	2  0x00007f19467800d6 in networkGetNetworkAddress (netname=<optimized out>, netaddr=netaddr@entry=0x7f1924013f18) at network/bridge_driver.c:4780
	3  0x00007f193e43a33c in qemuProcessGraphicsSetupNetworkAddress (listenAddr=0x7f19340f7650 "127.0.0.1", glisten=0x7f1924013f10) at qemu/qemu_process.c:4062
	4  qemuProcessGraphicsSetupListen (vm=<optimized out>, graphics=0x7f1924014f10, cfg=0x7f1934119f00) at qemu/qemu_process.c:4133
	5  qemuProcessSetupGraphics (flags=17, vm=0x7f19240155d0, driver=0x7f193411f1d0) at qemu/qemu_process.c:4196
	6  qemuProcessPrepareDomain (conn=conn@entry=0x7f192c00ab50, driver=driver@entry=0x7f193411f1d0, vm=vm@entry=0x7f19240155d0, flags=flags@entry=17) at qemu/qemu_process.c:4969
	7  0x00007f193e4417c0 in qemuProcessStart (conn=conn@entry=0x7f192c00ab50, driver=driver@entry=0x7f193411f1d0, vm=0x7f19240155d0,asyncJob=asyncJob@entry=QEMU_ASYNC_JOB_START, migrateFrom=migrateFrom@entry=0x0, migrateFd=migrateFd@entry=-1, migratePath=migratePath@entry=0x0,snapshot=snapshot@entry=0x0, vmop=vmop@entry=VIR_NETDEV_VPORT_PROFILE_OP_CREATE, flags=17, flags@entry=1) at qemu/qemu_process.c:5553

	Man page for getifaddrs also states that the "ifa_addr" may contain
	a null pointer which happens if there is an existing network interface
	on the host without IP address.

2017-04-20  Jim Fehlig  <jfehlig@suse.com>

	Increase default task limit for libvirtd
	libvirtd can spawn threads/tasks when creating new domains for
	some hypervisors such as Xen's libxl driver, quickly reaching
	the cgroups pids controller default TasksMax setting of 512. When
	the limit is reached, attempting to create additional domains
	results in an error from the cgroups pids controller, e.g.

	kernel: [71282.213347] cgroup: fork rejected by pids controller in
	/system.slice/libvirtd.service

	Depending on domain type and configuration, anywhere from 4-7
	threads/tasks may be created by libxl when starting a domain.
	In order to support 4096 domains, similar to commit 27cd763500,
	increase the TasksMax setting in libvirtd.service to
	4096 * 8 = 32768 tasks.

2017-04-20  Daniel P. Berrange  <berrange@redhat.com>

	Fix error reporting when poll returns POLLHUP/POLLERR
	In the RPC client event loop code, if poll() returns only a POLLHUP
	or POLLERR status, then we end up reporting a bogus error message:

	  error: failed to connect to the hypervisor
	  error: An error occurred, but the cause is unknown

	We do actually report an error, but we virNetClientMarkClose method
	has already captured the error status before we report it, so the
	real error gets thrown away. The key fix is to report the error
	before calling virNetClientMarkClose(). In changing this, we also
	split out reporting of POLLHUP vs POLLERR to make any future bugs
	easier to diagnose.

2017-04-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: hotplug: Don't save status XML when monitor is closed
	In the vcpu hotplug code if exit from the monitor failed we would still
	attempt to save the status XML. When the daemon is terminated the
	monitor socket is closed. In such case, the written status XML would not
	contain the monitor path and thus be invalid.

	Avoid this issue by only saving status XML on success of the monitor
	command.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1439452

2017-04-20  Peter Krempa  <pkrempa@redhat.com>

	qemu: hotplug: Unexport qemuDomainHotplugDelVcpu
	The function is used only in the hotplug module.

2017-04-20  Pavel Hrdina  <phrdina@redhat.com>

	qemu_domain: use correct default USB controller on ppc64
	The history of USB controller for ppc64 guest is complex and goes
	back to libvirt 1.3.1 where the fun started.

	Prior Libvirt 1.3.1 if no model for USB controller was specified
	we've simply passed "-usb" on QEMU command line.

	Since Libvirt 1.3.1 there is a patch (8156493d8db) that fixes this
	issue by using "-device pci-ohci,..." but it breaks migration with
	older Libvirts which was agreed that's acceptable.  However this
	patch didn't reflect this change in the domain XML and the model
	was still missing.

	Since Libvirt 2.2.0 there is a patch (f55eaccb0c5) that fixes the
	issue with not setting the USB model into domain XML which we need
	to know about to not break the migration and since the default
	model was *pci-ohci* it was used as default in this patch as well.

	This patch tries to take all the previous changes into account and
	also change the default for newly defined domains that don't specify
	any model for USB controller.

	The VIR_DOMAIN_DEF_PARSE_ABI_UPDATE is set only if new domain is
	defined or new device is added into a domain which means that in
	all other cases we will use the old *pci-ohci* model instead of the
	better and not broken *nec-usb-xhci* model.

	Resolves: https://bugzilla.redhat.com/show_bug.cgi?id=1373184

2017-04-20  Pavel Hrdina  <phrdina@redhat.com>

	conf: add a new parse flag VIR_DOMAIN_DEF_PARSE_ABI_UPDATE_MIGRATION
	So far there is probably no change that is allowed to be done
	by the VIR_DOMAIN_DEF_PARSE_ABI_UPDATE flag that would break
	guest ABI but this may change in the future.

	This introduces new VIR_DOMAIN_DEF_PARSE_ABI_UPDATE_MIGRATION
	which should be used only for ABI updates that are "safe" for
	persistent migration.

2017-04-19  Daniel P. Berrange  <berrange@redhat.com>

	Refresh translations from zanata

2017-04-19  Jiri Denemark  <jdenemar@redhat.com>

	qemu: Use more data for comparing CPUs
	With QEMU older than 2.9.0 libvirt uses CPUID instruction to determine
	what CPU features are supported on the host. This was later used when
	checking compatibility of guest CPUs. Since QEMU 2.9.0 we ask QEMU for
	the host CPU data. But the two methods we use usually provide disjoint
	sets of CPU features because QEMU/KVM does not support all features
	provided by the host CPU and on the other hand it can enable some
	feature even if the host CPU does not support them.

	So if there is a domain which requires a CPU features disabled by
	QEMU/KVM, libvirt will refuse to start it with QEMU > 2.9.0 as its guest
	CPU is incompatible with the host CPU data we got from QEMU. But such
	domain would happily start on older QEMU (of course, the features would
	be missing the guest CPU). To fix this regression, we need to combine
	both CPU feature sets when checking guest CPU compatibility.

	https://bugzilla.redhat.com/show_bug.cgi?id=1439933

2017-04-19  Jiri Denemark  <jdenemar@redhat.com>

	cpu: Introduce virCPUGetHostIsSupported
	Sometimes we want to call virCPUGetHost only when it is implemented for
	a given architecture to avoid logging expected and possibly misleading
	errors. The new virCPUGetHostIsSupported API may be used to guard such
	calls to virCPUGetHost.

	cpu: Drop feature filtering from virCPUUpdate
	Because of the changes done in the previous commit, @host is already a
	migratable CPU and there's no need to do any additional filtering.

	qemu: Pass migratable host CPU model to virCPUUpdate
	We already know from QEMU which CPU features will block migration. Let's
	use this information to make a migratable copy of the host CPU model and
	use it for updating guest CPU specification. This will allow us to drop
	feature filtering from virCPUUpdate where it was just a hack.

	qemu: Prepare qemuCaps for multiple host CPU defs
	Soon we will need to store multiple host CPU definitions in
	virQEMUCapsHostCPUData and qemuCaps users will want to request the one
	they need. This patch introduces virQEMUCapsHostCPUType enum which will
	be used for specifying the requested CPU definition.

	qemu: Move qemuCaps host CPU data in a struct
	We need to store several CPU related data structure for both KVM and
	TCG. So instead of keeping two different copies of everything let's
	make a virQEMUCapsHostCPUData struct and use it twice.

	qemu: Introduce virQEMUCapsHostCPUDataClear
	To keep freeing of host CPU data in one place.

	qemu: Move qemuCaps CPU data copying into a separate function
	This introduces virQEMUCapsHostCPUDataCopy which will later be
	refactored a bit and called twice from virQEMUCapsNewCopy.

	qemu: Introduce virQEMUCapsSetHostModel
	A simple helper as a complement to virQEMUCapsGetHostModel.

2017-04-19  Daniel P. Berrange  <berrange@redhat.com>

	virt-storage-rbd: fix typo s/RDB/RBD/ in configure check

	virsh: report errors in virshInit()
	There are several functions in virshInit which can fail, especially
	when running win32 builds under WINE. Currently virsh just exits
	without reporting what error happened.

2017-04-19  Daniel P. Berrange  <berrange@redhat.com>

	Add travis build configuration
	This travis configuration tests libvirt builds on 5 platforms that we don't
	exercise in the CentOS CI system.

	  - Ubuntu Trusty with GCC
	  - Ubuntu Trusty with CLang
	  - Ubuntu Precise with GCC
	  - Ubuntu Precise with CLang
	  - OS-X with CLang

	NB, syntax-check fails on OS-X with errors like:

	   /bin/sh: /usr/bin/grep: Argument list too long

	Presumably their grep impl isn't as good as the GNU one, so this test
	config skips syntax-check on OS-X for now.

2017-04-19  Daniel P. Berrange  <berrange@redhat.com>

	Ignore SASL deprecation warnings on OS-X
	Apple have annotated all SASL functions as deprecated for
	unknown reasons. Since they still work, lets just ignore
	the warnings. If Apple finally delete the SASL functions
	our configure check should already catch that

	Fix detection of required RBD version
	If building libvirt against Ubuntu precise, the librbd.h is lacking
	many functions that libvirt expects. We have no version check, so
	we were enabling RBD even though it cannot compile. This configure
	check uses existance of 'rbd_get_features' as an identifier for the
	min required version.

	Prevent test failures with ebtables/iptables/ip6tables are missing
	When running tests in a restricted container (as opposed to a full
	OS install), we can't assume ebtables/iptbles/ip6tables are going
	to be installed. We must check this and mark the tests as skipped.

2017-04-19  Daniel P. Berrange  <berrange@redhat.com>

	annotate all mocked functions with noinline
	CLang's optimizer is more aggressive at inlining functions than
	gcc and so will often inline functions that our tests want to
	mock-override. This causes the test to fail in bizarre ways.

	We don't want to disable inlining completely, but we must at
	least prevent inlining of mocked functions. Fortunately there
	is a 'noinline' attribute that lets us control this per function.

	A syntax check rule is added that parses tests/*mock.c to extract
	the list of functions that are mocked (restricted to names starting
	with 'vir' prefix). It then checks that src/*.h header file to
	ensure it has a 'ATTRIBUTE_NOINLINE' annotation. This should prevent
	use from bit-rotting in future.

2017-04-19  Jiri Denemark  <jdenemar@redhat.com>

	spec: Avoid RPM verification errors on nwfilter XMLs
	/etc/libvirt/nwfilter/*.xml files are installed with no UUID, which
	means libvirtd will automatically alter all of them once it starts. Thus
	RPM verification will always fail on them. Let's use a trick similar to
	the default network XML and store nwfilter XMLs in /usr/share. They will
	be copied into /etc in %post. Additionally the /etc files are marked as
	%ghost so that they are uninstalled if the RPM package is removed.

	Note that the %post script overwrites existing files with new ones on
	upgrade, which is what has always been happening.

	https://bugzilla.redhat.com/show_bug.cgi?id=1431581
	https://bugzilla.redhat.com/show_bug.cgi?id=1378774

2017-04-19  John Ferlan  <jferlan@redhat.com>

	network: Use consistent function name prefixes for virnetworkobj
	Use "virNetworkObj" as a prefix for any external API in virnetworkobj.

	Also a couple of functions were local to virnetworkobj.c, so remove their
	external defs in virnetworkobj.h.

2017-04-19  John Ferlan  <jferlan@redhat.com>

	network: Rename virNetworkObjAssignDef to virNetworkObjUpdateAssignDef
	Rename the API to be a better description of what it does. Besides, a
	subsequent patch will rename virNetworkAssignDef to virNetworkObjAssignDef
	so rather than make that patch confusing we'll take the intermittent step
	in this patch.

	network: Alter coding style of network conf function prototypes
	In an effort to be consistent with the source module, alter the function
	prototypes to follow the similar style of source with the "type" on one
	line followed by the function name and arguments on subsequent lines with
	with argument getting it's own line.

	network: Adjust coding style for network conf sources
	Alter the format of the code to follow more recent style guidelines of
	two empty lines between functions, function decls with "[static] type"
	on one line followed by function name with arguments to functions each
	on one line.

2017-04-19  John Ferlan  <jferlan@redhat.com>

	network: Introduce virnetworkobj
	Move all the virNetworkObj related API/data structures into their own
	modules virnetworkobj.{c,h} from the network_conf.{c,h}

	Purely code motion at this point plus adjustments to cleanly build

2017-04-19  Dawid Zamirski  <dzamirski@datto.com>

	hyperv: recognize array property as distinct type.
